/* Generated by re2c 0.9.12 on Wed Nov 12 15:14:05 2008 */
/*
   +----------------------------------------------------------------------+
   | PHP Version 5                                                        |
   +----------------------------------------------------------------------+
   | Copyright (c) 1997-2006 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Authors: Derick Rethans <derick@derickrethans.nl>                    |
   +----------------------------------------------------------------------+
 */

/* $Id: parse_date.re,v 1.26.2.27 2006/04/11 18:03:52 derick Exp $ */

#include "timelib.h"

#include <stdio.h>
#include <ctype.h>

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif

#if defined(_MSC_VER)
# define strtoll(s, f, b) _atoi64(s)
#elif !defined(HAVE_STRTOLL)
# if defined(HAVE_ATOLL)
#  define strtoll(s, f, b) atoll(s)
# else
#  define strtoll(s, f, b) strtol(s, f, b)
# endif
#endif

#define TIMELIB_SECOND  1
#define TIMELIB_MINUTE  2
#define TIMELIB_HOUR    3
#define TIMELIB_DAY     4
#define TIMELIB_MONTH   5
#define TIMELIB_YEAR    6
#define TIMELIB_WEEKDAY 7
#define TIMELIB_SPECIAL 8

#define EOI      257
#define TIME     258
#define DATE     259

#define TIMELIB_XMLRPC_SOAP    260
#define TIMELIB_TIME12         261
#define TIMELIB_TIME24         262
#define TIMELIB_GNU_NOCOLON    263
#define TIMELIB_GNU_NOCOLON_TZ 264
#define TIMELIB_ISO_NOCOLON    265

#define TIMELIB_AMERICAN       266
#define TIMELIB_ISO_DATE       267
#define TIMELIB_DATE_FULL      268
#define TIMELIB_DATE_TEXT      269
#define TIMELIB_DATE_NOCOLON   270
#define TIMELIB_PG_YEARDAY     271
#define TIMELIB_PG_TEXT        272
#define TIMELIB_PG_REVERSE     273
#define TIMELIB_CLF            274
#define TIMELIB_DATE_NO_DAY    275
#define TIMELIB_SHORTDATE_WITH_TIME 276
#define TIMELIB_DATE_FULL_POINTED 277
#define TIMELIB_TIME24_WITH_ZONE 278
#define TIMELIB_ISO_WEEK       279

#define TIMELIB_TIMEZONE       300
#define TIMELIB_AGO            301

#define TIMELIB_RELATIVE       310

#define TIMELIB_ERROR          999

typedef unsigned char uchar;

#define   BSIZE	   8192

#define   YYCTYPE      uchar
#define   YYCURSOR     cursor
#define   YYLIMIT      s->lim
#define   YYMARKER     s->ptr
#define   YYFILL(n)    return EOI;

#define   RET(i)       {s->cur = cursor; return i;}

#define timelib_string_free free

#define TIMELIB_HAVE_TIME() { if (s->time->have_time) { add_error(s, "Double time specification"); timelib_string_free(str); return TIMELIB_ERROR; } else { s->time->have_time = 1; s->time->h = 0; s->time->i = 0; s->time->s = 0; s->time->f = 0; } }
#define TIMELIB_UNHAVE_TIME() { s->time->have_time = 0; s->time->h = 0; s->time->i = 0; s->time->s = 0; s->time->f = 0; }
#define TIMELIB_HAVE_DATE() { if (s->time->have_date) { add_error(s, "Double date specification"); timelib_string_free(str); return TIMELIB_ERROR; } else { s->time->have_date = 1; } }
#define TIMELIB_UNHAVE_DATE() { s->time->have_date = 0; s->time->d = 0; s->time->m = 0; s->time->y = 0; }
#define TIMELIB_HAVE_RELATIVE() { s->time->have_relative = 1; s->time->relative.weekday_behavior = 1; }
#define TIMELIB_HAVE_WEEKDAY_RELATIVE() { s->time->have_weekday_relative = 1; }
#define TIMELIB_HAVE_SPECIAL_RELATIVE() { s->time->have_special_relative = 1; }
#define TIMELIB_HAVE_TZ() { s->cur = cursor; if (s->time->have_zone) { add_warning(s, "Double timezone specification"); timelib_string_free(str); return TIMELIB_ERROR; } else { s->time->have_zone = 1; } }

#define TIMELIB_INIT  s->cur = cursor; str = timelib_string(s); ptr = str
#define TIMELIB_DEINIT timelib_string_free(str)
#define TIMELIB_ADJUST_RELATIVE_WEEKDAY() if (in->time.have_weekday_relative && (in.rel.d > 0)) { in.rel.d -= 7; }

#define TIMELIB_PROCESS_YEAR(x) { \
	if ((x) == -1) {         \
	/*	(x) = 0; */          \
	} else if ((x) < 100) {  \
		if ((x) < 70) {      \
			(x) += 2000;     \
		} else {             \
			(x) += 1900;     \
		}                    \
	}                        \
}

#ifdef DEBUG_PARSER
#define DEBUG_OUTPUT(s) printf("%s\n", s);
#define YYDEBUG(s,c) { if (s != -1) { printf("state: %d ", s); printf("[%c]\n", c); } }
#else
#define DEBUG_OUTPUT(s)
#define YYDEBUG(s,c)
#endif

#include "timelib_structs.h"

typedef struct timelib_elems {
	unsigned int   c; /* Number of elements */
	char         **v; /* Values */
} timelib_elems;

typedef struct Scanner {
	int           fd;
	uchar        *lim, *str, *ptr, *cur, *tok, *pos;
	unsigned int  line, len;
	struct timelib_error_container *errors;

	struct timelib_time *time;
	timelib_tzdb        *tzdb;
} Scanner;

typedef struct _timelib_lookup_table {
    const char *name;
    int         type;
    int         value;
} timelib_lookup_table;

typedef struct _timelib_relunit {
	const char *name;
	int         unit;
	int         multiplier;
} timelib_relunit;

#define HOUR(a) (int)(a * 60)

/* The timezone table. */
static timelib_tz_lookup_table timelib_timezone_lookup[] = {
#include "timezonemap.h"
	{ NULL, 0, 0, NULL },
};

static timelib_tz_lookup_table timelib_timezone_fallbackmap[] = {
#include "fallbackmap.h"
	{ NULL, 0, 0, NULL },
};

static timelib_tz_lookup_table timelib_timezone_utc[] = {
	{ "utc", 0, 0, "UTC" },
};

static timelib_relunit const timelib_relunit_lookup[] = {
	{ "sec",         TIMELIB_SECOND,  1 },
	{ "secs",        TIMELIB_SECOND,  1 },
	{ "second",      TIMELIB_SECOND,  1 },
	{ "seconds",     TIMELIB_SECOND,  1 },
	{ "min",         TIMELIB_MINUTE,  1 },
	{ "mins",        TIMELIB_MINUTE,  1 },
	{ "minute",      TIMELIB_MINUTE,  1 },
	{ "minutes",     TIMELIB_MINUTE,  1 },
	{ "hour",        TIMELIB_HOUR,    1 },
	{ "hours",       TIMELIB_HOUR,    1 },
	{ "day",         TIMELIB_DAY,     1 },
	{ "days",        TIMELIB_DAY,     1 },
	{ "week",        TIMELIB_DAY,     7 },
	{ "weeks",       TIMELIB_DAY,     7 },
	{ "fortnight",   TIMELIB_DAY,    14 },
	{ "fortnights",  TIMELIB_DAY,    14 },
	{ "forthnight",  TIMELIB_DAY,    14 },
	{ "forthnights", TIMELIB_DAY,    14 },
	{ "month",       TIMELIB_MONTH,   1 },
	{ "months",      TIMELIB_MONTH,   1 },
	{ "year",        TIMELIB_YEAR,    1 },
	{ "years",       TIMELIB_YEAR,    1 },

	{ "monday",      TIMELIB_WEEKDAY, 1 },
	{ "mon",         TIMELIB_WEEKDAY, 1 },
	{ "tuesday",     TIMELIB_WEEKDAY, 2 },
	{ "tue",         TIMELIB_WEEKDAY, 2 },
	{ "wednesday",   TIMELIB_WEEKDAY, 3 },
	{ "wed",         TIMELIB_WEEKDAY, 3 },
	{ "thursday",    TIMELIB_WEEKDAY, 4 },
	{ "thu",         TIMELIB_WEEKDAY, 4 },
	{ "friday",      TIMELIB_WEEKDAY, 5 },
	{ "fri",         TIMELIB_WEEKDAY, 5 },
	{ "saturday",    TIMELIB_WEEKDAY, 6 },
	{ "sat",         TIMELIB_WEEKDAY, 6 },
	{ "sunday",      TIMELIB_WEEKDAY, 0 },
	{ "sun",         TIMELIB_WEEKDAY, 0 },

	{ "weekday",     TIMELIB_SPECIAL, TIMELIB_SPECIAL_WEEKDAY },
	{ "weekdays",    TIMELIB_SPECIAL, TIMELIB_SPECIAL_WEEKDAY },
	{ NULL,          0,          0 }
};

/* The relative text table. */
static timelib_lookup_table const timelib_reltext_lookup[] = {
	{ "first",    0,  1 },
	{ "next",     0,  1 },
	{ "second",   0,  2 },
	{ "third",    0,  3 },
	{ "fourth",   0,  4 },
	{ "fifth",    0,  5 },
	{ "sixth",    0,  6 },
	{ "seventh",  0,  7 },
	{ "eight",    0,  8 },
	{ "ninth",    0,  9 },
	{ "tenth",    0, 10 },
	{ "eleventh", 0, 11 },
	{ "twelfth",  0, 12 },
	{ "last",     0, -1 },
	{ "previous", 0, -1 },
	{ "this",     1,  0 },
	{ NULL,       1,  0 }
};

/* The month table. */
static timelib_lookup_table const timelib_month_lookup[] = {
	{ "jan",  0,  1 },
	{ "feb",  0,  2 },
	{ "mar",  0,  3 },
	{ "apr",  0,  4 },
	{ "may",  0,  5 },
	{ "jun",  0,  6 },
	{ "jul",  0,  7 },
	{ "aug",  0,  8 },
	{ "sep",  0,  9 },
	{ "sept", 0,  9 },
	{ "oct",  0, 10 },
	{ "nov",  0, 11 },
	{ "dec",  0, 12 },
	{ "i",    0,  1 },
	{ "ii",   0,  2 },
	{ "iii",  0,  3 },
	{ "iv",   0,  4 },
	{ "v",    0,  5 },
	{ "vi",   0,  6 },
	{ "vii",  0,  7 },
	{ "viii", 0,  8 },
	{ "ix",   0,  9 },
	{ "x",    0, 10 },
	{ "xi",   0, 11 },
	{ "xii",  0, 12 },

	{ "january",   0,  1 },
	{ "february",  0,  2 },
	{ "march",     0,  3 },
	{ "april",     0,  4 },
	{ "may",       0,  5 },
	{ "june",      0,  6 },
	{ "july",      0,  7 },
	{ "august",    0,  8 },
	{ "september", 0,  9 },
	{ "october",   0, 10 },
	{ "november",  0, 11 },
	{ "december",  0, 12 },
	{  NULL,       0,  0 }
};

#if 0
static char* timelib_ltrim(char *s)
{
	char *ptr = s;
	while (ptr[0] == ' ' || ptr[0] == '\t') {
		ptr++;
	}
	return ptr;
}
#endif

#if 0
uchar *fill(Scanner *s, uchar *cursor){
	if(!s->eof){
		unsigned int cnt = s->tok - s->bot;
		if(cnt){
			memcpy(s->bot, s->tok, s->lim - s->tok);
			s->tok = s->bot;
			s->ptr -= cnt;
			cursor -= cnt;
			s->pos -= cnt;
			s->lim -= cnt;
		}
		if((s->top - s->lim) < BSIZE){
			uchar *buf = (uchar*) malloc(((s->lim - s->bot) + BSIZE)*sizeof(uchar));
			memcpy(buf, s->tok, s->lim - s->tok);
			s->tok = buf;
			s->ptr = &buf[s->ptr - s->bot];
			cursor = &buf[cursor - s->bot];
			s->pos = &buf[s->pos - s->bot];
			s->lim = &buf[s->lim - s->bot];
			s->top = &s->lim[BSIZE];
			free(s->bot);
			s->bot = buf;
		}
		if((cnt = read(s->fd, (char*) s->lim, BSIZE)) != BSIZE){
			s->eof = &s->lim[cnt]; *(s->eof)++ = '\n';
		}
		s->lim += cnt;
	}
	return cursor;
}
#endif

static void add_warning(Scanner *s, char *error)
{
	s->errors->warning_count++;
	s->errors->warning_messages = realloc(s->errors->warning_messages, s->errors->warning_count * sizeof(timelib_error_message));
	s->errors->warning_messages[s->errors->warning_count - 1].position = s->tok ? s->tok - s->str : 0;
	s->errors->warning_messages[s->errors->warning_count - 1].character = s->tok ? *s->tok : 0;
	s->errors->warning_messages[s->errors->warning_count - 1].message = strdup(error);
}

static void add_error(Scanner *s, char *error)
{
	s->errors->error_count++;
	s->errors->error_messages = realloc(s->errors->error_messages, s->errors->error_count * sizeof(timelib_error_message));
	s->errors->error_messages[s->errors->error_count - 1].position = s->tok ? s->tok - s->str : 0;
	s->errors->error_messages[s->errors->error_count - 1].character = s->tok ? *s->tok : 0;
	s->errors->error_messages[s->errors->error_count - 1].message = strdup(error);
}

static timelib_sll timelib_meridian(char **ptr, timelib_sll h)
{
	timelib_sll retval = 0;

	while (!strchr("AaPp", **ptr)) {
		++*ptr;
	}
	if (**ptr == 'a' || **ptr == 'A') {
		if (h == 12) {
			retval = -12;
		}
	} else if (h != 12) {
		retval = 12;
	}
	++*ptr;
	if (**ptr == '.') {
		*ptr += 3;
	} else {
		++*ptr;
	}
	return retval;
}

static char *timelib_string(Scanner *s)
{
	char *tmp = calloc(1, s->cur - s->tok + 1);
	memcpy(tmp, s->tok, s->cur - s->tok);

	return tmp;
}

static timelib_sll timelib_get_nr(char **ptr, int max_length)
{
	char *begin, *end, *str;
	timelib_sll tmp_nr = -1;
	int len = 0;

	while ((**ptr < '0') || (**ptr > '9')) {
		if (**ptr == '\0') {
			return -1;
		}
		++*ptr;
	}
	begin = *ptr;
	while ((**ptr >= '0') && (**ptr <= '9') && len < max_length) {
		++*ptr;
		++len;
	}
	end = *ptr;
	str = calloc(1, end - begin + 1);
	memcpy(str, begin, end - begin);
	tmp_nr = strtoll(str, NULL, 10);
	free(str);
	return tmp_nr;
}

static void timelib_skip_day_suffix(char **ptr)
{
	if (isspace(**ptr)) {
		return;
	}
	if (!strncasecmp(*ptr, "nd", 2) || !strncasecmp(*ptr, "rd", 2) ||!strncasecmp(*ptr, "st", 2) || !strncasecmp(*ptr, "th", 2)) {
		*ptr += 2;
	}
}

static double timelib_get_frac_nr(char **ptr, int max_length)
{
	char *begin, *end, *str;
	double tmp_nr = -1;
	int len = 0;

	while ((**ptr != '.') && ((**ptr < '0') || (**ptr > '9'))) {
		if (**ptr == '\0') {
			return -1;
		}
		++*ptr;
	}
	begin = *ptr;
	while (((**ptr == '.') || ((**ptr >= '0') && (**ptr <= '9'))) && len < max_length) {
		++*ptr;
		++len;
	}
	end = *ptr;
	str = calloc(1, end - begin + 1);
	memcpy(str, begin, end - begin);
	tmp_nr = strtod(str, NULL);
	free(str);
	return tmp_nr;
}

static timelib_ull timelib_get_unsigned_nr(char **ptr, int max_length)
{
	timelib_ull dir = 1;

	while (((**ptr < '0') || (**ptr > '9')) && (**ptr != '+') && (**ptr != '-')) {
		if (**ptr == '\0') {
			return -1;
		}
		++*ptr;
	}
	if (**ptr == '+') {
		++*ptr;
	} else if (**ptr == '-') {
		dir = -1;
		++*ptr;
	}
	return dir * timelib_get_nr(ptr, max_length);
}

static long timelib_parse_tz_cor(char **ptr)
{
	char *begin = *ptr, *end;
	long  tmp;

	while (**ptr != '\0') {
		++*ptr;
	}
	end = *ptr;
	switch (end - begin) {
		case 1:
		case 2:
			return HOUR(strtol(begin, NULL, 10));
			break;
		case 3:
		case 4:
			if (begin[1] == ':') {
				tmp = HOUR(strtol(begin, NULL, 10)) + strtol(begin + 2, NULL, 10);
				return tmp;
			} else if (begin[2] == ':') {
				tmp = HOUR(strtol(begin, NULL, 10)) + strtol(begin + 3, NULL, 10);
				return tmp;
			} else {
				tmp = strtol(begin, NULL, 10);
				return HOUR(tmp / 100) + tmp % 100;
			}
		case 5:
			tmp = HOUR(strtol(begin, NULL, 10)) + strtol(begin + 3, NULL, 10);
			return tmp;
	}
	return 0;
}

static timelib_sll timelib_lookup_relative_text(char **ptr, int *behavior)
{
	char *word;
	char *begin = *ptr, *end;
	timelib_sll  value = 0;
	const timelib_lookup_table *tp;

	while ((**ptr >= 'A' && **ptr <= 'Z') || (**ptr >= 'a' && **ptr <= 'z')) {
		++*ptr;
	}
	end = *ptr;
	word = calloc(1, end - begin + 1);
	memcpy(word, begin, end - begin);

	for (tp = timelib_reltext_lookup; tp->name; tp++) {
		if (strcasecmp(word, tp->name) == 0) {
			value = tp->value;
			*behavior = tp->type;
		}
	}

	free(word);
	return value;
}

static timelib_sll timelib_get_relative_text(char **ptr, int *behavior)
{
	while (**ptr == ' ' || **ptr == '\t' || **ptr == '-' || **ptr == '/') {
		++*ptr;
	}
	return timelib_lookup_relative_text(ptr, behavior);
}

static long timelib_lookup_month(char **ptr)
{
	char *word;
	char *begin = *ptr, *end;
	long  value = 0;
	const timelib_lookup_table *tp;

	while ((**ptr >= 'A' && **ptr <= 'Z') || (**ptr >= 'a' && **ptr <= 'z')) {
		++*ptr;
	}
	end = *ptr;
	word = calloc(1, end - begin + 1);
	memcpy(word, begin, end - begin);

	for (tp = timelib_month_lookup; tp->name; tp++) {
		if (strcasecmp(word, tp->name) == 0) {
			value = tp->value;
		}
	}

	free(word);
	return value;
}

static long timelib_get_month(char **ptr)
{
	while (**ptr == ' ' || **ptr == '\t' || **ptr == '-' || **ptr == '.' || **ptr == '/') {
		++*ptr;
	}
	return timelib_lookup_month(ptr);
}

static void timelib_eat_spaces(char **ptr)
{
	while (**ptr == ' ' || **ptr == '\t') {
		++*ptr;
	}
}

static const timelib_relunit* timelib_lookup_relunit(char **ptr)
{
	char *word;
	char *begin = *ptr, *end;
	const timelib_relunit *tp, *value = NULL;

	while (**ptr != '\0' && **ptr != ' ' && **ptr != '\t') {
		++*ptr;
	}
	end = *ptr;
	word = calloc(1, end - begin + 1);
	memcpy(word, begin, end - begin);

	for (tp = timelib_relunit_lookup; tp->name; tp++) {
		if (strcasecmp(word, tp->name) == 0) {
			value = tp;
			break;
		}
	}

	free(word);
	return value;
}

static void timelib_set_relative(char **ptr, timelib_sll amount, int behavior, Scanner *s)
{
	const timelib_relunit* relunit;

	relunit = timelib_lookup_relunit(ptr);
	switch (relunit->unit) {
		case TIMELIB_SECOND: s->time->relative.s += amount * relunit->multiplier; break;
		case TIMELIB_MINUTE: s->time->relative.i += amount * relunit->multiplier; break;
		case TIMELIB_HOUR:   s->time->relative.h += amount * relunit->multiplier; break;
		case TIMELIB_DAY:    s->time->relative.d += amount * relunit->multiplier; break;
		case TIMELIB_MONTH:  s->time->relative.m += amount * relunit->multiplier; break;
		case TIMELIB_YEAR:   s->time->relative.y += amount * relunit->multiplier; break;

		case TIMELIB_WEEKDAY:
			TIMELIB_HAVE_WEEKDAY_RELATIVE();
			TIMELIB_UNHAVE_TIME();
			s->time->relative.d += (amount > 0 ? amount - 1 : amount) * 7;
			s->time->relative.weekday = relunit->multiplier;
			s->time->relative.weekday_behavior = behavior;
			break;

		case TIMELIB_SPECIAL:
			TIMELIB_HAVE_SPECIAL_RELATIVE();
			TIMELIB_UNHAVE_TIME();
			s->time->special.type = relunit->multiplier;
			s->time->special.amount = amount;
	}
}

static timelib_tz_lookup_table* zone_search(const char *word, long gmtoffset, int isdst)
{
	int first_found = 0;
	timelib_tz_lookup_table  *tp, *first_found_elem = NULL;
	timelib_tz_lookup_table  *fmp;

	if (strcasecmp("utc", word) == 0 || strcasecmp("gmt", word) == 0) {
		return timelib_timezone_utc;
	}
	
	for (tp = timelib_timezone_lookup; tp->name; tp++) {
		if (strcasecmp(word, tp->name) == 0) {
			if (!first_found) {
				first_found = 1;
				first_found_elem = tp;
				if (gmtoffset == -1) {
					return tp;
				}
			}
			if (tp->gmtoffset == gmtoffset) {
				return tp;
			}
		}
	}
	if (first_found) {
		return first_found_elem;
	}

	/* Still didn't find anything, let's find the zone solely based on
	 * offset/isdst then */
	for (fmp = timelib_timezone_fallbackmap; fmp->name; fmp++) {
		if ((fmp->gmtoffset * 3600) == gmtoffset && fmp->type == isdst) {
			return fmp;
		}
	}
	return NULL;
}

static long timelib_lookup_zone(char **ptr, int *dst, char **tz_abbr, int *found)
{
	char *word;
	char *begin = *ptr, *end;
	long  value = 0;
	timelib_tz_lookup_table *tp;

	while (**ptr != '\0' && **ptr != ')') {
		++*ptr;
	}
	end = *ptr;
	word = calloc(1, end - begin + 1);
	memcpy(word, begin, end - begin);

	if ((tp = zone_search(word, -1, 0))) {
		value = -tp->gmtoffset / 60;
		*dst = tp->type;
		value += tp->type * 60;
		*found = 1;
	} else {
		*found = 0;
	}

	*tz_abbr = word;
	return value;
}

static long timelib_get_zone(char **ptr, int *dst, timelib_time *t, int *tz_not_found, timelib_tzdb *tzdb)
{
	timelib_tzinfo *res;
	long            retval = 0;

	*tz_not_found = 0;

	while (**ptr == ' ' || **ptr == '\t' || **ptr == '(') {
		++*ptr;
	}
	if (**ptr == '+') {
		++*ptr;
		t->is_localtime = 1;
		t->zone_type = TIMELIB_ZONETYPE_OFFSET;
		*tz_not_found = 0;
		t->dst = 0;

		retval = -1 * timelib_parse_tz_cor(ptr);
	} else if (**ptr == '-') {
		++*ptr;
		t->is_localtime = 1;
		t->zone_type = TIMELIB_ZONETYPE_OFFSET;
		*tz_not_found = 0;
		t->dst = 0;

		retval = timelib_parse_tz_cor(ptr);
	} else {
		int found = 0;
		long offset;
		char *tz_abbr;

		t->is_localtime = 1;

		offset = timelib_lookup_zone(ptr, dst, &tz_abbr, &found);
		if (found) {
			t->zone_type = TIMELIB_ZONETYPE_ABBR;
		}
#if 0
		/* If we found a TimeZone identifier, use it */
		if (tz_name) {
			t->tz_info = timelib_parse_tzfile(tz_name);
			t->zone_type = TIMELIB_ZONETYPE_ID;
		}
#endif
		/* If we have a TimeZone identifier to start with, use it */
		if (strstr(tz_abbr, "/")) {
			if ((res = timelib_parse_tzfile(tz_abbr, tzdb)) != NULL) {
				t->tz_info = res;
				t->zone_type = TIMELIB_ZONETYPE_ID;
				found++;
			}
		}
		if (found && t->zone_type != TIMELIB_ZONETYPE_ID) {
			timelib_time_tz_abbr_update(t, tz_abbr);
		}
		free(tz_abbr);
		*tz_not_found = (found == 0);
		retval = offset;
	}
	while (**ptr == ')') {
		++*ptr;
	}
	return retval;
}

#define timelib_split_free(arg) {       \
	int i;                         \
	for (i = 0; i < arg.c; i++) {  \
		free(arg.v[i]);            \
	}                              \
	if (arg.v) {                   \
		free(arg.v);               \
	}                              \
}

static int scan(Scanner *s)
{
	uchar *cursor = s->cur;
	char *str, *ptr = NULL;
		
std:
	s->tok = cursor;
	s->len = 0;


{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0, 208,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	208,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0, 128,  64, 192,   0, 
	  8,   8,   8,   8,   8,   8,   8,   8, 
	  8,   8,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,  32,  32,  32, 160,  32,  32,  32, 
	160,  32,  32,  32,  32,  32, 160,  32, 
	 32,  32, 160, 160, 160,  32,  32,  32, 
	 32,  32,  32,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	goto yy0;

	YYDEBUG(1, *YYCURSOR);
	++YYCURSOR;
yy0:
	if((YYLIMIT - YYCURSOR) < 29) YYFILL(29);
	yych = *YYCURSOR;
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x00:	case 0x0A:	goto yy48;
	case 0x09:	case ' ':	goto yy45;
	case '(':	goto yy42;
	case '+':	case '-':	goto yy41;
	case ',':	case '.':	goto yy47;
	case '0':	goto yy13;
	case '1':	goto yy14;
	case '2':	goto yy15;
	case '3':	goto yy16;
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy17;
	case '@':	goto yy11;
	case 'A':	goto yy25;
	case 'B':
	case 'C':	case 'G':
	case 'H':	case 'K':	case 'Q':
	case 'R':	case 'U':	case 'Z':	goto yy43;
	case 'D':	goto yy31;
	case 'E':	goto yy35;
	case 'F':	goto yy23;
	case 'I':	goto yy18;
	case 'J':	goto yy21;
	case 'L':	goto yy37;
	case 'M':	goto yy7;
	case 'N':	goto yy5;
	case 'O':	goto yy29;
	case 'P':	goto yy39;
	case 'S':	goto yy27;
	case 'T':	goto yy9;
	case 'V':	goto yy19;
	case 'W':	goto yy33;
	case 'X':	goto yy20;
	case 'Y':	goto yy2;
	case 'a':	goto yy26;
	case 'b':
	case 'c':	case 'g':
	case 'h':
	case 'i':	case 'k':	case 'q':
	case 'r':	case 'u':
	case 'v':	case 'x':	case 'z':	goto yy44;
	case 'd':	goto yy32;
	case 'e':	goto yy36;
	case 'f':	goto yy24;
	case 'j':	goto yy22;
	case 'l':	goto yy38;
	case 'm':	goto yy8;
	case 'n':	goto yy6;
	case 'o':	goto yy30;
	case 'p':	goto yy40;
	case 's':	goto yy28;
	case 't':	goto yy10;
	case 'w':	goto yy34;
	case 'y':	goto yy4;
	default:	goto yy50;
	}
yy2:
	YYDEBUG(2, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'E'){
		if(yych <= ')'){
			if(yych >= ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy137;
			goto yy1504;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy137;
			if(yych >= 'a')	goto yy142;
			goto yy3;
		} else {
			if(yych <= 'e')	goto yy1513;
			if(yych <= 'z')	goto yy142;
			goto yy3;
		}
	}
yy3:
	YYDEBUG(3, *YYCURSOR);

{
		int tz_not_found;
		DEBUG_OUTPUT("tzcorrection | tz");
		TIMELIB_INIT;
		TIMELIB_HAVE_TZ();
		s->time->z = timelib_get_zone((char **) &ptr, &s->time->dst, s->time, &tz_not_found, s->tzdb);
		if (tz_not_found) {
			add_error(s, "The timezone could not be found in the database");
		}
		TIMELIB_DEINIT;
		return TIMELIB_TIMEZONE;
	}
yy4:
	YYDEBUG(4, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy137;
			goto yy1504;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'e')	goto yy1504;
			if(yych <= 'z')	goto yy137;
			goto yy3;
		}
	}
yy5:
	YYDEBUG(5, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'D'){
			if(yych == ')')	goto yy136;
			if(yych <= '@')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'H'){
				if(yych <= 'E')	goto yy1475;
				goto yy137;
			} else {
				if(yych <= 'I')	goto yy1476;
				if(yych <= 'N')	goto yy137;
				goto yy1474;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= '`'){
				if(yych <= 'Z')	goto yy137;
				goto yy3;
			} else {
				if(yych == 'e')	goto yy1491;
				goto yy142;
			}
		} else {
			if(yych <= 'n'){
				if(yych <= 'i')	goto yy1492;
				goto yy142;
			} else {
				if(yych <= 'o')	goto yy1490;
				if(yych <= 'z')	goto yy142;
				goto yy3;
			}
		}
	}
yy6:
	YYDEBUG(6, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'D'){
			if(yych == ')')	goto yy136;
			if(yych <= '@')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'H'){
				if(yych <= 'E')	goto yy1475;
				goto yy137;
			} else {
				if(yych <= 'I')	goto yy1476;
				if(yych <= 'N')	goto yy137;
				goto yy1474;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= '`'){
				if(yych <= 'Z')	goto yy137;
				goto yy3;
			} else {
				if(yych == 'e')	goto yy1475;
				goto yy137;
			}
		} else {
			if(yych <= 'n'){
				if(yych <= 'i')	goto yy1476;
				goto yy137;
			} else {
				if(yych <= 'o')	goto yy1474;
				if(yych <= 'z')	goto yy137;
				goto yy3;
			}
		}
	}
yy7:
	YYDEBUG(7, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'A'){
			if(yych == ')')	goto yy136;
			if(yych <= '@')	goto yy3;
			goto yy1444;
		} else {
			if(yych == 'I')	goto yy1445;
			if(yych <= 'N')	goto yy137;
			goto yy1446;
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy1459;
			goto yy142;
		} else {
			if(yych <= 'n'){
				if(yych <= 'i')	goto yy1460;
				goto yy142;
			} else {
				if(yych <= 'o')	goto yy1461;
				if(yych <= 'z')	goto yy142;
				goto yy3;
			}
		}
	}
yy8:
	YYDEBUG(8, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'A'){
			if(yych == ')')	goto yy136;
			if(yych <= '@')	goto yy3;
			goto yy1444;
		} else {
			if(yych == 'I')	goto yy1445;
			if(yych <= 'N')	goto yy137;
			goto yy1446;
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy1444;
			goto yy137;
		} else {
			if(yych <= 'n'){
				if(yych <= 'i')	goto yy1445;
				goto yy137;
			} else {
				if(yych <= 'o')	goto yy1446;
				if(yych <= 'z')	goto yy137;
				goto yy3;
			}
		}
	}
yy9:
	YYDEBUG(9, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case ')':	goto yy136;
	case '0':
	case '1':	goto yy1376;
	case '2':	goto yy1377;
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1378;
	case 'A':
	case 'B':
	case 'C':
	case 'D':	case 'F':
	case 'G':	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':	case 'V':	case 'X':
	case 'Y':
	case 'Z':	goto yy137;
	case 'E':	goto yy1371;
	case 'H':	goto yy1372;
	case 'O':	goto yy1373;
	case 'U':	goto yy1374;
	case 'W':	goto yy1375;
	case 'a':
	case 'b':
	case 'c':
	case 'd':	case 'f':
	case 'g':	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':	case 'v':	case 'x':
	case 'y':
	case 'z':	goto yy142;
	case 'e':	goto yy1413;
	case 'h':	goto yy1414;
	case 'o':	goto yy1415;
	case 'u':	goto yy1416;
	case 'w':	goto yy1417;
	default:	goto yy3;
	}
yy10:
	YYDEBUG(10, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case ')':	goto yy136;
	case '0':
	case '1':	goto yy1376;
	case '2':	goto yy1377;
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1378;
	case 'A':
	case 'B':
	case 'C':
	case 'D':	case 'F':
	case 'G':	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':	case 'V':	case 'X':
	case 'Y':
	case 'Z':	case 'a':
	case 'b':
	case 'c':
	case 'd':	case 'f':
	case 'g':	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':	case 'v':	case 'x':
	case 'y':
	case 'z':	goto yy137;
	case 'E':	case 'e':	goto yy1371;
	case 'H':	case 'h':	goto yy1372;
	case 'O':	case 'o':	goto yy1373;
	case 'U':	case 'u':	goto yy1374;
	case 'W':	case 'w':	goto yy1375;
	default:	goto yy3;
	}
yy11:
	YYDEBUG(11, *YYCURSOR);
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '-')	goto yy1367;
	if(yych <= '/')	goto yy12;
	if(yych <= '9')	goto yy1368;
	goto yy12;
yy12:
	YYDEBUG(12, *YYCURSOR);

{
		add_error(s, "Unexpected character");
		goto std;
	}
yy13:
	YYDEBUG(13, *YYCURSOR);
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	goto yy1329;
	case ' ':	case 'A':	case 'D':	case 'F':	case 'H':
	case 'I':
	case 'J':	case 'M':
	case 'N':
	case 'O':	case 'S':
	case 'T':	case 'V':
	case 'W':
	case 'X':
	case 'Y':	case 'a':	case 'd':	case 'f':	case 'h':	case 'j':	case 'm':	case 'o':	case 'w':	case 'y':	goto yy1331;
	case '-':	goto yy794;
	case '.':	goto yy1333;
	case '/':	goto yy793;
	case '0':	goto yy1366;
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1365;
	case ':':	goto yy1334;
	case 'n':	goto yy791;
	case 'r':	goto yy792;
	case 's':	goto yy785;
	case 't':	goto yy789;
	default:	goto yy12;
	}
yy14:
	YYDEBUG(14, *YYCURSOR);
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	goto yy781;
	case ' ':	case 'A':	case 'D':	case 'F':	case 'H':
	case 'I':
	case 'J':	case 'M':
	case 'N':
	case 'O':
	case 'P':	case 'S':
	case 'T':	case 'V':
	case 'W':
	case 'X':
	case 'Y':	case 'a':	case 'd':	case 'f':	case 'h':	case 'j':	case 'm':	case 'o':
	case 'p':	case 'w':	case 'y':	goto yy783;
	case '-':	goto yy794;
	case '.':	goto yy795;
	case '/':	goto yy793;
	case '0':
	case '1':
	case '2':	goto yy1365;
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1332;
	case ':':	goto yy804;
	case 'n':	goto yy791;
	case 'r':	goto yy792;
	case 's':	goto yy785;
	case 't':	goto yy789;
	default:	goto yy12;
	}
yy15:
	YYDEBUG(15, *YYCURSOR);
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	goto yy781;
	case ' ':	case 'A':	case 'D':	case 'F':	case 'H':
	case 'I':
	case 'J':	case 'M':
	case 'N':
	case 'O':
	case 'P':	case 'S':
	case 'T':	case 'V':
	case 'W':
	case 'X':
	case 'Y':	case 'a':	case 'd':	case 'f':	case 'h':	case 'j':	case 'm':	case 'o':
	case 'p':	case 'w':	case 'y':	goto yy783;
	case '-':	goto yy794;
	case '.':	goto yy795;
	case '/':	goto yy793;
	case '0':
	case '1':
	case '2':
	case '3':	goto yy1332;
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1328;
	case ':':	goto yy804;
	case 'n':	goto yy791;
	case 'r':	goto yy792;
	case 's':	goto yy785;
	case 't':	goto yy789;
	default:	goto yy12;
	}
yy16:
	YYDEBUG(16, *YYCURSOR);
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	goto yy781;
	case ' ':	case 'A':	case 'D':	case 'F':	case 'H':
	case 'I':
	case 'J':	case 'M':
	case 'N':
	case 'O':
	case 'P':	case 'S':
	case 'T':	case 'V':
	case 'W':
	case 'X':
	case 'Y':	case 'a':	case 'd':	case 'f':	case 'h':	case 'j':	case 'm':	case 'o':
	case 'p':	case 'w':	case 'y':	goto yy783;
	case '-':	goto yy794;
	case '.':	goto yy795;
	case '/':	goto yy793;
	case '0':
	case '1':	goto yy1328;
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy790;
	case ':':	goto yy804;
	case 'n':	goto yy791;
	case 'r':	goto yy792;
	case 's':	goto yy785;
	case 't':	goto yy789;
	default:	goto yy12;
	}
yy17:
	YYDEBUG(17, *YYCURSOR);
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	goto yy781;
	case ' ':	case 'A':	case 'D':	case 'F':	case 'H':
	case 'I':
	case 'J':	case 'M':
	case 'N':
	case 'O':
	case 'P':	case 'S':
	case 'T':	case 'V':
	case 'W':
	case 'X':
	case 'Y':	case 'a':	case 'd':	case 'f':	case 'h':	case 'j':	case 'm':	case 'o':
	case 'p':	case 'w':	case 'y':	goto yy783;
	case '-':	goto yy794;
	case '.':	goto yy795;
	case '/':	goto yy793;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy790;
	case ':':	goto yy804;
	case 'n':	goto yy791;
	case 'r':	goto yy792;
	case 's':	goto yy785;
	case 't':	goto yy789;
	default:	goto yy12;
	}
yy18:
	YYDEBUG(18, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy3;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy3;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy3;
			} else {
				if(yych == '/')	goto yy3;
				goto yy446;
			}
		}
	} else {
		if(yych <= 'V'){
			if(yych <= 'H'){
				if(yych <= '@')	goto yy3;
				goto yy137;
			} else {
				if(yych <= 'I')	goto yy780;
				if(yych <= 'U')	goto yy137;
				goto yy779;
			}
		} else {
			if(yych <= 'Z'){
				if(yych == 'X')	goto yy779;
				goto yy137;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'z')	goto yy142;
				goto yy3;
			}
		}
	}
yy19:
	YYDEBUG(19, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy3;
			goto yy446;
		} else {
			if(yych == ')')	goto yy136;
			if(yych <= ',')	goto yy3;
			goto yy446;
		}
	} else {
		if(yych <= 'H'){
			if(yych <= '/')	goto yy3;
			if(yych <= '9')	goto yy446;
			if(yych <= '@')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'Z'){
				if(yych <= 'I')	goto yy776;
				goto yy137;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'z')	goto yy142;
				goto yy3;
			}
		}
	}
yy20:
	YYDEBUG(20, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy3;
			goto yy446;
		} else {
			if(yych == ')')	goto yy136;
			if(yych <= ',')	goto yy3;
			goto yy446;
		}
	} else {
		if(yych <= 'H'){
			if(yych <= '/')	goto yy3;
			if(yych <= '9')	goto yy446;
			if(yych <= '@')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'Z'){
				if(yych <= 'I')	goto yy774;
				goto yy137;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'z')	goto yy142;
				goto yy3;
			}
		}
	}
yy21:
	YYDEBUG(21, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= 'A')	goto yy757;
			if(yych <= 'T')	goto yy137;
			goto yy756;
		}
	} else {
		if(yych <= 'a'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy766;
		} else {
			if(yych == 'u')	goto yy765;
			if(yych <= 'z')	goto yy142;
			goto yy3;
		}
	}
yy22:
	YYDEBUG(22, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= 'A')	goto yy757;
			if(yych <= 'T')	goto yy137;
			goto yy756;
		}
	} else {
		if(yych <= 'a'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy757;
		} else {
			if(yych == 'u')	goto yy756;
			if(yych <= 'z')	goto yy137;
			goto yy3;
		}
	}
yy23:
	YYDEBUG(23, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'E'){
			if(yych <= ')'){
				if(yych <= '(')	goto yy3;
				goto yy136;
			} else {
				if(yych <= '@')	goto yy3;
				if(yych <= 'D')	goto yy137;
				goto yy718;
			}
		} else {
			if(yych <= 'N'){
				if(yych == 'I')	goto yy719;
				goto yy137;
			} else {
				if(yych <= 'O')	goto yy720;
				if(yych <= 'Q')	goto yy137;
				goto yy721;
			}
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'd'){
				if(yych <= 'Z')	goto yy137;
				if(yych <= '`')	goto yy3;
				goto yy142;
			} else {
				if(yych <= 'e')	goto yy737;
				if(yych <= 'h')	goto yy142;
				goto yy738;
			}
		} else {
			if(yych <= 'q'){
				if(yych == 'o')	goto yy739;
				goto yy142;
			} else {
				if(yych <= 'r')	goto yy740;
				if(yych <= 'z')	goto yy142;
				goto yy3;
			}
		}
	}
yy24:
	YYDEBUG(24, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'E'){
			if(yych <= ')'){
				if(yych <= '(')	goto yy3;
				goto yy136;
			} else {
				if(yych <= '@')	goto yy3;
				if(yych <= 'D')	goto yy137;
				goto yy718;
			}
		} else {
			if(yych <= 'N'){
				if(yych == 'I')	goto yy719;
				goto yy137;
			} else {
				if(yych <= 'O')	goto yy720;
				if(yych <= 'Q')	goto yy137;
				goto yy721;
			}
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'd'){
				if(yych <= 'Z')	goto yy137;
				if(yych <= '`')	goto yy3;
				goto yy137;
			} else {
				if(yych <= 'e')	goto yy718;
				if(yych <= 'h')	goto yy137;
				goto yy719;
			}
		} else {
			if(yych <= 'q'){
				if(yych == 'o')	goto yy720;
				goto yy137;
			} else {
				if(yych <= 'r')	goto yy721;
				if(yych <= 'z')	goto yy137;
				goto yy3;
			}
		}
	}
yy25:
	YYDEBUG(25, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'F'){
			if(yych == ')')	goto yy136;
			if(yych <= '@')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'O'){
				if(yych <= 'G')	goto yy697;
				goto yy137;
			} else {
				if(yych <= 'P')	goto yy696;
				if(yych <= 'T')	goto yy137;
				goto yy695;
			}
		}
	} else {
		if(yych <= 'o'){
			if(yych <= '`'){
				if(yych <= 'Z')	goto yy137;
				goto yy3;
			} else {
				if(yych == 'g')	goto yy709;
				goto yy142;
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'p')	goto yy708;
				goto yy142;
			} else {
				if(yych <= 'u')	goto yy707;
				if(yych <= 'z')	goto yy142;
				goto yy3;
			}
		}
	}
yy26:
	YYDEBUG(26, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'F'){
			if(yych == ')')	goto yy136;
			if(yych <= '@')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'O'){
				if(yych <= 'G')	goto yy697;
				goto yy137;
			} else {
				if(yych <= 'P')	goto yy696;
				if(yych <= 'T')	goto yy137;
				goto yy695;
			}
		}
	} else {
		if(yych <= 'o'){
			if(yych <= '`'){
				if(yych <= 'Z')	goto yy137;
				goto yy3;
			} else {
				if(yych == 'g')	goto yy697;
				goto yy137;
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'p')	goto yy696;
				goto yy137;
			} else {
				if(yych <= 'u')	goto yy695;
				if(yych <= 'z')	goto yy137;
				goto yy3;
			}
		}
	}
yy27:
	YYDEBUG(27, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'D'){
			if(yych <= ')'){
				if(yych <= '(')	goto yy3;
				goto yy136;
			} else {
				if(yych <= '@')	goto yy3;
				if(yych <= 'A')	goto yy638;
				goto yy137;
			}
		} else {
			if(yych <= 'H'){
				if(yych <= 'E')	goto yy637;
				goto yy137;
			} else {
				if(yych <= 'I')	goto yy639;
				if(yych <= 'T')	goto yy137;
				goto yy640;
			}
		}
	} else {
		if(yych <= 'e'){
			if(yych <= '`'){
				if(yych <= 'Z')	goto yy137;
				goto yy3;
			} else {
				if(yych <= 'a')	goto yy667;
				if(yych <= 'd')	goto yy142;
				goto yy666;
			}
		} else {
			if(yych <= 't'){
				if(yych == 'i')	goto yy668;
				goto yy142;
			} else {
				if(yych <= 'u')	goto yy669;
				if(yych <= 'z')	goto yy142;
				goto yy3;
			}
		}
	}
yy28:
	YYDEBUG(28, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'D'){
			if(yych <= ')'){
				if(yych <= '(')	goto yy3;
				goto yy136;
			} else {
				if(yych <= '@')	goto yy3;
				if(yych <= 'A')	goto yy638;
				goto yy137;
			}
		} else {
			if(yych <= 'H'){
				if(yych <= 'E')	goto yy637;
				goto yy137;
			} else {
				if(yych <= 'I')	goto yy639;
				if(yych <= 'T')	goto yy137;
				goto yy640;
			}
		}
	} else {
		if(yych <= 'e'){
			if(yych <= '`'){
				if(yych <= 'Z')	goto yy137;
				goto yy3;
			} else {
				if(yych <= 'a')	goto yy638;
				if(yych <= 'd')	goto yy137;
				goto yy637;
			}
		} else {
			if(yych <= 't'){
				if(yych == 'i')	goto yy639;
				goto yy137;
			} else {
				if(yych <= 'u')	goto yy640;
				if(yych <= 'z')	goto yy137;
				goto yy3;
			}
		}
	}
yy29:
	YYDEBUG(29, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'C'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'B')	goto yy137;
			goto yy627;
		}
	} else {
		if(yych <= 'b'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy142;
		} else {
			if(yych <= 'c')	goto yy632;
			if(yych <= 'z')	goto yy142;
			goto yy3;
		}
	}
yy30:
	YYDEBUG(30, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'C'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'B')	goto yy137;
			goto yy627;
		}
	} else {
		if(yych <= 'b'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'c')	goto yy627;
			if(yych <= 'z')	goto yy137;
			goto yy3;
		}
	}
yy31:
	YYDEBUG(31, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy137;
			goto yy442;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy142;
		} else {
			if(yych <= 'e')	goto yy620;
			if(yych <= 'z')	goto yy142;
			goto yy3;
		}
	}
yy32:
	YYDEBUG(32, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy137;
			goto yy442;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'e')	goto yy442;
			if(yych <= 'z')	goto yy137;
			goto yy3;
		}
	}
yy33:
	YYDEBUG(33, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy137;
			goto yy415;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy142;
		} else {
			if(yych <= 'e')	goto yy429;
			if(yych <= 'z')	goto yy142;
			goto yy3;
		}
	}
yy34:
	YYDEBUG(34, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy137;
			goto yy415;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'e')	goto yy415;
			if(yych <= 'z')	goto yy137;
			goto yy3;
		}
	}
yy35:
	YYDEBUG(35, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'I')	goto yy379;
			if(yych <= 'K')	goto yy137;
			goto yy380;
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			if(yych <= 'h')	goto yy142;
			goto yy397;
		} else {
			if(yych == 'l')	goto yy398;
			if(yych <= 'z')	goto yy142;
			goto yy3;
		}
	}
yy36:
	YYDEBUG(36, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'I')	goto yy379;
			if(yych <= 'K')	goto yy137;
			goto yy380;
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			if(yych <= 'h')	goto yy137;
			goto yy379;
		} else {
			if(yych == 'l')	goto yy380;
			if(yych <= 'z')	goto yy137;
			goto yy3;
		}
	}
yy37:
	YYDEBUG(37, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy331;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy137;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy355;
			if(yych <= 'z')	goto yy142;
			goto yy3;
		}
	}
yy38:
	YYDEBUG(38, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy331;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy137;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy331;
			if(yych <= 'z')	goto yy137;
			goto yy3;
		}
	}
yy39:
	YYDEBUG(39, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy137;
			goto yy161;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy142;
		} else {
			if(yych <= 'r')	goto yy247;
			if(yych <= 'z')	goto yy142;
			goto yy3;
		}
	}
yy40:
	YYDEBUG(40, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy137;
			goto yy161;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy137;
			if(yych <= '`')	goto yy3;
			goto yy137;
		} else {
			if(yych <= 'r')	goto yy161;
			if(yych <= 'z')	goto yy137;
			goto yy3;
		}
	}
yy41:
	YYDEBUG(41, *YYCURSOR);
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 16) {
		goto yy54;
	}
	if(yych <= '/')	goto yy12;
	if(yych <= '1')	goto yy154;
	if(yych <= '2')	goto yy155;
	if(yych <= '9')	goto yy156;
	goto yy12;
yy42:
	YYDEBUG(42, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@')	goto yy12;
	if(yych <= 'Z')	goto yy153;
	if(yych <= '`')	goto yy12;
	if(yych <= 'z')	goto yy153;
	goto yy12;
yy43:
	YYDEBUG(43, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Z')	goto yy137;
		if(yych <= '`')	goto yy3;
		if(yych <= 'z')	goto yy142;
		goto yy3;
	}
yy44:
	YYDEBUG(44, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Z')	goto yy137;
		if(yych <= '`')	goto yy3;
		if(yych <= 'z')	goto yy137;
		goto yy3;
	}
yy45:
	YYDEBUG(45, *YYCURSOR);
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 16) {
		goto yy54;
	}
	if(yych <= '/')	goto yy46;
	if(yych <= '9')	goto yy51;
	goto yy46;
yy46:
	YYDEBUG(46, *YYCURSOR);

{
		goto std;
	}
yy47:
	YYDEBUG(47, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy46;
yy48:
	YYDEBUG(48, *YYCURSOR);
	++YYCURSOR;
	goto yy49;
yy49:
	YYDEBUG(49, *YYCURSOR);

{
		s->pos = cursor; s->line++;
		goto std;
	}
yy50:
	YYDEBUG(50, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy12;
yy51:
	YYDEBUG(51, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 11) YYFILL(11);
	yych = *YYCURSOR;
	goto yy52;
yy52:
	YYDEBUG(52, *YYCURSOR);
	if(yybm[0+yych] & 8) {
		goto yy51;
	}
	if(yych <= 'W'){
		if(yych <= 'F'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy56;
				if(yych >= ' ')	goto yy56;
				goto yy53;
			} else {
				if(yych == 'D')	goto yy61;
				if(yych >= 'F')	goto yy63;
				goto yy53;
			}
		} else {
			if(yych <= 'M'){
				if(yych == 'H')	goto yy60;
				if(yych >= 'M')	goto yy59;
				goto yy53;
			} else {
				if(yych <= 'S'){
					if(yych >= 'S')	goto yy58;
					goto yy53;
				} else {
					if(yych <= 'T')	goto yy65;
					if(yych >= 'W')	goto yy62;
					goto yy53;
				}
			}
		}
	} else {
		if(yych <= 'l'){
			if(yych <= 'd'){
				if(yych == 'Y')	goto yy64;
				if(yych >= 'd')	goto yy61;
				goto yy53;
			} else {
				if(yych <= 'f'){
					if(yych >= 'f')	goto yy63;
					goto yy53;
				} else {
					if(yych == 'h')	goto yy60;
					goto yy53;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'm')	goto yy59;
				if(yych <= 'r')	goto yy53;
				if(yych <= 's')	goto yy58;
				goto yy65;
			} else {
				if(yych <= 'w'){
					if(yych >= 'w')	goto yy62;
					goto yy53;
				} else {
					if(yych == 'y')	goto yy64;
					goto yy53;
				}
			}
		}
	}
yy53:
	YYDEBUG(53, *YYCURSOR);
	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 27:	goto yy1512;
	case 25:	goto yy1481;
	case 26:	goto yy1489;
	case 24:	goto yy1403;
	case 23:	goto yy1400;
	case 12:	goto yy812;
	case 21:	goto yy1337;
	case 22:	goto yy1345;
	case 14:	goto yy969;
	case 19:	goto yy1233;
	case 13:	goto yy959;
	case 9:	goto yy543;
	case 18:	goto yy1077;
	case 7:	goto yy449;
	case 11:	goto yy797;
	case 17:	goto yy1131;
	case 20:	goto yy1125;
	case 16:	goto yy1104;
	case 15:	goto yy1070;
	case 10:	goto yy699;
	case 5:	goto yy417;
	case 4:	goto yy180;
	case 6:	goto yy444;
	case 0:	goto yy3;
	case 8:	goto yy473;
	case 3:	goto yy69;
	case 2:	goto yy46;
	case 1:	goto yy12;
	}
yy54:
	YYDEBUG(54, *YYCURSOR);
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy55;
yy55:
	YYDEBUG(55, *YYCURSOR);
	if(yybm[0+yych] & 16) {
		goto yy54;
	}
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy51;
	goto yy53;
yy56:
	YYDEBUG(56, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 11) YYFILL(11);
	yych = *YYCURSOR;
	goto yy57;
yy57:
	YYDEBUG(57, *YYCURSOR);
	if(yych <= 'W'){
		if(yych <= 'F'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy56;
				if(yych <= 0x1F)	goto yy53;
				goto yy56;
			} else {
				if(yych == 'D')	goto yy61;
				if(yych <= 'E')	goto yy53;
				goto yy63;
			}
		} else {
			if(yych <= 'M'){
				if(yych == 'H')	goto yy60;
				if(yych <= 'L')	goto yy53;
				goto yy59;
			} else {
				if(yych <= 'S'){
					if(yych <= 'R')	goto yy53;
					goto yy58;
				} else {
					if(yych <= 'T')	goto yy65;
					if(yych <= 'V')	goto yy53;
					goto yy62;
				}
			}
		}
	} else {
		if(yych <= 'l'){
			if(yych <= 'd'){
				if(yych == 'Y')	goto yy64;
				if(yych <= 'c')	goto yy53;
				goto yy61;
			} else {
				if(yych <= 'f'){
					if(yych <= 'e')	goto yy53;
					goto yy63;
				} else {
					if(yych == 'h')	goto yy60;
					goto yy53;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'm')	goto yy59;
				if(yych <= 'r')	goto yy53;
				if(yych >= 't')	goto yy65;
				goto yy58;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy53;
					goto yy62;
				} else {
					if(yych == 'y')	goto yy64;
					goto yy53;
				}
			}
		}
	}
yy58:
	YYDEBUG(58, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'D'){
			if(yych == 'A')	goto yy123;
			goto yy53;
		} else {
			if(yych <= 'E')	goto yy124;
			if(yych <= 'T')	goto yy53;
			goto yy122;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'a')	goto yy123;
			goto yy53;
		} else {
			if(yych <= 'e')	goto yy124;
			if(yych == 'u')	goto yy122;
			goto yy53;
		}
	}
yy59:
	YYDEBUG(59, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych == 'I')	goto yy114;
		if(yych <= 'N')	goto yy53;
		goto yy113;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy53;
			goto yy114;
		} else {
			if(yych == 'o')	goto yy113;
			goto yy53;
		}
	}
yy60:
	YYDEBUG(60, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy111;
	if(yych == 'o')	goto yy111;
	goto yy53;
yy61:
	YYDEBUG(61, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy110;
	if(yych == 'a')	goto yy110;
	goto yy53;
yy62:
	YYDEBUG(62, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy98;
	if(yych == 'e')	goto yy98;
	goto yy53;
yy63:
	YYDEBUG(63, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych == 'O')	goto yy83;
		if(yych <= 'Q')	goto yy53;
		goto yy82;
	} else {
		if(yych <= 'o'){
			if(yych <= 'n')	goto yy53;
			goto yy83;
		} else {
			if(yych == 'r')	goto yy82;
			goto yy53;
		}
	}
yy64:
	YYDEBUG(64, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy79;
	if(yych == 'e')	goto yy79;
	goto yy53;
yy65:
	YYDEBUG(65, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'H')	goto yy66;
		if(yych <= 'T')	goto yy53;
		goto yy67;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy53;
			goto yy66;
		} else {
			if(yych == 'u')	goto yy67;
			goto yy53;
		}
	}
yy66:
	YYDEBUG(66, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy74;
	if(yych == 'u')	goto yy74;
	goto yy53;
yy67:
	YYDEBUG(67, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy68;
	if(yych != 'e')	goto yy53;
	goto yy68;
yy68:
	YYDEBUG(68, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'S')	goto yy70;
	if(yych == 's')	goto yy70;
	goto yy69;
yy69:
	YYDEBUG(69, *YYCURSOR);

{
		timelib_ull i;
		DEBUG_OUTPUT("relative");
		TIMELIB_INIT;
		TIMELIB_HAVE_RELATIVE();

		while(*ptr) {
			i = timelib_get_unsigned_nr((char **) &ptr, 24);
			timelib_eat_spaces((char **) &ptr);
			timelib_set_relative((char **) &ptr, i, 0, s);
		}
		TIMELIB_DEINIT;
		return TIMELIB_RELATIVE;
	}
yy70:
	YYDEBUG(70, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy71;
	if(yych != 'd')	goto yy53;
	goto yy71;
yy71:
	YYDEBUG(71, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy72;
	if(yych != 'a')	goto yy53;
	goto yy72;
yy72:
	YYDEBUG(72, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy73;
	if(yych != 'y')	goto yy53;
	goto yy73;
yy73:
	YYDEBUG(73, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy69;
yy74:
	YYDEBUG(74, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'R')	goto yy75;
	if(yych != 'r')	goto yy69;
	goto yy75;
yy75:
	YYDEBUG(75, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy76;
	if(yych != 's')	goto yy53;
	goto yy76;
yy76:
	YYDEBUG(76, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy77;
	if(yych != 'd')	goto yy53;
	goto yy77;
yy77:
	YYDEBUG(77, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy78;
	if(yych != 'a')	goto yy53;
	goto yy78;
yy78:
	YYDEBUG(78, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy73;
	if(yych == 'y')	goto yy73;
	goto yy53;
yy79:
	YYDEBUG(79, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy80;
	if(yych != 'a')	goto yy53;
	goto yy80;
yy80:
	YYDEBUG(80, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy81;
	if(yych != 'r')	goto yy53;
	goto yy81;
yy81:
	YYDEBUG(81, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy73;
	if(yych == 's')	goto yy73;
	goto yy69;
yy82:
	YYDEBUG(82, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy95;
	if(yych == 'i')	goto yy95;
	goto yy53;
yy83:
	YYDEBUG(83, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy84;
	if(yych != 'r')	goto yy53;
	goto yy84;
yy84:
	YYDEBUG(84, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy85;
	if(yych != 't')	goto yy53;
	goto yy85;
yy85:
	YYDEBUG(85, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'H')	goto yy87;
		if(yych <= 'M')	goto yy53;
		goto yy86;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy53;
			goto yy87;
		} else {
			if(yych != 'n')	goto yy53;
			goto yy86;
		}
	}
yy86:
	YYDEBUG(86, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy92;
	if(yych == 'i')	goto yy92;
	goto yy53;
yy87:
	YYDEBUG(87, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy88;
	if(yych != 'n')	goto yy53;
	goto yy88;
yy88:
	YYDEBUG(88, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy89;
	if(yych != 'i')	goto yy53;
	goto yy89;
yy89:
	YYDEBUG(89, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy90;
	if(yych != 'g')	goto yy53;
	goto yy90;
yy90:
	YYDEBUG(90, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy91;
	if(yych != 'h')	goto yy53;
	goto yy91;
yy91:
	YYDEBUG(91, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy81;
	if(yych == 't')	goto yy81;
	goto yy53;
yy92:
	YYDEBUG(92, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy93;
	if(yych != 'g')	goto yy53;
	goto yy93;
yy93:
	YYDEBUG(93, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy94;
	if(yych != 'h')	goto yy53;
	goto yy94;
yy94:
	YYDEBUG(94, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy81;
	if(yych == 't')	goto yy81;
	goto yy53;
yy95:
	YYDEBUG(95, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'D')	goto yy96;
	if(yych != 'd')	goto yy69;
	goto yy96;
yy96:
	YYDEBUG(96, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy97;
	if(yych != 'a')	goto yy53;
	goto yy97;
yy97:
	YYDEBUG(97, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy73;
	if(yych == 'y')	goto yy73;
	goto yy53;
yy98:
	YYDEBUG(98, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= 'C')	goto yy53;
		if(yych <= 'D')	goto yy100;
		goto yy99;
	} else {
		if(yych <= 'c')	goto yy53;
		if(yych <= 'd')	goto yy100;
		if(yych >= 'f')	goto yy53;
		goto yy99;
	}
yy99:
	YYDEBUG(99, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy106;
	if(yych == 'k')	goto yy106;
	goto yy53;
yy100:
	YYDEBUG(100, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'N')	goto yy101;
	if(yych != 'n')	goto yy69;
	goto yy101;
yy101:
	YYDEBUG(101, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy102;
	if(yych != 'e')	goto yy53;
	goto yy102;
yy102:
	YYDEBUG(102, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy103;
	if(yych != 's')	goto yy53;
	goto yy103;
yy103:
	YYDEBUG(103, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy104;
	if(yych != 'd')	goto yy53;
	goto yy104;
yy104:
	YYDEBUG(104, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy105;
	if(yych != 'a')	goto yy53;
	goto yy105;
yy105:
	YYDEBUG(105, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy73;
	if(yych == 'y')	goto yy73;
	goto yy53;
yy106:
	YYDEBUG(106, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych == 'D')	goto yy107;
		if(yych <= 'R')	goto yy69;
		goto yy73;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy69;
			goto yy107;
		} else {
			if(yych == 's')	goto yy73;
			goto yy69;
		}
	}
yy107:
	YYDEBUG(107, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy108;
	if(yych != 'a')	goto yy53;
	goto yy108;
yy108:
	YYDEBUG(108, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy109;
	if(yych != 'y')	goto yy53;
	goto yy109;
yy109:
	YYDEBUG(109, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy73;
	if(yych == 's')	goto yy73;
	goto yy69;
yy110:
	YYDEBUG(110, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy81;
	if(yych == 'y')	goto yy81;
	goto yy53;
yy111:
	YYDEBUG(111, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy112;
	if(yych != 'u')	goto yy53;
	goto yy112;
yy112:
	YYDEBUG(112, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy81;
	if(yych == 'r')	goto yy81;
	goto yy53;
yy113:
	YYDEBUG(113, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy118;
	if(yych == 'n')	goto yy118;
	goto yy53;
yy114:
	YYDEBUG(114, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy115;
	if(yych != 'n')	goto yy53;
	goto yy115;
yy115:
	YYDEBUG(115, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych == 'S')	goto yy73;
		if(yych <= 'T')	goto yy69;
		goto yy116;
	} else {
		if(yych <= 's'){
			if(yych <= 'r')	goto yy69;
			goto yy73;
		} else {
			if(yych != 'u')	goto yy69;
			goto yy116;
		}
	}
yy116:
	YYDEBUG(116, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy117;
	if(yych != 't')	goto yy53;
	goto yy117;
yy117:
	YYDEBUG(117, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy81;
	if(yych == 'e')	goto yy81;
	goto yy53;
yy118:
	YYDEBUG(118, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych == 'D')	goto yy119;
		if(yych <= 'S')	goto yy69;
		goto yy120;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy69;
			goto yy119;
		} else {
			if(yych == 't')	goto yy120;
			goto yy69;
		}
	}
yy119:
	YYDEBUG(119, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy121;
	if(yych == 'a')	goto yy121;
	goto yy53;
yy120:
	YYDEBUG(120, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy81;
	if(yych == 'h')	goto yy81;
	goto yy53;
yy121:
	YYDEBUG(121, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy73;
	if(yych == 'y')	goto yy73;
	goto yy53;
yy122:
	YYDEBUG(122, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy133;
	if(yych == 'n')	goto yy133;
	goto yy53;
yy123:
	YYDEBUG(123, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy128;
	if(yych == 't')	goto yy128;
	goto yy53;
yy124:
	YYDEBUG(124, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy125;
	if(yych != 'c')	goto yy53;
	goto yy125;
yy125:
	YYDEBUG(125, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych == 'O')	goto yy126;
		if(yych <= 'R')	goto yy69;
		goto yy73;
	} else {
		if(yych <= 'o'){
			if(yych <= 'n')	goto yy69;
			goto yy126;
		} else {
			if(yych == 's')	goto yy73;
			goto yy69;
		}
	}
yy126:
	YYDEBUG(126, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy127;
	if(yych != 'n')	goto yy53;
	goto yy127;
yy127:
	YYDEBUG(127, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy81;
	if(yych == 'd')	goto yy81;
	goto yy53;
yy128:
	YYDEBUG(128, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'U')	goto yy129;
	if(yych != 'u')	goto yy69;
	goto yy129;
yy129:
	YYDEBUG(129, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy130;
	if(yych != 'r')	goto yy53;
	goto yy130;
yy130:
	YYDEBUG(130, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy131;
	if(yych != 'd')	goto yy53;
	goto yy131;
yy131:
	YYDEBUG(131, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy132;
	if(yych != 'a')	goto yy53;
	goto yy132;
yy132:
	YYDEBUG(132, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy73;
	if(yych == 'y')	goto yy73;
	goto yy53;
yy133:
	YYDEBUG(133, *YYCURSOR);
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'D')	goto yy134;
	if(yych != 'd')	goto yy69;
	goto yy134;
yy134:
	YYDEBUG(134, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy135;
	if(yych != 'a')	goto yy53;
	goto yy135;
yy135:
	YYDEBUG(135, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy73;
	if(yych == 'y')	goto yy73;
	goto yy53;
yy136:
	YYDEBUG(136, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy3;
yy137:
	YYDEBUG(137, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Z')	goto yy138;
		if(yych <= '`')	goto yy3;
		if(yych >= '{')	goto yy3;
		goto yy138;
	}
yy138:
	YYDEBUG(138, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Z')	goto yy139;
		if(yych <= '`')	goto yy3;
		if(yych >= '{')	goto yy3;
		goto yy139;
	}
yy139:
	YYDEBUG(139, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Z')	goto yy140;
		if(yych <= '`')	goto yy3;
		if(yych >= '{')	goto yy3;
		goto yy140;
	}
yy140:
	YYDEBUG(140, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Z')	goto yy141;
		if(yych <= '`')	goto yy3;
		if(yych >= '{')	goto yy3;
		goto yy141;
	}
yy141:
	YYDEBUG(141, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == ')')	goto yy136;
	goto yy3;
yy142:
	YYDEBUG(142, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych == '/')	goto yy144;
			goto yy3;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych >= '{')	goto yy3;
			goto yy143;
		}
	}
yy143:
	YYDEBUG(143, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych != '/')	goto yy3;
			goto yy144;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy144:
	YYDEBUG(144, *YYCURSOR);
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '@')	goto yy53;
	if(yych >= '[')	goto yy53;
	goto yy145;
yy145:
	YYDEBUG(145, *YYCURSOR);
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yybm[0+yych] & 32) {
		goto yy146;
	}
	goto yy53;
yy146:
	YYDEBUG(146, *YYCURSOR);
	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy147;
yy147:
	YYDEBUG(147, *YYCURSOR);
	if(yybm[0+yych] & 32) {
		goto yy146;
	}
	if(yych == '/')	goto yy144;
	if(yych == '_')	goto yy144;
	goto yy3;
yy148:
	YYDEBUG(148, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych == '/')	goto yy144;
			goto yy3;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych >= '{')	goto yy3;
			goto yy149;
		}
	}
yy149:
	YYDEBUG(149, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych == '/')	goto yy144;
			goto yy3;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych >= '{')	goto yy3;
			goto yy150;
		}
	}
yy150:
	YYDEBUG(150, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == ')')	goto yy136;
		if(yych <= '.')	goto yy3;
		goto yy144;
	} else {
		if(yych <= '_'){
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych >= '{')	goto yy3;
			goto yy151;
		}
	}
yy151:
	YYDEBUG(151, *YYCURSOR);
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy152;
yy152:
	YYDEBUG(152, *YYCURSOR);
	if(yych <= '^'){
		if(yych == '/')	goto yy144;
		goto yy53;
	} else {
		if(yych <= '_')	goto yy144;
		if(yych <= '`')	goto yy53;
		if(yych <= 'z')	goto yy151;
		goto yy53;
	}
yy153:
	YYDEBUG(153, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Z')	goto yy137;
		if(yych <= '`')	goto yy3;
		if(yych <= 'z')	goto yy137;
		goto yy3;
	}
yy154:
	YYDEBUG(154, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy3;
				goto yy57;
			} else {
				if(yych <= '9'){
					if(yych <= '/')	goto yy3;
					goto yy156;
				} else {
					if(yych <= ':')	goto yy157;
					if(yych <= 'C')	goto yy3;
					goto yy57;
				}
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy57;
				if(yych <= 'G')	goto yy3;
				goto yy57;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy3;
					goto yy57;
				} else {
					if(yych <= 'R')	goto yy3;
					if(yych <= 'T')	goto yy57;
					goto yy3;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy3;
				if(yych <= 'Y')	goto yy57;
				goto yy3;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy57;
					goto yy3;
				} else {
					if(yych == 'g')	goto yy3;
					goto yy57;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy3;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy3;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy3;
				}
			}
		}
	}
yy155:
	YYDEBUG(155, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= ':'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy3;
				goto yy57;
			} else {
				if(yych <= '3'){
					if(yych <= '/')	goto yy3;
					goto yy156;
				} else {
					if(yych <= '5')	goto yy158;
					if(yych <= '9')	goto yy159;
					goto yy157;
				}
			}
		} else {
			if(yych <= 'G'){
				if(yych <= 'D'){
					if(yych <= 'C')	goto yy3;
					goto yy57;
				} else {
					if(yych == 'F')	goto yy57;
					goto yy3;
				}
			} else {
				if(yych <= 'L'){
					if(yych <= 'H')	goto yy57;
					goto yy3;
				} else {
					if(yych <= 'M')	goto yy57;
					if(yych <= 'R')	goto yy3;
					goto yy57;
				}
			}
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Y'){
				if(yych == 'W')	goto yy57;
				if(yych <= 'X')	goto yy3;
				goto yy57;
			} else {
				if(yych <= 'd'){
					if(yych <= 'c')	goto yy3;
					goto yy57;
				} else {
					if(yych == 'f')	goto yy57;
					goto yy3;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'l'){
					if(yych <= 'h')	goto yy57;
					goto yy3;
				} else {
					if(yych <= 'm')	goto yy57;
					if(yych <= 'r')	goto yy3;
					goto yy57;
				}
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy3;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy3;
				}
			}
		}
	}
yy156:
	YYDEBUG(156, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= 'C'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy3;
				goto yy57;
			} else {
				if(yych <= '5'){
					if(yych <= '/')	goto yy3;
					goto yy158;
				} else {
					if(yych <= '9')	goto yy159;
					if(yych >= ';')	goto yy3;
					goto yy157;
				}
			}
		} else {
			if(yych <= 'G'){
				if(yych == 'E')	goto yy3;
				if(yych <= 'F')	goto yy57;
				goto yy3;
			} else {
				if(yych <= 'L'){
					if(yych <= 'H')	goto yy57;
					goto yy3;
				} else {
					if(yych <= 'M')	goto yy57;
					if(yych <= 'R')	goto yy3;
					goto yy57;
				}
			}
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Y'){
				if(yych == 'W')	goto yy57;
				if(yych <= 'X')	goto yy3;
				goto yy57;
			} else {
				if(yych <= 'd'){
					if(yych <= 'c')	goto yy3;
					goto yy57;
				} else {
					if(yych == 'f')	goto yy57;
					goto yy3;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'l'){
					if(yych <= 'h')	goto yy57;
					goto yy3;
				} else {
					if(yych <= 'm')	goto yy57;
					if(yych <= 'r')	goto yy3;
					goto yy57;
				}
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy3;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy3;
				}
			}
		}
	}
yy157:
	YYDEBUG(157, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy3;
	if(yych <= '5')	goto yy160;
	if(yych <= '9')	goto yy136;
	goto yy3;
yy158:
	YYDEBUG(158, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy3;
				goto yy57;
			} else {
				if(yych <= '/')	goto yy3;
				if(yych <= '9')	goto yy159;
				if(yych <= 'C')	goto yy3;
				goto yy57;
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy57;
				if(yych <= 'G')	goto yy3;
				goto yy57;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy3;
					goto yy57;
				} else {
					if(yych <= 'R')	goto yy3;
					if(yych <= 'T')	goto yy57;
					goto yy3;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy3;
				if(yych <= 'Y')	goto yy57;
				goto yy3;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy57;
					goto yy3;
				} else {
					if(yych == 'g')	goto yy3;
					goto yy57;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy3;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy3;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy3;
				}
			}
		}
	}
yy159:
	YYDEBUG(159, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 8) {
		goto yy51;
	}
	if(yych <= 'W'){
		if(yych <= 'F'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy3;
				goto yy57;
			} else {
				if(yych == 'D')	goto yy57;
				if(yych <= 'E')	goto yy3;
				goto yy57;
			}
		} else {
			if(yych <= 'M'){
				if(yych == 'H')	goto yy57;
				if(yych <= 'L')	goto yy3;
				goto yy57;
			} else {
				if(yych <= 'R')	goto yy3;
				if(yych <= 'T')	goto yy57;
				if(yych <= 'V')	goto yy3;
				goto yy57;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'd'){
				if(yych == 'Y')	goto yy57;
				if(yych <= 'c')	goto yy3;
				goto yy57;
			} else {
				if(yych == 'f')	goto yy57;
				if(yych <= 'g')	goto yy3;
				goto yy57;
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy3;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy3;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy3;
				}
			}
		}
	}
yy160:
	YYDEBUG(160, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy3;
	if(yych <= '9')	goto yy136;
	goto yy3;
yy161:
	YYDEBUG(161, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy138;
			goto yy162;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'e')	goto yy162;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy162:
	YYDEBUG(162, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'V'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'U')	goto yy139;
			goto yy163;
		}
	} else {
		if(yych <= 'u'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'v')	goto yy163;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy163:
	YYDEBUG(163, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'I'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'H')	goto yy140;
			goto yy164;
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'i')	goto yy164;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy164:
	YYDEBUG(164, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy141;
			goto yy165;
		}
	} else {
		if(yych <= 'n'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'o')	goto yy165;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy165:
	YYDEBUG(165, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'U')	goto yy166;
		if(yych != 'u')	goto yy3;
		goto yy166;
	}
yy166:
	YYDEBUG(166, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy167;
	if(yych != 's')	goto yy53;
	goto yy167;
yy167:
	YYDEBUG(167, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 11) YYFILL(11);
	yych = *YYCURSOR;
	goto yy168;
yy168:
	YYDEBUG(168, *YYCURSOR);
	if(yych <= 'W'){
		if(yych <= 'F'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy167;
				if(yych <= 0x1F)	goto yy53;
				goto yy167;
			} else {
				if(yych == 'D')	goto yy172;
				if(yych <= 'E')	goto yy53;
				goto yy174;
			}
		} else {
			if(yych <= 'M'){
				if(yych == 'H')	goto yy171;
				if(yych <= 'L')	goto yy53;
				goto yy170;
			} else {
				if(yych <= 'S'){
					if(yych <= 'R')	goto yy53;
					goto yy169;
				} else {
					if(yych <= 'T')	goto yy176;
					if(yych <= 'V')	goto yy53;
					goto yy173;
				}
			}
		}
	} else {
		if(yych <= 'l'){
			if(yych <= 'd'){
				if(yych == 'Y')	goto yy175;
				if(yych <= 'c')	goto yy53;
				goto yy172;
			} else {
				if(yych <= 'f'){
					if(yych <= 'e')	goto yy53;
					goto yy174;
				} else {
					if(yych == 'h')	goto yy171;
					goto yy53;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'm')	goto yy170;
				if(yych <= 'r')	goto yy53;
				if(yych >= 't')	goto yy176;
				goto yy169;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy53;
					goto yy173;
				} else {
					if(yych == 'y')	goto yy175;
					goto yy53;
				}
			}
		}
	}
yy169:
	YYDEBUG(169, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'D'){
			if(yych == 'A')	goto yy234;
			goto yy53;
		} else {
			if(yych <= 'E')	goto yy235;
			if(yych <= 'T')	goto yy53;
			goto yy233;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'a')	goto yy234;
			goto yy53;
		} else {
			if(yych <= 'e')	goto yy235;
			if(yych == 'u')	goto yy233;
			goto yy53;
		}
	}
yy170:
	YYDEBUG(170, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych == 'I')	goto yy225;
		if(yych <= 'N')	goto yy53;
		goto yy224;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy53;
			goto yy225;
		} else {
			if(yych == 'o')	goto yy224;
			goto yy53;
		}
	}
yy171:
	YYDEBUG(171, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy222;
	if(yych == 'o')	goto yy222;
	goto yy53;
yy172:
	YYDEBUG(172, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy221;
	if(yych == 'a')	goto yy221;
	goto yy53;
yy173:
	YYDEBUG(173, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy209;
	if(yych == 'e')	goto yy209;
	goto yy53;
yy174:
	YYDEBUG(174, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych == 'O')	goto yy194;
		if(yych <= 'Q')	goto yy53;
		goto yy193;
	} else {
		if(yych <= 'o'){
			if(yych <= 'n')	goto yy53;
			goto yy194;
		} else {
			if(yych == 'r')	goto yy193;
			goto yy53;
		}
	}
yy175:
	YYDEBUG(175, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy190;
	if(yych == 'e')	goto yy190;
	goto yy53;
yy176:
	YYDEBUG(176, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'H')	goto yy177;
		if(yych <= 'T')	goto yy53;
		goto yy178;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy53;
			goto yy177;
		} else {
			if(yych == 'u')	goto yy178;
			goto yy53;
		}
	}
yy177:
	YYDEBUG(177, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy185;
	if(yych == 'u')	goto yy185;
	goto yy53;
yy178:
	YYDEBUG(178, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy179;
	if(yych != 'e')	goto yy53;
	goto yy179;
yy179:
	YYDEBUG(179, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'S')	goto yy181;
	if(yych == 's')	goto yy181;
	goto yy180;
yy180:
	YYDEBUG(180, *YYCURSOR);

{
		timelib_sll i;
		int         behavior = 0;
		DEBUG_OUTPUT("relativetext");
		TIMELIB_INIT;
		TIMELIB_HAVE_RELATIVE();

		while(*ptr) {
			i = timelib_get_relative_text((char **) &ptr, &behavior);
			timelib_eat_spaces((char **) &ptr);
			timelib_set_relative((char **) &ptr, i, behavior, s);
		}
		TIMELIB_DEINIT;
		return TIMELIB_RELATIVE;
	}
yy181:
	YYDEBUG(181, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy182;
	if(yych != 'd')	goto yy53;
	goto yy182;
yy182:
	YYDEBUG(182, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy183;
	if(yych != 'a')	goto yy53;
	goto yy183;
yy183:
	YYDEBUG(183, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych != 'y')	goto yy53;
	goto yy184;
yy184:
	YYDEBUG(184, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy180;
yy185:
	YYDEBUG(185, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'R')	goto yy186;
	if(yych != 'r')	goto yy180;
	goto yy186;
yy186:
	YYDEBUG(186, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy187;
	if(yych != 's')	goto yy53;
	goto yy187;
yy187:
	YYDEBUG(187, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy188;
	if(yych != 'd')	goto yy53;
	goto yy188;
yy188:
	YYDEBUG(188, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy189;
	if(yych != 'a')	goto yy53;
	goto yy189;
yy189:
	YYDEBUG(189, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy184;
	goto yy53;
yy190:
	YYDEBUG(190, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy191;
	if(yych != 'a')	goto yy53;
	goto yy191;
yy191:
	YYDEBUG(191, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy192;
	if(yych != 'r')	goto yy53;
	goto yy192;
yy192:
	YYDEBUG(192, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy184;
	if(yych == 's')	goto yy184;
	goto yy180;
yy193:
	YYDEBUG(193, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy206;
	if(yych == 'i')	goto yy206;
	goto yy53;
yy194:
	YYDEBUG(194, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy195;
	if(yych != 'r')	goto yy53;
	goto yy195;
yy195:
	YYDEBUG(195, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy196;
	if(yych != 't')	goto yy53;
	goto yy196;
yy196:
	YYDEBUG(196, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'H')	goto yy198;
		if(yych <= 'M')	goto yy53;
		goto yy197;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy53;
			goto yy198;
		} else {
			if(yych != 'n')	goto yy53;
			goto yy197;
		}
	}
yy197:
	YYDEBUG(197, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy203;
	if(yych == 'i')	goto yy203;
	goto yy53;
yy198:
	YYDEBUG(198, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy199;
	if(yych != 'n')	goto yy53;
	goto yy199;
yy199:
	YYDEBUG(199, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy200;
	if(yych != 'i')	goto yy53;
	goto yy200;
yy200:
	YYDEBUG(200, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy201;
	if(yych != 'g')	goto yy53;
	goto yy201;
yy201:
	YYDEBUG(201, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy202;
	if(yych != 'h')	goto yy53;
	goto yy202;
yy202:
	YYDEBUG(202, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy192;
	if(yych == 't')	goto yy192;
	goto yy53;
yy203:
	YYDEBUG(203, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy204;
	if(yych != 'g')	goto yy53;
	goto yy204;
yy204:
	YYDEBUG(204, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy205;
	if(yych != 'h')	goto yy53;
	goto yy205;
yy205:
	YYDEBUG(205, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy192;
	if(yych == 't')	goto yy192;
	goto yy53;
yy206:
	YYDEBUG(206, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'D')	goto yy207;
	if(yych != 'd')	goto yy180;
	goto yy207;
yy207:
	YYDEBUG(207, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy208;
	if(yych != 'a')	goto yy53;
	goto yy208;
yy208:
	YYDEBUG(208, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy184;
	goto yy53;
yy209:
	YYDEBUG(209, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= 'C')	goto yy53;
		if(yych <= 'D')	goto yy211;
		goto yy210;
	} else {
		if(yych <= 'c')	goto yy53;
		if(yych <= 'd')	goto yy211;
		if(yych >= 'f')	goto yy53;
		goto yy210;
	}
yy210:
	YYDEBUG(210, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy217;
	if(yych == 'k')	goto yy217;
	goto yy53;
yy211:
	YYDEBUG(211, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'N')	goto yy212;
	if(yych != 'n')	goto yy180;
	goto yy212;
yy212:
	YYDEBUG(212, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy213;
	if(yych != 'e')	goto yy53;
	goto yy213;
yy213:
	YYDEBUG(213, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy214;
	if(yych != 's')	goto yy53;
	goto yy214;
yy214:
	YYDEBUG(214, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy215;
	if(yych != 'd')	goto yy53;
	goto yy215;
yy215:
	YYDEBUG(215, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy216;
	if(yych != 'a')	goto yy53;
	goto yy216;
yy216:
	YYDEBUG(216, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy184;
	goto yy53;
yy217:
	YYDEBUG(217, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych == 'D')	goto yy218;
		if(yych <= 'R')	goto yy180;
		goto yy184;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy180;
			goto yy218;
		} else {
			if(yych == 's')	goto yy184;
			goto yy180;
		}
	}
yy218:
	YYDEBUG(218, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy219;
	if(yych != 'a')	goto yy53;
	goto yy219;
yy219:
	YYDEBUG(219, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy220;
	if(yych != 'y')	goto yy53;
	goto yy220;
yy220:
	YYDEBUG(220, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy184;
	if(yych == 's')	goto yy184;
	goto yy180;
yy221:
	YYDEBUG(221, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy192;
	if(yych == 'y')	goto yy192;
	goto yy53;
yy222:
	YYDEBUG(222, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy223;
	if(yych != 'u')	goto yy53;
	goto yy223;
yy223:
	YYDEBUG(223, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy192;
	if(yych == 'r')	goto yy192;
	goto yy53;
yy224:
	YYDEBUG(224, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy229;
	if(yych == 'n')	goto yy229;
	goto yy53;
yy225:
	YYDEBUG(225, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy226;
	if(yych != 'n')	goto yy53;
	goto yy226;
yy226:
	YYDEBUG(226, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych == 'S')	goto yy184;
		if(yych <= 'T')	goto yy180;
		goto yy227;
	} else {
		if(yych <= 's'){
			if(yych <= 'r')	goto yy180;
			goto yy184;
		} else {
			if(yych != 'u')	goto yy180;
			goto yy227;
		}
	}
yy227:
	YYDEBUG(227, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy228;
	if(yych != 't')	goto yy53;
	goto yy228;
yy228:
	YYDEBUG(228, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy192;
	if(yych == 'e')	goto yy192;
	goto yy53;
yy229:
	YYDEBUG(229, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych == 'D')	goto yy230;
		if(yych <= 'S')	goto yy180;
		goto yy231;
	} else {
		if(yych <= 'd'){
			if(yych <= 'c')	goto yy180;
			goto yy230;
		} else {
			if(yych == 't')	goto yy231;
			goto yy180;
		}
	}
yy230:
	YYDEBUG(230, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy232;
	if(yych == 'a')	goto yy232;
	goto yy53;
yy231:
	YYDEBUG(231, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy192;
	if(yych == 'h')	goto yy192;
	goto yy53;
yy232:
	YYDEBUG(232, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy184;
	goto yy53;
yy233:
	YYDEBUG(233, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy244;
	if(yych == 'n')	goto yy244;
	goto yy53;
yy234:
	YYDEBUG(234, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy239;
	if(yych == 't')	goto yy239;
	goto yy53;
yy235:
	YYDEBUG(235, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy236;
	if(yych != 'c')	goto yy53;
	goto yy236;
yy236:
	YYDEBUG(236, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych == 'O')	goto yy237;
		if(yych <= 'R')	goto yy180;
		goto yy184;
	} else {
		if(yych <= 'o'){
			if(yych <= 'n')	goto yy180;
			goto yy237;
		} else {
			if(yych == 's')	goto yy184;
			goto yy180;
		}
	}
yy237:
	YYDEBUG(237, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy238;
	if(yych != 'n')	goto yy53;
	goto yy238;
yy238:
	YYDEBUG(238, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy192;
	if(yych == 'd')	goto yy192;
	goto yy53;
yy239:
	YYDEBUG(239, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'U')	goto yy240;
	if(yych != 'u')	goto yy180;
	goto yy240;
yy240:
	YYDEBUG(240, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy241;
	if(yych != 'r')	goto yy53;
	goto yy241;
yy241:
	YYDEBUG(241, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy242;
	if(yych != 'd')	goto yy53;
	goto yy242;
yy242:
	YYDEBUG(242, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy243;
	if(yych != 'a')	goto yy53;
	goto yy243;
yy243:
	YYDEBUG(243, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy184;
	goto yy53;
yy244:
	YYDEBUG(244, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'D')	goto yy245;
	if(yych != 'd')	goto yy180;
	goto yy245;
yy245:
	YYDEBUG(245, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy246;
	if(yych != 'a')	goto yy53;
	goto yy246;
yy246:
	YYDEBUG(246, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy184;
	goto yy53;
yy247:
	YYDEBUG(247, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy138;
			goto yy162;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy248;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy248:
	YYDEBUG(248, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'U')	goto yy139;
			goto yy163;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'v')	goto yy249;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy249:
	YYDEBUG(249, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'I'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'H')	goto yy140;
			goto yy164;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'i')	goto yy250;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy250:
	YYDEBUG(250, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'O'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy141;
			goto yy165;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'o')	goto yy251;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy251:
	YYDEBUG(251, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'T')	goto yy3;
			goto yy166;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'u')	goto yy252;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy252:
	YYDEBUG(252, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy53;
			goto yy144;
		} else {
			if(yych == 'S')	goto yy167;
			goto yy53;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy53;
			goto yy151;
		} else {
			if(yych <= 's')	goto yy253;
			if(yych <= 'z')	goto yy151;
			goto yy53;
		}
	}
yy253:
	YYDEBUG(253, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'h'){
		if(yych <= '`'){
			if(yych <= '/'){
				if(yych <= '.')	goto yy168;
				goto yy144;
			} else {
				if(yych == '_')	goto yy144;
				goto yy168;
			}
		} else {
			if(yych <= 'e'){
				if(yych == 'd')	goto yy257;
				goto yy151;
			} else {
				if(yych <= 'f')	goto yy259;
				if(yych <= 'g')	goto yy151;
				goto yy256;
			}
		}
	} else {
		if(yych <= 't'){
			if(yych <= 'm'){
				if(yych <= 'l')	goto yy151;
				goto yy255;
			} else {
				if(yych <= 'r')	goto yy151;
				if(yych >= 't')	goto yy261;
				goto yy254;
			}
		} else {
			if(yych <= 'x'){
				if(yych == 'w')	goto yy258;
				goto yy151;
			} else {
				if(yych <= 'y')	goto yy260;
				if(yych <= 'z')	goto yy151;
				goto yy168;
			}
		}
	}
yy254:
	YYDEBUG(254, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'D'){
			if(yych == 'A')	goto yy234;
			goto yy152;
		} else {
			if(yych <= 'E')	goto yy235;
			if(yych <= 'T')	goto yy152;
			goto yy233;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'a')	goto yy317;
			goto yy152;
		} else {
			if(yych <= 'e')	goto yy318;
			if(yych == 'u')	goto yy319;
			goto yy152;
		}
	}
yy255:
	YYDEBUG(255, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych == 'I')	goto yy225;
		if(yych <= 'N')	goto yy152;
		goto yy224;
	} else {
		if(yych <= 'i'){
			if(yych <= 'h')	goto yy152;
			goto yy308;
		} else {
			if(yych == 'o')	goto yy309;
			goto yy152;
		}
	}
yy256:
	YYDEBUG(256, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy222;
	if(yych == 'o')	goto yy306;
	goto yy152;
yy257:
	YYDEBUG(257, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy221;
	if(yych == 'a')	goto yy305;
	goto yy152;
yy258:
	YYDEBUG(258, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy209;
	if(yych == 'e')	goto yy293;
	goto yy152;
yy259:
	YYDEBUG(259, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych == 'O')	goto yy194;
		if(yych <= 'Q')	goto yy152;
		goto yy193;
	} else {
		if(yych <= 'o'){
			if(yych <= 'n')	goto yy152;
			goto yy277;
		} else {
			if(yych == 'r')	goto yy278;
			goto yy152;
		}
	}
yy260:
	YYDEBUG(260, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy190;
	if(yych == 'e')	goto yy274;
	goto yy152;
yy261:
	YYDEBUG(261, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'H')	goto yy177;
		if(yych <= 'T')	goto yy152;
		goto yy178;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy152;
			goto yy262;
		} else {
			if(yych == 'u')	goto yy263;
			goto yy152;
		}
	}
yy262:
	YYDEBUG(262, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy185;
	if(yych == 'u')	goto yy269;
	goto yy152;
yy263:
	YYDEBUG(263, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy179;
	if(yych != 'e')	goto yy152;
	goto yy264;
yy264:
	YYDEBUG(264, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy180;
			goto yy144;
		} else {
			if(yych == 'S')	goto yy181;
			goto yy180;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			goto yy151;
		} else {
			if(yych <= 's')	goto yy265;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy265:
	YYDEBUG(265, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy182;
	if(yych != 'd')	goto yy152;
	goto yy266;
yy266:
	YYDEBUG(266, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy183;
	if(yych != 'a')	goto yy152;
	goto yy267;
yy267:
	YYDEBUG(267, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych != 'y')	goto yy152;
	goto yy268;
yy268:
	YYDEBUG(268, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych == '/')	goto yy144;
		goto yy180;
	} else {
		if(yych <= '_')	goto yy144;
		if(yych <= '`')	goto yy180;
		if(yych <= 'z')	goto yy151;
		goto yy180;
	}
yy269:
	YYDEBUG(269, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy180;
			goto yy144;
		} else {
			if(yych == 'R')	goto yy186;
			goto yy180;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			goto yy151;
		} else {
			if(yych <= 'r')	goto yy270;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy270:
	YYDEBUG(270, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy187;
	if(yych != 's')	goto yy152;
	goto yy271;
yy271:
	YYDEBUG(271, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy188;
	if(yych != 'd')	goto yy152;
	goto yy272;
yy272:
	YYDEBUG(272, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy189;
	if(yych != 'a')	goto yy152;
	goto yy273;
yy273:
	YYDEBUG(273, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy268;
	goto yy152;
yy274:
	YYDEBUG(274, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy191;
	if(yych != 'a')	goto yy152;
	goto yy275;
yy275:
	YYDEBUG(275, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy192;
	if(yych != 'r')	goto yy152;
	goto yy276;
yy276:
	YYDEBUG(276, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy180;
			goto yy144;
		} else {
			if(yych == 'S')	goto yy184;
			goto yy180;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			goto yy151;
		} else {
			if(yych <= 's')	goto yy268;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy277:
	YYDEBUG(277, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy195;
	if(yych == 'r')	goto yy282;
	goto yy152;
yy278:
	YYDEBUG(278, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy206;
	if(yych != 'i')	goto yy152;
	goto yy279;
yy279:
	YYDEBUG(279, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy180;
			goto yy144;
		} else {
			if(yych == 'D')	goto yy207;
			goto yy180;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			goto yy151;
		} else {
			if(yych <= 'd')	goto yy280;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy280:
	YYDEBUG(280, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy208;
	if(yych != 'a')	goto yy152;
	goto yy281;
yy281:
	YYDEBUG(281, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy268;
	goto yy152;
yy282:
	YYDEBUG(282, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy196;
	if(yych != 't')	goto yy152;
	goto yy283;
yy283:
	YYDEBUG(283, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'H')	goto yy198;
		if(yych <= 'M')	goto yy152;
		goto yy197;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy152;
			goto yy285;
		} else {
			if(yych != 'n')	goto yy152;
			goto yy284;
		}
	}
yy284:
	YYDEBUG(284, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy203;
	if(yych == 'i')	goto yy290;
	goto yy152;
yy285:
	YYDEBUG(285, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy199;
	if(yych != 'n')	goto yy152;
	goto yy286;
yy286:
	YYDEBUG(286, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy200;
	if(yych != 'i')	goto yy152;
	goto yy287;
yy287:
	YYDEBUG(287, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy201;
	if(yych != 'g')	goto yy152;
	goto yy288;
yy288:
	YYDEBUG(288, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy202;
	if(yych != 'h')	goto yy152;
	goto yy289;
yy289:
	YYDEBUG(289, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy192;
	if(yych == 't')	goto yy276;
	goto yy152;
yy290:
	YYDEBUG(290, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy204;
	if(yych != 'g')	goto yy152;
	goto yy291;
yy291:
	YYDEBUG(291, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy205;
	if(yych != 'h')	goto yy152;
	goto yy292;
yy292:
	YYDEBUG(292, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy192;
	if(yych == 't')	goto yy276;
	goto yy152;
yy293:
	YYDEBUG(293, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= 'C')	goto yy152;
		if(yych <= 'D')	goto yy211;
		goto yy210;
	} else {
		if(yych <= 'c')	goto yy152;
		if(yych <= 'd')	goto yy295;
		if(yych >= 'f')	goto yy152;
		goto yy294;
	}
yy294:
	YYDEBUG(294, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'K')	goto yy217;
	if(yych == 'k')	goto yy301;
	goto yy152;
yy295:
	YYDEBUG(295, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy180;
			goto yy144;
		} else {
			if(yych == 'N')	goto yy212;
			goto yy180;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			goto yy151;
		} else {
			if(yych <= 'n')	goto yy296;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy296:
	YYDEBUG(296, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy213;
	if(yych != 'e')	goto yy152;
	goto yy297;
yy297:
	YYDEBUG(297, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy214;
	if(yych != 's')	goto yy152;
	goto yy298;
yy298:
	YYDEBUG(298, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy215;
	if(yych != 'd')	goto yy152;
	goto yy299;
yy299:
	YYDEBUG(299, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy216;
	if(yych != 'a')	goto yy152;
	goto yy300;
yy300:
	YYDEBUG(300, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy268;
	goto yy152;
yy301:
	YYDEBUG(301, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= 'C'){
			if(yych == '/')	goto yy144;
			goto yy180;
		} else {
			if(yych <= 'D')	goto yy218;
			if(yych == 'S')	goto yy184;
			goto yy180;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			if(yych <= 'c')	goto yy151;
			goto yy302;
		} else {
			if(yych == 's')	goto yy268;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy302:
	YYDEBUG(302, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy219;
	if(yych != 'a')	goto yy152;
	goto yy303;
yy303:
	YYDEBUG(303, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy220;
	if(yych != 'y')	goto yy152;
	goto yy304;
yy304:
	YYDEBUG(304, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy180;
			goto yy144;
		} else {
			if(yych == 'S')	goto yy184;
			goto yy180;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			goto yy151;
		} else {
			if(yych <= 's')	goto yy268;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy305:
	YYDEBUG(305, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy192;
	if(yych == 'y')	goto yy276;
	goto yy152;
yy306:
	YYDEBUG(306, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy223;
	if(yych != 'u')	goto yy152;
	goto yy307;
yy307:
	YYDEBUG(307, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy192;
	if(yych == 'r')	goto yy276;
	goto yy152;
yy308:
	YYDEBUG(308, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy226;
	if(yych == 'n')	goto yy314;
	goto yy152;
yy309:
	YYDEBUG(309, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy229;
	if(yych != 'n')	goto yy152;
	goto yy310;
yy310:
	YYDEBUG(310, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= 'C'){
			if(yych == '/')	goto yy144;
			goto yy180;
		} else {
			if(yych <= 'D')	goto yy230;
			if(yych == 'T')	goto yy231;
			goto yy180;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			if(yych <= 'c')	goto yy151;
			goto yy311;
		} else {
			if(yych == 't')	goto yy312;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy311:
	YYDEBUG(311, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy232;
	if(yych == 'a')	goto yy313;
	goto yy152;
yy312:
	YYDEBUG(312, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy192;
	if(yych == 'h')	goto yy276;
	goto yy152;
yy313:
	YYDEBUG(313, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy268;
	goto yy152;
yy314:
	YYDEBUG(314, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= 'R'){
			if(yych == '/')	goto yy144;
			goto yy180;
		} else {
			if(yych <= 'S')	goto yy184;
			if(yych == 'U')	goto yy227;
			goto yy180;
		}
	} else {
		if(yych <= 's'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			if(yych <= 'r')	goto yy151;
			goto yy268;
		} else {
			if(yych == 'u')	goto yy315;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy315:
	YYDEBUG(315, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy228;
	if(yych != 't')	goto yy152;
	goto yy316;
yy316:
	YYDEBUG(316, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy192;
	if(yych == 'e')	goto yy276;
	goto yy152;
yy317:
	YYDEBUG(317, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy239;
	if(yych == 't')	goto yy326;
	goto yy152;
yy318:
	YYDEBUG(318, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy236;
	if(yych == 'c')	goto yy323;
	goto yy152;
yy319:
	YYDEBUG(319, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy244;
	if(yych != 'n')	goto yy152;
	goto yy320;
yy320:
	YYDEBUG(320, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy180;
			goto yy144;
		} else {
			if(yych == 'D')	goto yy245;
			goto yy180;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			goto yy151;
		} else {
			if(yych <= 'd')	goto yy321;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy321:
	YYDEBUG(321, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy246;
	if(yych != 'a')	goto yy152;
	goto yy322;
yy322:
	YYDEBUG(322, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy268;
	goto yy152;
yy323:
	YYDEBUG(323, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= 'N'){
			if(yych == '/')	goto yy144;
			goto yy180;
		} else {
			if(yych <= 'O')	goto yy237;
			if(yych == 'S')	goto yy184;
			goto yy180;
		}
	} else {
		if(yych <= 'o'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			if(yych <= 'n')	goto yy151;
			goto yy324;
		} else {
			if(yych == 's')	goto yy268;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy324:
	YYDEBUG(324, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy238;
	if(yych != 'n')	goto yy152;
	goto yy325;
yy325:
	YYDEBUG(325, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy192;
	if(yych == 'd')	goto yy276;
	goto yy152;
yy326:
	YYDEBUG(326, *YYCURSOR);
	yyaccept = 4;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy180;
			goto yy144;
		} else {
			if(yych == 'U')	goto yy240;
			goto yy180;
		}
	} else {
		if(yych <= 't'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy180;
			goto yy151;
		} else {
			if(yych <= 'u')	goto yy327;
			if(yych <= 'z')	goto yy151;
			goto yy180;
		}
	}
yy327:
	YYDEBUG(327, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy241;
	if(yych != 'r')	goto yy152;
	goto yy328;
yy328:
	YYDEBUG(328, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy242;
	if(yych != 'd')	goto yy152;
	goto yy329;
yy329:
	YYDEBUG(329, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy243;
	if(yych != 'a')	goto yy152;
	goto yy330;
yy330:
	YYDEBUG(330, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy184;
	if(yych == 'y')	goto yy268;
	goto yy152;
yy331:
	YYDEBUG(331, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy138;
			goto yy332;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 's')	goto yy332;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy332:
	YYDEBUG(332, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy333;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 't')	goto yy333;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy333:
	YYDEBUG(333, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	goto yy167;
	case ')':	goto yy136;
	case 'A':
	case 'B':
	case 'C':	case 'E':	case 'G':	case 'I':
	case 'J':
	case 'K':
	case 'L':	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':	case 'U':
	case 'V':	case 'X':	case 'Z':	case 'a':
	case 'b':
	case 'c':	case 'e':	case 'g':	case 'i':
	case 'j':
	case 'k':
	case 'l':	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':	case 'u':
	case 'v':	case 'x':	case 'z':	goto yy140;
	case 'D':	case 'd':	goto yy337;
	case 'F':	case 'f':	goto yy339;
	case 'H':	case 'h':	goto yy336;
	case 'M':	case 'm':	goto yy335;
	case 'S':	case 's':	goto yy334;
	case 'T':	case 't':	goto yy341;
	case 'W':	case 'w':	goto yy338;
	case 'Y':	case 'y':	goto yy340;
	default:	goto yy3;
	}
yy334:
	YYDEBUG(334, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'A'){
			if(yych == ')')	goto yy136;
			if(yych <= '@')	goto yy3;
			goto yy352;
		} else {
			if(yych == 'E')	goto yy353;
			if(yych <= 'T')	goto yy141;
			goto yy354;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy352;
			goto yy141;
		} else {
			if(yych <= 't'){
				if(yych <= 'e')	goto yy353;
				goto yy141;
			} else {
				if(yych <= 'u')	goto yy354;
				if(yych <= 'z')	goto yy141;
				goto yy3;
			}
		}
	}
yy335:
	YYDEBUG(335, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'I')	goto yy350;
			if(yych <= 'N')	goto yy141;
			goto yy351;
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			if(yych <= 'h')	goto yy141;
			goto yy350;
		} else {
			if(yych == 'o')	goto yy351;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy336:
	YYDEBUG(336, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy141;
			goto yy349;
		}
	} else {
		if(yych <= 'n'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'o')	goto yy349;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy337:
	YYDEBUG(337, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy348;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy348;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy338:
	YYDEBUG(338, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy141;
			goto yy347;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'e')	goto yy347;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy339:
	YYDEBUG(339, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'O')	goto yy345;
			if(yych <= 'Q')	goto yy141;
			goto yy346;
		}
	} else {
		if(yych <= 'o'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			if(yych <= 'n')	goto yy141;
			goto yy345;
		} else {
			if(yych == 'r')	goto yy346;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy340:
	YYDEBUG(340, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy141;
			goto yy344;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'e')	goto yy344;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy341:
	YYDEBUG(341, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'H')	goto yy342;
			if(yych <= 'T')	goto yy141;
			goto yy343;
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			if(yych <= 'g')	goto yy141;
			goto yy342;
		} else {
			if(yych == 'u')	goto yy343;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy342:
	YYDEBUG(342, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'U')	goto yy185;
		if(yych == 'u')	goto yy185;
		goto yy3;
	}
yy343:
	YYDEBUG(343, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'E')	goto yy179;
		if(yych == 'e')	goto yy179;
		goto yy3;
	}
yy344:
	YYDEBUG(344, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'A')	goto yy191;
		if(yych == 'a')	goto yy191;
		goto yy3;
	}
yy345:
	YYDEBUG(345, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Q'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'R')	goto yy195;
		if(yych == 'r')	goto yy195;
		goto yy3;
	}
yy346:
	YYDEBUG(346, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'I')	goto yy206;
		if(yych == 'i')	goto yy206;
		goto yy3;
	}
yy347:
	YYDEBUG(347, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych == ')')	goto yy136;
		if(yych <= 'C')	goto yy3;
		goto yy211;
	} else {
		if(yych <= 'c'){
			if(yych <= 'E')	goto yy210;
			goto yy3;
		} else {
			if(yych <= 'd')	goto yy211;
			if(yych <= 'e')	goto yy210;
			goto yy3;
		}
	}
yy348:
	YYDEBUG(348, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Y')	goto yy192;
		if(yych == 'y')	goto yy192;
		goto yy3;
	}
yy349:
	YYDEBUG(349, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'U')	goto yy223;
		if(yych == 'u')	goto yy223;
		goto yy3;
	}
yy350:
	YYDEBUG(350, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'N')	goto yy226;
		if(yych == 'n')	goto yy226;
		goto yy3;
	}
yy351:
	YYDEBUG(351, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'N')	goto yy229;
		if(yych == 'n')	goto yy229;
		goto yy3;
	}
yy352:
	YYDEBUG(352, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'T')	goto yy239;
		if(yych == 't')	goto yy239;
		goto yy3;
	}
yy353:
	YYDEBUG(353, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'B'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'C')	goto yy236;
		if(yych == 'c')	goto yy236;
		goto yy3;
	}
yy354:
	YYDEBUG(354, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'N')	goto yy244;
		if(yych == 'n')	goto yy244;
		goto yy3;
	}
yy355:
	YYDEBUG(355, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy138;
			goto yy332;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 's')	goto yy356;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy356:
	YYDEBUG(356, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy333;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy357;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy357:
	YYDEBUG(357, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	goto yy167;
	case ')':	goto yy136;
	case '/':	case '_':	goto yy144;
	case 'A':
	case 'B':
	case 'C':	case 'E':	case 'G':	case 'I':
	case 'J':
	case 'K':
	case 'L':	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':	case 'U':
	case 'V':	case 'X':	case 'Z':	goto yy140;
	case 'D':	goto yy337;
	case 'F':	goto yy339;
	case 'H':	goto yy336;
	case 'M':	goto yy335;
	case 'S':	goto yy334;
	case 'T':	goto yy341;
	case 'W':	goto yy338;
	case 'Y':	goto yy340;
	case 'a':
	case 'b':
	case 'c':	case 'e':	case 'g':	case 'i':
	case 'j':
	case 'k':
	case 'l':	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':	case 'u':
	case 'v':	case 'x':	case 'z':	goto yy149;
	case 'd':	goto yy361;
	case 'f':	goto yy363;
	case 'h':	goto yy360;
	case 'm':	goto yy359;
	case 's':	goto yy358;
	case 't':	goto yy365;
	case 'w':	goto yy362;
	case 'y':	goto yy364;
	default:	goto yy3;
	}
yy358:
	YYDEBUG(358, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '@'){
			if(yych <= ')'){
				if(yych <= '(')	goto yy3;
				goto yy136;
			} else {
				if(yych == '/')	goto yy144;
				goto yy3;
			}
		} else {
			if(yych <= 'D'){
				if(yych <= 'A')	goto yy352;
				goto yy141;
			} else {
				if(yych <= 'E')	goto yy353;
				if(yych <= 'T')	goto yy141;
				goto yy354;
			}
		}
	} else {
		if(yych <= 'a'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy141;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy376;
			}
		} else {
			if(yych <= 't'){
				if(yych == 'e')	goto yy377;
				goto yy150;
			} else {
				if(yych <= 'u')	goto yy378;
				if(yych <= 'z')	goto yy150;
				goto yy3;
			}
		}
	}
yy359:
	YYDEBUG(359, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'O'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= 'H'){
				if(yych <= '@')	goto yy3;
				goto yy141;
			} else {
				if(yych <= 'I')	goto yy350;
				if(yych <= 'N')	goto yy141;
				goto yy351;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy141;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy150;
			}
		} else {
			if(yych <= 'n'){
				if(yych <= 'i')	goto yy374;
				goto yy150;
			} else {
				if(yych <= 'o')	goto yy375;
				if(yych <= 'z')	goto yy150;
				goto yy3;
			}
		}
	}
yy360:
	YYDEBUG(360, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'O'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy141;
			goto yy349;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'o')	goto yy373;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy361:
	YYDEBUG(361, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy348;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy372;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy362:
	YYDEBUG(362, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy141;
			goto yy347;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy371;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy363:
	YYDEBUG(363, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= 'N'){
				if(yych <= '@')	goto yy3;
				goto yy141;
			} else {
				if(yych <= 'O')	goto yy345;
				if(yych <= 'Q')	goto yy141;
				goto yy346;
			}
		}
	} else {
		if(yych <= 'n'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy141;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy150;
			}
		} else {
			if(yych <= 'q'){
				if(yych <= 'o')	goto yy369;
				goto yy150;
			} else {
				if(yych <= 'r')	goto yy370;
				if(yych <= 'z')	goto yy150;
				goto yy3;
			}
		}
	}
yy364:
	YYDEBUG(364, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy141;
			goto yy344;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy368;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy365:
	YYDEBUG(365, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= 'G'){
				if(yych <= '@')	goto yy3;
				goto yy141;
			} else {
				if(yych <= 'H')	goto yy342;
				if(yych <= 'T')	goto yy141;
				goto yy343;
			}
		}
	} else {
		if(yych <= 'g'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy141;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy150;
			}
		} else {
			if(yych <= 't'){
				if(yych >= 'i')	goto yy150;
				goto yy366;
			} else {
				if(yych <= 'u')	goto yy367;
				if(yych <= 'z')	goto yy150;
				goto yy3;
			}
		}
	}
yy366:
	YYDEBUG(366, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'T')	goto yy3;
			goto yy185;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'u')	goto yy269;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy367:
	YYDEBUG(367, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'D')	goto yy3;
			goto yy179;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy264;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy368:
	YYDEBUG(368, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy191;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy275;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy369:
	YYDEBUG(369, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'Q')	goto yy3;
			goto yy195;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy282;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy370:
	YYDEBUG(370, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'I'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'H')	goto yy3;
			goto yy206;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'i')	goto yy279;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy371:
	YYDEBUG(371, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'C')	goto yy3;
			if(yych <= 'D')	goto yy211;
			goto yy210;
		}
	} else {
		if(yych <= 'c'){
			if(yych == '_')	goto yy144;
			if(yych <= '`')	goto yy3;
			goto yy151;
		} else {
			if(yych <= 'd')	goto yy295;
			if(yych <= 'e')	goto yy294;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy372:
	YYDEBUG(372, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Y'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'X')	goto yy3;
			goto yy192;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'y')	goto yy276;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy373:
	YYDEBUG(373, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'T')	goto yy3;
			goto yy223;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'u')	goto yy307;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy374:
	YYDEBUG(374, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'M')	goto yy3;
			goto yy226;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy314;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy375:
	YYDEBUG(375, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'M')	goto yy3;
			goto yy229;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy310;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy376:
	YYDEBUG(376, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'S')	goto yy3;
			goto yy239;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy326;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy377:
	YYDEBUG(377, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'C'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'B')	goto yy3;
			goto yy236;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'c')	goto yy323;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy378:
	YYDEBUG(378, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'M')	goto yy3;
			goto yy244;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy320;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy379:
	YYDEBUG(379, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'G'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'F')	goto yy138;
			goto yy386;
		}
	} else {
		if(yych <= 'f'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'g')	goto yy386;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy380:
	YYDEBUG(380, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy138;
			goto yy381;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'e')	goto yy381;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy381:
	YYDEBUG(381, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'V'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'U')	goto yy139;
			goto yy382;
		}
	} else {
		if(yych <= 'u'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'v')	goto yy382;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy382:
	YYDEBUG(382, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy140;
			goto yy383;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'e')	goto yy383;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy383:
	YYDEBUG(383, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy141;
			goto yy384;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'n')	goto yy384;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy384:
	YYDEBUG(384, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'T')	goto yy385;
		if(yych != 't')	goto yy3;
		goto yy385;
	}
yy385:
	YYDEBUG(385, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy167;
	if(yych == 'h')	goto yy167;
	goto yy53;
yy386:
	YYDEBUG(386, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy139;
			goto yy387;
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'h')	goto yy387;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy387:
	YYDEBUG(387, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 't')	goto yy388;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy388:
	YYDEBUG(388, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	goto yy167;
	case ')':	goto yy136;
	case 'A':
	case 'B':
	case 'C':	case 'E':	case 'G':	case 'I':
	case 'J':
	case 'K':
	case 'L':	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':	case 'U':
	case 'V':	case 'X':	case 'Z':	case 'a':
	case 'b':
	case 'c':	case 'e':	case 'g':	case 'i':
	case 'j':
	case 'k':
	case 'l':	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':	case 'u':
	case 'v':	case 'x':	case 'z':	goto yy141;
	case 'D':	case 'd':	goto yy389;
	case 'F':	case 'f':	goto yy390;
	case 'H':	case 'h':	goto yy391;
	case 'M':	case 'm':	goto yy392;
	case 'S':	case 's':	goto yy393;
	case 'T':	case 't':	goto yy394;
	case 'W':	case 'w':	goto yy395;
	case 'Y':	case 'y':	goto yy396;
	default:	goto yy3;
	}
yy389:
	YYDEBUG(389, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'A')	goto yy221;
		if(yych == 'a')	goto yy221;
		goto yy3;
	}
yy390:
	YYDEBUG(390, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Q'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych == 'O')	goto yy194;
			goto yy3;
		}
	} else {
		if(yych <= 'o'){
			if(yych <= 'R')	goto yy193;
			if(yych <= 'n')	goto yy3;
			goto yy194;
		} else {
			if(yych == 'r')	goto yy193;
			goto yy3;
		}
	}
yy391:
	YYDEBUG(391, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'O')	goto yy222;
		if(yych == 'o')	goto yy222;
		goto yy3;
	}
yy392:
	YYDEBUG(392, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych == 'I')	goto yy225;
			goto yy3;
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'O')	goto yy224;
			if(yych <= 'h')	goto yy3;
			goto yy225;
		} else {
			if(yych == 'o')	goto yy224;
			goto yy3;
		}
	}
yy393:
	YYDEBUG(393, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= 'A')	goto yy234;
			if(yych == 'E')	goto yy235;
			goto yy3;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'U')	goto yy233;
			if(yych == 'a')	goto yy234;
			goto yy3;
		} else {
			if(yych <= 'e')	goto yy235;
			if(yych == 'u')	goto yy233;
			goto yy3;
		}
	}
yy394:
	YYDEBUG(394, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych == 'H')	goto yy177;
			goto yy3;
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'U')	goto yy178;
			if(yych <= 'g')	goto yy3;
			goto yy177;
		} else {
			if(yych == 'u')	goto yy178;
			goto yy3;
		}
	}
yy395:
	YYDEBUG(395, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'E')	goto yy209;
		if(yych == 'e')	goto yy209;
		goto yy3;
	}
yy396:
	YYDEBUG(396, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'E')	goto yy190;
		if(yych == 'e')	goto yy190;
		goto yy3;
	}
yy397:
	YYDEBUG(397, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'G'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'F')	goto yy138;
			goto yy386;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'g')	goto yy404;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy398:
	YYDEBUG(398, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy138;
			goto yy381;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy399;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy399:
	YYDEBUG(399, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'U')	goto yy139;
			goto yy382;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'v')	goto yy400;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy400:
	YYDEBUG(400, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy140;
			goto yy383;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy401;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy401:
	YYDEBUG(401, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy141;
			goto yy384;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy402;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy402:
	YYDEBUG(402, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'S')	goto yy3;
			goto yy385;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy403;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy403:
	YYDEBUG(403, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy53;
			goto yy144;
		} else {
			if(yych == 'H')	goto yy167;
			goto yy53;
		}
	} else {
		if(yych <= 'g'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy53;
			goto yy151;
		} else {
			if(yych <= 'h')	goto yy253;
			if(yych <= 'z')	goto yy151;
			goto yy53;
		}
	}
yy404:
	YYDEBUG(404, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy139;
			goto yy387;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy405;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy405:
	YYDEBUG(405, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy406;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy406:
	YYDEBUG(406, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	goto yy167;
	case ')':	goto yy136;
	case '/':	case '_':	goto yy144;
	case 'A':
	case 'B':
	case 'C':	case 'E':	case 'G':	case 'I':
	case 'J':
	case 'K':
	case 'L':	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':	case 'U':
	case 'V':	case 'X':	case 'Z':	goto yy141;
	case 'D':	goto yy389;
	case 'F':	goto yy390;
	case 'H':	goto yy391;
	case 'M':	goto yy392;
	case 'S':	goto yy393;
	case 'T':	goto yy394;
	case 'W':	goto yy395;
	case 'Y':	goto yy396;
	case 'a':
	case 'b':
	case 'c':	case 'e':	case 'g':	case 'i':
	case 'j':
	case 'k':
	case 'l':	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':	case 'u':
	case 'v':	case 'x':	case 'z':	goto yy150;
	case 'd':	goto yy407;
	case 'f':	goto yy408;
	case 'h':	goto yy409;
	case 'm':	goto yy410;
	case 's':	goto yy411;
	case 't':	goto yy412;
	case 'w':	goto yy413;
	case 'y':	goto yy414;
	default:	goto yy3;
	}
yy407:
	YYDEBUG(407, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy221;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy305;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy408:
	YYDEBUG(408, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych == 'O')	goto yy194;
			if(yych <= 'Q')	goto yy3;
			goto yy193;
		}
	} else {
		if(yych <= 'n'){
			if(yych == '_')	goto yy144;
			if(yych <= '`')	goto yy3;
			goto yy151;
		} else {
			if(yych <= 'q'){
				if(yych <= 'o')	goto yy277;
				goto yy151;
			} else {
				if(yych <= 'r')	goto yy278;
				if(yych <= 'z')	goto yy151;
				goto yy3;
			}
		}
	}
yy409:
	YYDEBUG(409, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'O'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'N')	goto yy3;
			goto yy222;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'o')	goto yy306;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy410:
	YYDEBUG(410, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'O'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych == 'I')	goto yy225;
			if(yych <= 'N')	goto yy3;
			goto yy224;
		}
	} else {
		if(yych <= 'h'){
			if(yych == '_')	goto yy144;
			if(yych <= '`')	goto yy3;
			goto yy151;
		} else {
			if(yych <= 'n'){
				if(yych <= 'i')	goto yy308;
				goto yy151;
			} else {
				if(yych <= 'o')	goto yy309;
				if(yych <= 'z')	goto yy151;
				goto yy3;
			}
		}
	}
yy411:
	YYDEBUG(411, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '@'){
			if(yych <= ')'){
				if(yych <= '(')	goto yy3;
				goto yy136;
			} else {
				if(yych == '/')	goto yy144;
				goto yy3;
			}
		} else {
			if(yych <= 'D'){
				if(yych <= 'A')	goto yy234;
				goto yy3;
			} else {
				if(yych <= 'E')	goto yy235;
				if(yych <= 'T')	goto yy3;
				goto yy233;
			}
		}
	} else {
		if(yych <= 'd'){
			if(yych <= '_'){
				if(yych <= '^')	goto yy3;
				goto yy144;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'a')	goto yy317;
				goto yy151;
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'e')	goto yy318;
				goto yy151;
			} else {
				if(yych <= 'u')	goto yy319;
				if(yych <= 'z')	goto yy151;
				goto yy3;
			}
		}
	}
yy412:
	YYDEBUG(412, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych == 'H')	goto yy177;
			if(yych <= 'T')	goto yy3;
			goto yy178;
		}
	} else {
		if(yych <= 'g'){
			if(yych == '_')	goto yy144;
			if(yych <= '`')	goto yy3;
			goto yy151;
		} else {
			if(yych <= 't'){
				if(yych <= 'h')	goto yy262;
				goto yy151;
			} else {
				if(yych <= 'u')	goto yy263;
				if(yych <= 'z')	goto yy151;
				goto yy3;
			}
		}
	}
yy413:
	YYDEBUG(413, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'D')	goto yy3;
			goto yy209;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy293;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy414:
	YYDEBUG(414, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'D')	goto yy3;
			goto yy190;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy274;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy415:
	YYDEBUG(415, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= 'C')	goto yy138;
			if(yych >= 'E')	goto yy418;
			goto yy416;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'd')	goto yy416;
			if(yych <= 'e')	goto yy418;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy416:
	YYDEBUG(416, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'N'){
		if(yych <= ')'){
			if(yych >= ')')	goto yy136;
			goto yy417;
		} else {
			if(yych <= '@')	goto yy417;
			if(yych <= 'M')	goto yy139;
			goto yy424;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy139;
			if(yych >= 'a')	goto yy139;
			goto yy417;
		} else {
			if(yych <= 'n')	goto yy424;
			if(yych <= 'z')	goto yy139;
			goto yy417;
		}
	}
yy417:
	YYDEBUG(417, *YYCURSOR);

{
		const timelib_relunit* relunit;
		DEBUG_OUTPUT("daytext");
		TIMELIB_INIT;
		TIMELIB_HAVE_RELATIVE();
		TIMELIB_HAVE_WEEKDAY_RELATIVE();
		TIMELIB_UNHAVE_TIME();
		relunit = timelib_lookup_relunit((char**) &ptr);
		s->time->relative.weekday = relunit->multiplier;
		s->time->relative.weekday_behavior = 1;
		
		TIMELIB_DEINIT;
		return TIMELIB_WEEKDAY;
	}
yy418:
	YYDEBUG(418, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'K'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'J')	goto yy139;
			goto yy419;
		}
	} else {
		if(yych <= 'j'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'k')	goto yy419;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy419:
	YYDEBUG(419, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy140;
			goto yy420;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'd')	goto yy420;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy420:
	YYDEBUG(420, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy421;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy421;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy421:
	YYDEBUG(421, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Y')	goto yy422;
		if(yych != 'y')	goto yy3;
		goto yy422;
	}
yy422:
	YYDEBUG(422, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy423;
	if(yych != 's')	goto yy417;
	goto yy423;
yy423:
	YYDEBUG(423, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy417;
yy424:
	YYDEBUG(424, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy140;
			goto yy425;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'e')	goto yy425;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy425:
	YYDEBUG(425, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy141;
			goto yy426;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 's')	goto yy426;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy426:
	YYDEBUG(426, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'C'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'D')	goto yy427;
		if(yych != 'd')	goto yy3;
		goto yy427;
	}
yy427:
	YYDEBUG(427, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy428;
	if(yych != 'a')	goto yy53;
	goto yy428;
yy428:
	YYDEBUG(428, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy423;
	if(yych == 'y')	goto yy423;
	goto yy53;
yy429:
	YYDEBUG(429, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy138;
			if(yych <= 'D')	goto yy416;
			goto yy418;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych <= 'd'){
				if(yych <= 'c')	goto yy143;
				goto yy430;
			} else {
				if(yych <= 'e')	goto yy431;
				if(yych <= 'z')	goto yy143;
				goto yy3;
			}
		}
	}
yy430:
	YYDEBUG(430, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy417;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy417;
			if(yych <= 'M')	goto yy139;
			goto yy424;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy417;
		} else {
			if(yych == 'n')	goto yy437;
			if(yych <= 'z')	goto yy148;
			goto yy417;
		}
	}
yy431:
	YYDEBUG(431, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'K'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'J')	goto yy139;
			goto yy419;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'k')	goto yy432;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy432:
	YYDEBUG(432, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy140;
			goto yy420;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'd')	goto yy433;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy433:
	YYDEBUG(433, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy421;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy434;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy434:
	YYDEBUG(434, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Y'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'X')	goto yy3;
			goto yy422;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'y')	goto yy435;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy435:
	YYDEBUG(435, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy417;
			goto yy144;
		} else {
			if(yych == 'S')	goto yy423;
			goto yy417;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy417;
			goto yy151;
		} else {
			if(yych <= 's')	goto yy436;
			if(yych <= 'z')	goto yy151;
			goto yy417;
		}
	}
yy436:
	YYDEBUG(436, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych == '/')	goto yy144;
		goto yy417;
	} else {
		if(yych <= '_')	goto yy144;
		if(yych <= '`')	goto yy417;
		if(yych <= 'z')	goto yy151;
		goto yy417;
	}
yy437:
	YYDEBUG(437, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy140;
			goto yy425;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy438;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy438:
	YYDEBUG(438, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy141;
			goto yy426;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 's')	goto yy439;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy439:
	YYDEBUG(439, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'C')	goto yy3;
			goto yy427;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'd')	goto yy440;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy440:
	YYDEBUG(440, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy428;
	if(yych != 'a')	goto yy152;
	goto yy441;
yy441:
	YYDEBUG(441, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy423;
	if(yych == 'y')	goto yy436;
	goto yy152;
yy442:
	YYDEBUG(442, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'C'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'B')	goto yy138;
			goto yy443;
		}
	} else {
		if(yych <= 'b'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'c')	goto yy443;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy443:
	YYDEBUG(443, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych >= 0x09)	goto yy446;
				goto yy444;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych == 'E')	goto yy452;
				goto yy139;
			}
		} else {
			if(yych <= 'd'){
				if(yych >= 'a')	goto yy139;
				goto yy444;
			} else {
				if(yych <= 'e')	goto yy452;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy444:
	YYDEBUG(444, *YYCURSOR);

{
		DEBUG_OUTPUT("monthtext");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->m = timelib_lookup_month((char **) &ptr);
		TIMELIB_DEINIT;
		return TIMELIB_DATE_TEXT;
	}
yy445:
	YYDEBUG(445, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 20) YYFILL(20);
	yych = *YYCURSOR;
	goto yy446;
yy446:
	YYDEBUG(446, *YYCURSOR);
	if(yybm[0+yych] & 64) {
		goto yy445;
	}
	if(yych <= '/')	goto yy53;
	if(yych <= '2')	goto yy448;
	if(yych <= '3')	goto yy450;
	if(yych <= '9')	goto yy451;
	goto yy53;
yy447:
	YYDEBUG(447, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy446;
	if(yych <= '0')	goto yy607;
	if(yych <= '2')	goto yy608;
	if(yych <= '3')	goto yy609;
	goto yy446;
yy448:
	YYDEBUG(448, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '1'){
			if(yych <= '/')	goto yy466;
			if(yych <= '0')	goto yy546;
			goto yy547;
		} else {
			if(yych <= '2')	goto yy605;
			if(yych <= '9')	goto yy606;
			goto yy466;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy462;
			if(yych <= 'q')	goto yy466;
			goto yy463;
		} else {
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy449:
	YYDEBUG(449, *YYCURSOR);

{
		DEBUG_OUTPUT("datetextual | datenoyear");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->m = timelib_get_month((char **) &ptr);
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		TIMELIB_PROCESS_YEAR(s->time->y);
		TIMELIB_DEINIT;
		return TIMELIB_DATE_TEXT;
	}
yy450:
	YYDEBUG(450, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '1'){
			if(yych <= '/')	goto yy466;
			if(yych <= '0')	goto yy546;
			goto yy547;
		} else {
			if(yych <= '2')	goto yy459;
			if(yych <= '9')	goto yy460;
			goto yy466;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy462;
			if(yych <= 'q')	goto yy466;
			goto yy463;
		} else {
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy451:
	YYDEBUG(451, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '1'){
			if(yych <= '/')	goto yy466;
			if(yych <= '0')	goto yy457;
			goto yy458;
		} else {
			if(yych <= '2')	goto yy459;
			if(yych <= '9')	goto yy460;
			goto yy466;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy462;
			if(yych <= 'q')	goto yy466;
			goto yy463;
		} else {
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy452:
	YYDEBUG(452, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'L')	goto yy140;
			goto yy453;
		}
	} else {
		if(yych <= 'l'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'm')	goto yy453;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy453:
	YYDEBUG(453, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'B'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'A')	goto yy141;
			goto yy454;
		}
	} else {
		if(yych <= 'a'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'b')	goto yy454;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy454:
	YYDEBUG(454, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'E')	goto yy455;
		if(yych != 'e')	goto yy3;
		goto yy455;
	}
yy455:
	YYDEBUG(455, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy456;
	if(yych != 'r')	goto yy53;
	goto yy456;
yy456:
	YYDEBUG(456, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ' '){
		if(yych == 0x09)	goto yy446;
		if(yych <= 0x1F)	goto yy444;
		goto yy446;
	} else {
		if(yych <= '.'){
			if(yych <= ',')	goto yy444;
			goto yy446;
		} else {
			if(yych <= '/')	goto yy444;
			if(yych <= '9')	goto yy446;
			goto yy444;
		}
	}
yy457:
	YYDEBUG(457, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy471;
		goto yy449;
	} else {
		if(yych <= '0')	goto yy544;
		if(yych <= '9')	goto yy545;
		if(yych <= ':')	goto yy471;
		goto yy449;
	}
yy458:
	YYDEBUG(458, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '2')	goto yy545;
		if(yych <= '9')	goto yy544;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy459:
	YYDEBUG(459, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '3')	goto yy544;
		if(yych <= '9')	goto yy541;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy460:
	YYDEBUG(460, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy541;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy461:
	YYDEBUG(461, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy466;
yy462:
	YYDEBUG(462, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy466;
yy463:
	YYDEBUG(463, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy466;
yy464:
	YYDEBUG(464, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy466;
yy465:
	YYDEBUG(465, *YYCURSOR);
	yyaccept = 7;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 17) YYFILL(17);
	yych = *YYCURSOR;
	goto yy466;
yy466:
	YYDEBUG(466, *YYCURSOR);
	if(yybm[0+yych] & 128) {
		goto yy465;
	}
	if(yych <= '2'){
		if(yych <= '/')	goto yy449;
		if(yych <= '0')	goto yy507;
		if(yych <= '1')	goto yy508;
		goto yy509;
	} else {
		if(yych <= '9')	goto yy510;
		if(yych != 'T')	goto yy449;
		goto yy467;
	}
yy467:
	YYDEBUG(467, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '1')	goto yy468;
	if(yych <= '2')	goto yy469;
	if(yych <= '9')	goto yy470;
	goto yy53;
yy468:
	YYDEBUG(468, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/'){
		if(yych == '.')	goto yy471;
		goto yy53;
	} else {
		if(yych <= '9')	goto yy470;
		if(yych <= ':')	goto yy471;
		goto yy53;
	}
yy469:
	YYDEBUG(469, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/'){
		if(yych == '.')	goto yy471;
		goto yy53;
	} else {
		if(yych <= '3')	goto yy470;
		if(yych == ':')	goto yy471;
		goto yy53;
	}
yy470:
	YYDEBUG(470, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '.')	goto yy471;
	if(yych != ':')	goto yy53;
	goto yy471;
yy471:
	YYDEBUG(471, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy472;
	if(yych <= '9')	goto yy474;
	goto yy53;
yy472:
	YYDEBUG(472, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy475;
		goto yy473;
	} else {
		if(yych <= '9')	goto yy474;
		if(yych <= ':')	goto yy475;
		goto yy473;
	}
yy473:
	YYDEBUG(473, *YYCURSOR);

{
		int tz_not_found;
		DEBUG_OUTPUT("dateshortwithtimeshort | dateshortwithtimelong | dateshortwithtimelongtz");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->m = timelib_get_month((char **) &ptr);
		s->time->d = timelib_get_nr((char **) &ptr, 2);

		TIMELIB_HAVE_TIME();
		s->time->h = timelib_get_nr((char **) &ptr, 2);
		s->time->i = timelib_get_nr((char **) &ptr, 2);
		if (*ptr == ':') {
			s->time->s = timelib_get_nr((char **) &ptr, 2);

			if (*ptr == '.') {
				s->time->f = timelib_get_frac_nr((char **) &ptr, 8);
			}
		}

		if (*ptr != '\0') {
			s->time->z = timelib_get_zone((char **) &ptr, &s->time->dst, s->time, &tz_not_found, s->tzdb);
			if (tz_not_found) {
				add_error(s, "The timezone could not be found in the database");
			}
		}
		TIMELIB_DEINIT;
		return TIMELIB_SHORTDATE_WITH_TIME;
	}
yy474:
	YYDEBUG(474, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy475;
	if(yych != ':')	goto yy473;
	goto yy475;
yy475:
	YYDEBUG(475, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy476;
	if(yych <= '6')	goto yy477;
	if(yych <= '9')	goto yy478;
	goto yy53;
yy476:
	YYDEBUG(476, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy473;
	if(yych <= '9')	goto yy479;
	goto yy473;
yy477:
	YYDEBUG(477, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '0')	goto yy479;
	goto yy473;
yy478:
	YYDEBUG(478, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy473;
yy479:
	YYDEBUG(479, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '*'){
		if(yych <= 0x1F){
			if(yych != 0x09)	goto yy473;
			goto yy480;
		} else {
			if(yych <= ' ')	goto yy480;
			if(yych == '(')	goto yy483;
			goto yy473;
		}
	} else {
		if(yych <= '@'){
			if(yych == ',')	goto yy473;
			if(yych <= '-')	goto yy482;
			goto yy473;
		} else {
			if(yych <= 'Z')	goto yy484;
			if(yych <= '`')	goto yy473;
			if(yych <= 'z')	goto yy485;
			goto yy473;
		}
	}
yy480:
	YYDEBUG(480, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	goto yy481;
yy481:
	YYDEBUG(481, *YYCURSOR);
	if(yych <= '*'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy480;
			goto yy53;
		} else {
			if(yych <= ' ')	goto yy480;
			if(yych == '(')	goto yy483;
			goto yy53;
		}
	} else {
		if(yych <= '@'){
			if(yych == ',')	goto yy53;
			if(yych >= '.')	goto yy53;
			goto yy482;
		} else {
			if(yych <= 'Z')	goto yy484;
			if(yych <= '`')	goto yy53;
			if(yych <= 'z')	goto yy485;
			goto yy53;
		}
	}
yy482:
	YYDEBUG(482, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '1')	goto yy502;
	if(yych <= '2')	goto yy503;
	if(yych <= '9')	goto yy504;
	goto yy53;
yy483:
	YYDEBUG(483, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@')	goto yy53;
	if(yych <= 'Z')	goto yy485;
	if(yych <= '`')	goto yy53;
	if(yych <= 'z')	goto yy485;
	goto yy53;
yy484:
	YYDEBUG(484, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy478;
		goto yy473;
	} else {
		if(yych <= 'Z')	goto yy486;
		if(yych <= '`')	goto yy473;
		if(yych <= 'z')	goto yy491;
		goto yy473;
	}
yy485:
	YYDEBUG(485, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy478;
		goto yy473;
	} else {
		if(yych <= 'Z')	goto yy486;
		if(yych <= '`')	goto yy473;
		if(yych >= '{')	goto yy473;
		goto yy486;
	}
yy486:
	YYDEBUG(486, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy478;
		goto yy473;
	} else {
		if(yych <= 'Z')	goto yy487;
		if(yych <= '`')	goto yy473;
		if(yych >= '{')	goto yy473;
		goto yy487;
	}
yy487:
	YYDEBUG(487, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy478;
		goto yy473;
	} else {
		if(yych <= 'Z')	goto yy488;
		if(yych <= '`')	goto yy473;
		if(yych >= '{')	goto yy473;
		goto yy488;
	}
yy488:
	YYDEBUG(488, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy478;
		goto yy473;
	} else {
		if(yych <= 'Z')	goto yy489;
		if(yych <= '`')	goto yy473;
		if(yych >= '{')	goto yy473;
		goto yy489;
	}
yy489:
	YYDEBUG(489, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '@'){
		if(yych == ')')	goto yy478;
		goto yy473;
	} else {
		if(yych <= 'Z')	goto yy490;
		if(yych <= '`')	goto yy473;
		if(yych >= '{')	goto yy473;
		goto yy490;
	}
yy490:
	YYDEBUG(490, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == ')')	goto yy478;
	goto yy473;
yy491:
	YYDEBUG(491, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy473;
			goto yy478;
		} else {
			if(yych == '/')	goto yy493;
			goto yy473;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy487;
			if(yych <= '^')	goto yy473;
			goto yy493;
		} else {
			if(yych <= '`')	goto yy473;
			if(yych >= '{')	goto yy473;
			goto yy492;
		}
	}
yy492:
	YYDEBUG(492, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy473;
			goto yy478;
		} else {
			if(yych != '/')	goto yy473;
			goto yy493;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy488;
			if(yych <= '^')	goto yy473;
			goto yy493;
		} else {
			if(yych <= '`')	goto yy473;
			if(yych <= 'z')	goto yy497;
			goto yy473;
		}
	}
yy493:
	YYDEBUG(493, *YYCURSOR);
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '@')	goto yy53;
	if(yych >= '[')	goto yy53;
	goto yy494;
yy494:
	YYDEBUG(494, *YYCURSOR);
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '`')	goto yy53;
	if(yych >= '{')	goto yy53;
	goto yy495;
yy495:
	YYDEBUG(495, *YYCURSOR);
	yyaccept = 8;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy496;
yy496:
	YYDEBUG(496, *YYCURSOR);
	if(yych <= '^'){
		if(yych == '/')	goto yy493;
		goto yy473;
	} else {
		if(yych <= '_')	goto yy493;
		if(yych <= '`')	goto yy473;
		if(yych <= 'z')	goto yy495;
		goto yy473;
	}
yy497:
	YYDEBUG(497, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy473;
			goto yy478;
		} else {
			if(yych == '/')	goto yy493;
			goto yy473;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy489;
			if(yych <= '^')	goto yy473;
			goto yy493;
		} else {
			if(yych <= '`')	goto yy473;
			if(yych >= '{')	goto yy473;
			goto yy498;
		}
	}
yy498:
	YYDEBUG(498, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy473;
			goto yy478;
		} else {
			if(yych == '/')	goto yy493;
			goto yy473;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy490;
			if(yych <= '^')	goto yy473;
			goto yy493;
		} else {
			if(yych <= '`')	goto yy473;
			if(yych >= '{')	goto yy473;
			goto yy499;
		}
	}
yy499:
	YYDEBUG(499, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == ')')	goto yy478;
		if(yych <= '.')	goto yy473;
		goto yy493;
	} else {
		if(yych <= '_'){
			if(yych <= '^')	goto yy473;
			goto yy493;
		} else {
			if(yych <= '`')	goto yy473;
			if(yych >= '{')	goto yy473;
			goto yy500;
		}
	}
yy500:
	YYDEBUG(500, *YYCURSOR);
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy501;
yy501:
	YYDEBUG(501, *YYCURSOR);
	if(yych <= '^'){
		if(yych == '/')	goto yy493;
		goto yy53;
	} else {
		if(yych <= '_')	goto yy493;
		if(yych <= '`')	goto yy53;
		if(yych <= 'z')	goto yy500;
		goto yy53;
	}
yy502:
	YYDEBUG(502, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy473;
	if(yych <= '9')	goto yy504;
	if(yych <= ':')	goto yy505;
	goto yy473;
yy503:
	YYDEBUG(503, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '5'){
		if(yych <= '/')	goto yy473;
		if(yych >= '4')	goto yy506;
		goto yy504;
	} else {
		if(yych <= '9')	goto yy478;
		if(yych <= ':')	goto yy505;
		goto yy473;
	}
yy504:
	YYDEBUG(504, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy473;
	if(yych <= '5')	goto yy506;
	if(yych <= '9')	goto yy478;
	if(yych >= ';')	goto yy473;
	goto yy505;
yy505:
	YYDEBUG(505, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy473;
	if(yych <= '5')	goto yy506;
	if(yych <= '9')	goto yy478;
	goto yy473;
yy506:
	YYDEBUG(506, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy473;
	if(yych <= '9')	goto yy478;
	goto yy473;
yy507:
	YYDEBUG(507, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy471;
		goto yy449;
	} else {
		if(yych <= '0')	goto yy539;
		if(yych <= '9')	goto yy540;
		if(yych <= ':')	goto yy471;
		goto yy449;
	}
yy508:
	YYDEBUG(508, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '2')	goto yy540;
		if(yych <= '9')	goto yy539;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy509:
	YYDEBUG(509, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '3')	goto yy539;
		if(yych <= '9')	goto yy511;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy510:
	YYDEBUG(510, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy511;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy511:
	YYDEBUG(511, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy449;
	if(yych <= '9')	goto yy537;
	goto yy449;
yy512:
	YYDEBUG(512, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy513;
	if(yych <= '9')	goto yy514;
	goto yy53;
yy513:
	YYDEBUG(513, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy515;
		goto yy473;
	} else {
		if(yych <= '9')	goto yy530;
		if(yych <= ':')	goto yy515;
		goto yy473;
	}
yy514:
	YYDEBUG(514, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy515;
	if(yych != ':')	goto yy473;
	goto yy515;
yy515:
	YYDEBUG(515, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy516;
	if(yych <= '6')	goto yy517;
	if(yych <= '9')	goto yy478;
	goto yy53;
yy516:
	YYDEBUG(516, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy473;
	if(yych <= '9')	goto yy518;
	goto yy473;
yy517:
	YYDEBUG(517, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '0')	goto yy473;
	goto yy518;
yy518:
	YYDEBUG(518, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '*'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy520;
			goto yy473;
		} else {
			if(yych <= ' ')	goto yy520;
			if(yych == '(')	goto yy520;
			goto yy473;
		}
	} else {
		if(yych <= '@'){
			if(yych == ',')	goto yy473;
			if(yych <= '-')	goto yy520;
			goto yy473;
		} else {
			if(yych <= 'Z')	goto yy520;
			if(yych <= '`')	goto yy473;
			if(yych <= 'z')	goto yy520;
			goto yy473;
		}
	}
yy519:
	YYDEBUG(519, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	goto yy520;
yy520:
	YYDEBUG(520, *YYCURSOR);
	if(yych <= '-'){
		if(yych <= '\''){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy53;
				goto yy519;
			} else {
				if(yych == ' ')	goto yy519;
				goto yy53;
			}
		} else {
			if(yych <= '*'){
				if(yych <= '(')	goto yy483;
				goto yy53;
			} else {
				if(yych == ',')	goto yy53;
				goto yy482;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= 'A'){
				if(yych <= '@')	goto yy53;
				goto yy521;
			} else {
				if(yych != 'P')	goto yy484;
				goto yy521;
			}
		} else {
			if(yych <= 'o'){
				if(yych <= '`')	goto yy53;
				if(yych <= 'a')	goto yy522;
				goto yy485;
			} else {
				if(yych <= 'p')	goto yy522;
				if(yych <= 'z')	goto yy485;
				goto yy53;
			}
		}
	}
yy521:
	YYDEBUG(521, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'L'){
		if(yych <= '-'){
			if(yych == ')')	goto yy478;
			goto yy473;
		} else {
			if(yych <= '.')	goto yy523;
			if(yych <= '@')	goto yy473;
			goto yy486;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'M')	goto yy524;
			if(yych <= 'Z')	goto yy486;
			goto yy473;
		} else {
			if(yych == 'm')	goto yy529;
			if(yych <= 'z')	goto yy491;
			goto yy473;
		}
	}
yy522:
	YYDEBUG(522, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'L'){
		if(yych <= '-'){
			if(yych == ')')	goto yy478;
			goto yy473;
		} else {
			if(yych <= '.')	goto yy523;
			if(yych <= '@')	goto yy473;
			goto yy486;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'M')	goto yy524;
			if(yych <= 'Z')	goto yy486;
			goto yy473;
		} else {
			if(yych == 'm')	goto yy524;
			if(yych <= 'z')	goto yy486;
			goto yy473;
		}
	}
yy523:
	YYDEBUG(523, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy528;
	if(yych == 'm')	goto yy528;
	goto yy53;
yy524:
	YYDEBUG(524, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ')'){
		if(yych <= 0x09){
			if(yych <= 0x00)	goto yy526;
			if(yych <= 0x08)	goto yy473;
			goto yy526;
		} else {
			if(yych == ' ')	goto yy526;
			if(yych <= '(')	goto yy473;
			goto yy478;
		}
	} else {
		if(yych <= '@'){
			if(yych != '.')	goto yy473;
			goto yy525;
		} else {
			if(yych <= 'Z')	goto yy487;
			if(yych <= '`')	goto yy473;
			if(yych <= 'z')	goto yy487;
			goto yy473;
		}
	}
yy525:
	YYDEBUG(525, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x09){
		if(yych <= 0x00)	goto yy526;
		if(yych <= 0x08)	goto yy53;
		goto yy526;
	} else {
		if(yych != ' ')	goto yy53;
		goto yy526;
	}
yy526:
	YYDEBUG(526, *YYCURSOR);
	++YYCURSOR;
	goto yy527;
yy527:
	YYDEBUG(527, *YYCURSOR);

{
		DEBUG_OUTPUT("dateshortwithtimeshort12 | dateshortwithtimelong12");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->m = timelib_get_month((char **) &ptr);
		s->time->d = timelib_get_nr((char **) &ptr, 2);

		TIMELIB_HAVE_TIME();
		s->time->h = timelib_get_nr((char **) &ptr, 2);
		s->time->i = timelib_get_nr((char **) &ptr, 2);
		if (*ptr == ':' || *ptr == '.') {
			s->time->s = timelib_get_nr((char **) &ptr, 2);

			if (*ptr == '.') {
				s->time->f = timelib_get_frac_nr((char **) &ptr, 8);
			}
		}

		s->time->h += timelib_meridian((char **) &ptr, s->time->h);
		TIMELIB_DEINIT;
		return TIMELIB_SHORTDATE_WITH_TIME;
	}
yy528:
	YYDEBUG(528, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x1F){
		if(yych <= 0x00)	goto yy526;
		if(yych == 0x09)	goto yy526;
		goto yy53;
	} else {
		if(yych <= ' ')	goto yy526;
		if(yych == '.')	goto yy525;
		goto yy53;
	}
yy529:
	YYDEBUG(529, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '-'){
		if(yych <= 0x1F){
			if(yych <= 0x00)	goto yy526;
			if(yych == 0x09)	goto yy526;
			goto yy473;
		} else {
			if(yych <= ' ')	goto yy526;
			if(yych == ')')	goto yy478;
			goto yy473;
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '.')	goto yy525;
			if(yych <= '/')	goto yy493;
			if(yych <= '@')	goto yy473;
			goto yy487;
		} else {
			if(yych <= '_'){
				if(yych <= '^')	goto yy473;
				goto yy493;
			} else {
				if(yych <= '`')	goto yy473;
				if(yych <= 'z')	goto yy492;
				goto yy473;
			}
		}
	}
yy530:
	YYDEBUG(530, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ':'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy531;
			if(yych <= 0x1F)	goto yy473;
			goto yy531;
		} else {
			if(yych == '.')	goto yy515;
			if(yych <= '9')	goto yy473;
			goto yy515;
		}
	} else {
		if(yych <= 'P'){
			if(yych == 'A')	goto yy533;
			if(yych <= 'O')	goto yy473;
			goto yy533;
		} else {
			if(yych <= 'a'){
				if(yych <= '`')	goto yy473;
				goto yy533;
			} else {
				if(yych == 'p')	goto yy533;
				goto yy473;
			}
		}
	}
yy531:
	YYDEBUG(531, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	goto yy532;
yy532:
	YYDEBUG(532, *YYCURSOR);
	if(yych <= 'A'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy531;
			goto yy53;
		} else {
			if(yych <= ' ')	goto yy531;
			if(yych <= '@')	goto yy53;
			goto yy533;
		}
	} else {
		if(yych <= '`'){
			if(yych != 'P')	goto yy53;
			goto yy533;
		} else {
			if(yych <= 'a')	goto yy533;
			if(yych != 'p')	goto yy53;
			goto yy533;
		}
	}
yy533:
	YYDEBUG(533, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych != '.')	goto yy53;
		goto yy534;
	} else {
		if(yych <= 'M')	goto yy535;
		if(yych == 'm')	goto yy535;
		goto yy53;
	}
yy534:
	YYDEBUG(534, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy535;
	if(yych != 'm')	goto yy53;
	goto yy535;
yy535:
	YYDEBUG(535, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x1F){
		if(yych <= 0x00)	goto yy526;
		if(yych == 0x09)	goto yy526;
		goto yy53;
	} else {
		if(yych <= ' ')	goto yy526;
		if(yych != '.')	goto yy53;
		goto yy536;
	}
yy536:
	YYDEBUG(536, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x09){
		if(yych <= 0x00)	goto yy526;
		if(yych <= 0x08)	goto yy53;
		goto yy526;
	} else {
		if(yych == ' ')	goto yy526;
		goto yy53;
	}
yy537:
	YYDEBUG(537, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy449;
	if(yych >= ':')	goto yy449;
	goto yy538;
yy538:
	YYDEBUG(538, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy449;
yy539:
	YYDEBUG(539, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy471;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy537;
		if(yych <= ':')	goto yy471;
		goto yy449;
	}
yy540:
	YYDEBUG(540, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy537;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy541:
	YYDEBUG(541, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy449;
	if(yych >= ':')	goto yy449;
	goto yy542;
yy542:
	YYDEBUG(542, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '/')	goto yy543;
	if(yych <= '9')	goto yy538;
	goto yy543;
yy543:
	YYDEBUG(543, *YYCURSOR);

{
		DEBUG_OUTPUT("datenoday");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->m = timelib_get_month((char **) &ptr);
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		s->time->d = 1;
		TIMELIB_PROCESS_YEAR(s->time->y);
		TIMELIB_DEINIT;
		return TIMELIB_DATE_NO_DAY;
	}
yy544:
	YYDEBUG(544, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy471;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy542;
		if(yych <= ':')	goto yy471;
		goto yy449;
	}
yy545:
	YYDEBUG(545, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy542;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy546:
	YYDEBUG(546, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '/'){
			if(yych == '.')	goto yy581;
			goto yy466;
		} else {
			if(yych <= '0')	goto yy582;
			if(yych <= '1')	goto yy550;
			if(yych <= '2')	goto yy551;
			goto yy552;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy471;
			if(yych == 'n')	goto yy462;
			goto yy466;
		} else {
			if(yych <= 'r')	goto yy463;
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy547:
	YYDEBUG(547, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '/'){
			if(yych != '.')	goto yy466;
			goto yy548;
		} else {
			if(yych <= '0')	goto yy549;
			if(yych <= '1')	goto yy550;
			if(yych <= '2')	goto yy551;
			goto yy552;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy512;
			if(yych == 'n')	goto yy462;
			goto yy466;
		} else {
			if(yych <= 'r')	goto yy463;
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy548:
	YYDEBUG(548, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '1'){
		if(yych <= '/')	goto yy466;
		if(yych <= '0')	goto yy556;
		goto yy557;
	} else {
		if(yych <= '2')	goto yy558;
		if(yych <= '5')	goto yy559;
		if(yych <= '9')	goto yy560;
		goto yy466;
	}
yy549:
	YYDEBUG(549, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '0')	goto yy554;
		if(yych <= '9')	goto yy555;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy550:
	YYDEBUG(550, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '2')	goto yy555;
		if(yych <= '9')	goto yy554;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy551:
	YYDEBUG(551, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '3')	goto yy554;
		if(yych <= '9')	goto yy553;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy552:
	YYDEBUG(552, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy553;
		if(yych <= ':')	goto yy512;
		goto yy449;
	}
yy553:
	YYDEBUG(553, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy543;
	if(yych <= '9')	goto yy537;
	goto yy543;
yy554:
	YYDEBUG(554, *YYCURSOR);
	yyaccept = 9;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy471;
		goto yy543;
	} else {
		if(yych <= '9')	goto yy537;
		if(yych <= ':')	goto yy471;
		goto yy543;
	}
yy555:
	YYDEBUG(555, *YYCURSOR);
	yyaccept = 9;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy512;
		goto yy543;
	} else {
		if(yych <= '9')	goto yy537;
		if(yych <= ':')	goto yy512;
		goto yy543;
	}
yy556:
	YYDEBUG(556, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy576;
		goto yy449;
	} else {
		if(yych <= '0')	goto yy575;
		if(yych <= '9')	goto yy580;
		if(yych <= ':')	goto yy576;
		goto yy449;
	}
yy557:
	YYDEBUG(557, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy561;
		goto yy449;
	} else {
		if(yych <= '2')	goto yy580;
		if(yych <= '9')	goto yy575;
		if(yych <= ':')	goto yy561;
		goto yy449;
	}
yy558:
	YYDEBUG(558, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy561;
		goto yy449;
	} else {
		if(yych <= '3')	goto yy575;
		if(yych <= '9')	goto yy574;
		if(yych <= ':')	goto yy561;
		goto yy449;
	}
yy559:
	YYDEBUG(559, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy561;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy574;
		if(yych <= ':')	goto yy561;
		goto yy449;
	}
yy560:
	YYDEBUG(560, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych != '.')	goto yy449;
		goto yy561;
	} else {
		if(yych <= '9')	goto yy511;
		if(yych >= ';')	goto yy449;
		goto yy561;
	}
yy561:
	YYDEBUG(561, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy562;
	if(yych <= '6')	goto yy563;
	if(yych <= '9')	goto yy514;
	goto yy53;
yy562:
	YYDEBUG(562, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy515;
		goto yy473;
	} else {
		if(yych <= '9')	goto yy564;
		if(yych <= ':')	goto yy515;
		goto yy473;
	}
yy563:
	YYDEBUG(563, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy515;
		goto yy473;
	} else {
		if(yych <= '0')	goto yy518;
		if(yych == ':')	goto yy515;
		goto yy473;
	}
yy564:
	YYDEBUG(564, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy566;
			if(yych <= 0x1F)	goto yy473;
			goto yy566;
		} else {
			if(yych <= '('){
				if(yych <= '\'')	goto yy473;
				goto yy566;
			} else {
				if(yych == '+')	goto yy566;
				goto yy473;
			}
		}
	} else {
		if(yych <= ':'){
			if(yych <= '-')	goto yy566;
			if(yych <= '.')	goto yy515;
			if(yych <= '9')	goto yy473;
			goto yy515;
		} else {
			if(yych <= 'Z'){
				if(yych <= '@')	goto yy473;
				goto yy566;
			} else {
				if(yych <= '`')	goto yy473;
				if(yych <= 'z')	goto yy566;
				goto yy473;
			}
		}
	}
yy565:
	YYDEBUG(565, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	goto yy566;
yy566:
	YYDEBUG(566, *YYCURSOR);
	if(yych <= '-'){
		if(yych <= '\''){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy53;
				goto yy565;
			} else {
				if(yych == ' ')	goto yy565;
				goto yy53;
			}
		} else {
			if(yych <= '*'){
				if(yych <= '(')	goto yy483;
				goto yy53;
			} else {
				if(yych == ',')	goto yy53;
				goto yy482;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= 'A'){
				if(yych <= '@')	goto yy53;
				goto yy567;
			} else {
				if(yych != 'P')	goto yy484;
				goto yy567;
			}
		} else {
			if(yych <= 'o'){
				if(yych <= '`')	goto yy53;
				if(yych <= 'a')	goto yy568;
				goto yy485;
			} else {
				if(yych <= 'p')	goto yy568;
				if(yych <= 'z')	goto yy485;
				goto yy53;
			}
		}
	}
yy567:
	YYDEBUG(567, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'L'){
		if(yych <= '-'){
			if(yych == ')')	goto yy478;
			goto yy473;
		} else {
			if(yych <= '.')	goto yy570;
			if(yych <= '@')	goto yy473;
			goto yy486;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'M')	goto yy569;
			if(yych <= 'Z')	goto yy486;
			goto yy473;
		} else {
			if(yych == 'm')	goto yy573;
			if(yych <= 'z')	goto yy491;
			goto yy473;
		}
	}
yy568:
	YYDEBUG(568, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'L'){
		if(yych <= '-'){
			if(yych == ')')	goto yy478;
			goto yy473;
		} else {
			if(yych <= '.')	goto yy570;
			if(yych <= '@')	goto yy473;
			goto yy486;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'M')	goto yy569;
			if(yych <= 'Z')	goto yy486;
			goto yy473;
		} else {
			if(yych == 'm')	goto yy569;
			if(yych <= 'z')	goto yy486;
			goto yy473;
		}
	}
yy569:
	YYDEBUG(569, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ')'){
		if(yych <= 0x09){
			if(yych <= 0x00)	goto yy526;
			if(yych <= 0x08)	goto yy473;
			goto yy526;
		} else {
			if(yych == ' ')	goto yy526;
			if(yych <= '(')	goto yy473;
			goto yy478;
		}
	} else {
		if(yych <= '@'){
			if(yych == '.')	goto yy572;
			goto yy473;
		} else {
			if(yych <= 'Z')	goto yy487;
			if(yych <= '`')	goto yy473;
			if(yych <= 'z')	goto yy487;
			goto yy473;
		}
	}
yy570:
	YYDEBUG(570, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy571;
	if(yych != 'm')	goto yy53;
	goto yy571;
yy571:
	YYDEBUG(571, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x1F){
		if(yych <= 0x00)	goto yy526;
		if(yych == 0x09)	goto yy526;
		goto yy53;
	} else {
		if(yych <= ' ')	goto yy526;
		if(yych != '.')	goto yy53;
		goto yy572;
	}
yy572:
	YYDEBUG(572, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x09){
		if(yych <= 0x00)	goto yy526;
		if(yych <= 0x08)	goto yy53;
		goto yy526;
	} else {
		if(yych == ' ')	goto yy526;
		goto yy53;
	}
yy573:
	YYDEBUG(573, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '-'){
		if(yych <= 0x1F){
			if(yych <= 0x00)	goto yy526;
			if(yych == 0x09)	goto yy526;
			goto yy473;
		} else {
			if(yych <= ' ')	goto yy526;
			if(yych == ')')	goto yy478;
			goto yy473;
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '.')	goto yy572;
			if(yych <= '/')	goto yy493;
			if(yych <= '@')	goto yy473;
			goto yy487;
		} else {
			if(yych <= '_'){
				if(yych <= '^')	goto yy473;
				goto yy493;
			} else {
				if(yych <= '`')	goto yy473;
				if(yych <= 'z')	goto yy492;
				goto yy473;
			}
		}
	}
yy574:
	YYDEBUG(574, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ':'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy531;
			if(yych <= 0x1F)	goto yy449;
			goto yy531;
		} else {
			if(yych <= '.'){
				if(yych <= '-')	goto yy449;
				goto yy515;
			} else {
				if(yych <= '/')	goto yy449;
				if(yych <= '9')	goto yy537;
				goto yy515;
			}
		}
	} else {
		if(yych <= 'P'){
			if(yych == 'A')	goto yy533;
			if(yych <= 'O')	goto yy449;
			goto yy533;
		} else {
			if(yych <= 'a'){
				if(yych <= '`')	goto yy449;
				goto yy533;
			} else {
				if(yych == 'p')	goto yy533;
				goto yy449;
			}
		}
	}
yy575:
	YYDEBUG(575, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ':'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy531;
			if(yych <= 0x1F)	goto yy449;
			goto yy531;
		} else {
			if(yych <= '.'){
				if(yych <= '-')	goto yy449;
				goto yy576;
			} else {
				if(yych <= '/')	goto yy449;
				if(yych <= '9')	goto yy537;
				goto yy576;
			}
		}
	} else {
		if(yych <= 'P'){
			if(yych == 'A')	goto yy533;
			if(yych <= 'O')	goto yy449;
			goto yy533;
		} else {
			if(yych <= 'a'){
				if(yych <= '`')	goto yy449;
				goto yy533;
			} else {
				if(yych == 'p')	goto yy533;
				goto yy449;
			}
		}
	}
yy576:
	YYDEBUG(576, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy577;
	if(yych <= '6')	goto yy578;
	if(yych <= '9')	goto yy474;
	goto yy53;
yy577:
	YYDEBUG(577, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy475;
		goto yy473;
	} else {
		if(yych <= '9')	goto yy579;
		if(yych <= ':')	goto yy475;
		goto yy473;
	}
yy578:
	YYDEBUG(578, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy475;
		goto yy473;
	} else {
		if(yych <= '0')	goto yy518;
		if(yych == ':')	goto yy475;
		goto yy473;
	}
yy579:
	YYDEBUG(579, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy520;
			if(yych <= 0x1F)	goto yy473;
			goto yy520;
		} else {
			if(yych <= '('){
				if(yych <= '\'')	goto yy473;
				goto yy520;
			} else {
				if(yych == '+')	goto yy520;
				goto yy473;
			}
		}
	} else {
		if(yych <= ':'){
			if(yych <= '-')	goto yy520;
			if(yych <= '.')	goto yy475;
			if(yych <= '9')	goto yy473;
			goto yy475;
		} else {
			if(yych <= 'Z'){
				if(yych <= '@')	goto yy473;
				goto yy520;
			} else {
				if(yych <= '`')	goto yy473;
				if(yych <= 'z')	goto yy520;
				goto yy473;
			}
		}
	}
yy580:
	YYDEBUG(580, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ':'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy531;
			if(yych <= 0x1F)	goto yy449;
			goto yy531;
		} else {
			if(yych <= '.'){
				if(yych <= '-')	goto yy449;
				goto yy561;
			} else {
				if(yych <= '/')	goto yy449;
				if(yych <= '9')	goto yy537;
				goto yy561;
			}
		}
	} else {
		if(yych <= 'P'){
			if(yych == 'A')	goto yy533;
			if(yych <= 'O')	goto yy449;
			goto yy533;
		} else {
			if(yych <= 'a'){
				if(yych <= '`')	goto yy449;
				goto yy533;
			} else {
				if(yych == 'p')	goto yy533;
				goto yy449;
			}
		}
	}
yy581:
	YYDEBUG(581, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '1'){
		if(yych <= '/')	goto yy466;
		if(yych <= '0')	goto yy583;
		goto yy584;
	} else {
		if(yych <= '2')	goto yy585;
		if(yych <= '5')	goto yy586;
		if(yych <= '9')	goto yy587;
		goto yy466;
	}
yy582:
	YYDEBUG(582, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy471;
		goto yy449;
	} else {
		if(yych <= '0')	goto yy554;
		if(yych <= '9')	goto yy555;
		if(yych <= ':')	goto yy471;
		goto yy449;
	}
yy583:
	YYDEBUG(583, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy600;
		goto yy449;
	} else {
		if(yych <= '0')	goto yy599;
		if(yych <= '9')	goto yy604;
		if(yych <= ':')	goto yy600;
		goto yy449;
	}
yy584:
	YYDEBUG(584, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy588;
		goto yy449;
	} else {
		if(yych <= '2')	goto yy604;
		if(yych <= '9')	goto yy599;
		if(yych <= ':')	goto yy588;
		goto yy449;
	}
yy585:
	YYDEBUG(585, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy588;
		goto yy449;
	} else {
		if(yych <= '3')	goto yy599;
		if(yych <= '9')	goto yy598;
		if(yych <= ':')	goto yy588;
		goto yy449;
	}
yy586:
	YYDEBUG(586, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy588;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy598;
		if(yych <= ':')	goto yy588;
		goto yy449;
	}
yy587:
	YYDEBUG(587, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych != '.')	goto yy449;
		goto yy588;
	} else {
		if(yych <= '9')	goto yy511;
		if(yych >= ';')	goto yy449;
		goto yy588;
	}
yy588:
	YYDEBUG(588, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy589;
	if(yych <= '6')	goto yy590;
	if(yych <= '9')	goto yy514;
	goto yy53;
yy589:
	YYDEBUG(589, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy515;
		goto yy473;
	} else {
		if(yych <= '9')	goto yy591;
		if(yych <= ':')	goto yy515;
		goto yy473;
	}
yy590:
	YYDEBUG(590, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy515;
		goto yy473;
	} else {
		if(yych <= '0')	goto yy479;
		if(yych == ':')	goto yy515;
		goto yy473;
	}
yy591:
	YYDEBUG(591, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy593;
			if(yych <= 0x1F)	goto yy473;
			goto yy593;
		} else {
			if(yych <= '('){
				if(yych <= '\'')	goto yy473;
				goto yy593;
			} else {
				if(yych == '+')	goto yy593;
				goto yy473;
			}
		}
	} else {
		if(yych <= ':'){
			if(yych <= '-')	goto yy593;
			if(yych <= '.')	goto yy515;
			if(yych <= '9')	goto yy473;
			goto yy515;
		} else {
			if(yych <= 'Z'){
				if(yych <= '@')	goto yy473;
				goto yy593;
			} else {
				if(yych <= '`')	goto yy473;
				if(yych <= 'z')	goto yy593;
				goto yy473;
			}
		}
	}
yy592:
	YYDEBUG(592, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	goto yy593;
yy593:
	YYDEBUG(593, *YYCURSOR);
	if(yych <= '-'){
		if(yych <= '\''){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy53;
				goto yy592;
			} else {
				if(yych == ' ')	goto yy592;
				goto yy53;
			}
		} else {
			if(yych <= '*'){
				if(yych <= '(')	goto yy483;
				goto yy53;
			} else {
				if(yych == ',')	goto yy53;
				goto yy482;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= 'A'){
				if(yych <= '@')	goto yy53;
				goto yy594;
			} else {
				if(yych != 'P')	goto yy484;
				goto yy594;
			}
		} else {
			if(yych <= 'o'){
				if(yych <= '`')	goto yy53;
				if(yych <= 'a')	goto yy595;
				goto yy485;
			} else {
				if(yych <= 'p')	goto yy595;
				if(yych <= 'z')	goto yy485;
				goto yy53;
			}
		}
	}
yy594:
	YYDEBUG(594, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'L'){
		if(yych <= '-'){
			if(yych == ')')	goto yy478;
			goto yy473;
		} else {
			if(yych <= '.')	goto yy534;
			if(yych <= '@')	goto yy473;
			goto yy486;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'M')	goto yy596;
			if(yych <= 'Z')	goto yy486;
			goto yy473;
		} else {
			if(yych == 'm')	goto yy597;
			if(yych <= 'z')	goto yy491;
			goto yy473;
		}
	}
yy595:
	YYDEBUG(595, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'L'){
		if(yych <= '-'){
			if(yych == ')')	goto yy478;
			goto yy473;
		} else {
			if(yych <= '.')	goto yy534;
			if(yych <= '@')	goto yy473;
			goto yy486;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'M')	goto yy596;
			if(yych <= 'Z')	goto yy486;
			goto yy473;
		} else {
			if(yych == 'm')	goto yy596;
			if(yych <= 'z')	goto yy486;
			goto yy473;
		}
	}
yy596:
	YYDEBUG(596, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ')'){
		if(yych <= 0x09){
			if(yych <= 0x00)	goto yy526;
			if(yych <= 0x08)	goto yy473;
			goto yy526;
		} else {
			if(yych == ' ')	goto yy526;
			if(yych <= '(')	goto yy473;
			goto yy478;
		}
	} else {
		if(yych <= '@'){
			if(yych == '.')	goto yy536;
			goto yy473;
		} else {
			if(yych <= 'Z')	goto yy487;
			if(yych <= '`')	goto yy473;
			if(yych <= 'z')	goto yy487;
			goto yy473;
		}
	}
yy597:
	YYDEBUG(597, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '-'){
		if(yych <= 0x1F){
			if(yych <= 0x00)	goto yy526;
			if(yych == 0x09)	goto yy526;
			goto yy473;
		} else {
			if(yych <= ' ')	goto yy526;
			if(yych == ')')	goto yy478;
			goto yy473;
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '.')	goto yy536;
			if(yych <= '/')	goto yy493;
			if(yych <= '@')	goto yy473;
			goto yy487;
		} else {
			if(yych <= '_'){
				if(yych <= '^')	goto yy473;
				goto yy493;
			} else {
				if(yych <= '`')	goto yy473;
				if(yych <= 'z')	goto yy492;
				goto yy473;
			}
		}
	}
yy598:
	YYDEBUG(598, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy475;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy537;
		if(yych <= ':')	goto yy475;
		goto yy449;
	}
yy599:
	YYDEBUG(599, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych != '.')	goto yy449;
		goto yy600;
	} else {
		if(yych <= '9')	goto yy537;
		if(yych >= ';')	goto yy449;
		goto yy600;
	}
yy600:
	YYDEBUG(600, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy601;
	if(yych <= '6')	goto yy602;
	if(yych <= '9')	goto yy474;
	goto yy53;
yy601:
	YYDEBUG(601, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy475;
		goto yy473;
	} else {
		if(yych <= '9')	goto yy603;
		if(yych <= ':')	goto yy475;
		goto yy473;
	}
yy602:
	YYDEBUG(602, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy475;
		goto yy473;
	} else {
		if(yych <= '0')	goto yy479;
		if(yych == ':')	goto yy475;
		goto yy473;
	}
yy603:
	YYDEBUG(603, *YYCURSOR);
	yyaccept = 8;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy480;
			if(yych <= 0x1F)	goto yy473;
			goto yy480;
		} else {
			if(yych <= '('){
				if(yych <= '\'')	goto yy473;
				goto yy483;
			} else {
				if(yych == '+')	goto yy482;
				goto yy473;
			}
		}
	} else {
		if(yych <= ':'){
			if(yych <= '-')	goto yy482;
			if(yych <= '.')	goto yy475;
			if(yych <= '9')	goto yy473;
			goto yy475;
		} else {
			if(yych <= 'Z'){
				if(yych <= '@')	goto yy473;
				goto yy484;
			} else {
				if(yych <= '`')	goto yy473;
				if(yych <= 'z')	goto yy485;
				goto yy473;
			}
		}
	}
yy604:
	YYDEBUG(604, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy588;
		goto yy449;
	} else {
		if(yych <= '9')	goto yy537;
		if(yych <= ':')	goto yy588;
		goto yy449;
	}
yy605:
	YYDEBUG(605, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '/'){
			if(yych == '.')	goto yy548;
			goto yy466;
		} else {
			if(yych <= '0')	goto yy582;
			if(yych <= '1')	goto yy550;
			if(yych <= '2')	goto yy551;
			goto yy552;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy512;
			if(yych == 'n')	goto yy462;
			goto yy466;
		} else {
			if(yych <= 'r')	goto yy463;
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy606:
	YYDEBUG(606, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '/'){
			if(yych == '.')	goto yy548;
			goto yy466;
		} else {
			if(yych <= '0')	goto yy582;
			if(yych <= '1')	goto yy550;
			if(yych <= '2')	goto yy551;
			goto yy552;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy512;
			if(yych == 'n')	goto yy462;
			goto yy466;
		} else {
			if(yych <= 'r')	goto yy463;
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy607:
	YYDEBUG(607, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '1'){
			if(yych <= '/')	goto yy466;
			if(yych <= '0')	goto yy546;
			goto yy611;
		} else {
			if(yych <= '2')	goto yy618;
			if(yych <= '9')	goto yy619;
			goto yy466;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy462;
			if(yych <= 'q')	goto yy466;
			goto yy463;
		} else {
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy608:
	YYDEBUG(608, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '1'){
			if(yych <= '/')	goto yy466;
			if(yych <= '0')	goto yy610;
			goto yy611;
		} else {
			if(yych <= '2')	goto yy618;
			if(yych <= '9')	goto yy619;
			goto yy466;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy462;
			if(yych <= 'q')	goto yy466;
			goto yy463;
		} else {
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy609:
	YYDEBUG(609, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '1'){
			if(yych <= '/')	goto yy466;
			if(yych >= '1')	goto yy611;
			goto yy610;
		} else {
			if(yych <= '2')	goto yy459;
			if(yych <= '9')	goto yy460;
			goto yy466;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy462;
			if(yych <= 'q')	goto yy466;
			goto yy463;
		} else {
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy610:
	YYDEBUG(610, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '/'){
			if(yych <= ',')	goto yy466;
			if(yych <= '-')	goto yy612;
			if(yych <= '.')	goto yy581;
			goto yy466;
		} else {
			if(yych <= '0')	goto yy582;
			if(yych <= '1')	goto yy550;
			if(yych <= '2')	goto yy551;
			goto yy552;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy471;
			if(yych == 'n')	goto yy462;
			goto yy466;
		} else {
			if(yych <= 'r')	goto yy463;
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy611:
	YYDEBUG(611, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '/'){
			if(yych <= ',')	goto yy466;
			if(yych <= '-')	goto yy612;
			if(yych <= '.')	goto yy548;
			goto yy466;
		} else {
			if(yych <= '0')	goto yy549;
			if(yych <= '1')	goto yy550;
			if(yych <= '2')	goto yy551;
			goto yy552;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy512;
			if(yych == 'n')	goto yy462;
			goto yy466;
		} else {
			if(yych <= 'r')	goto yy463;
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy612:
	YYDEBUG(612, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy613;
yy613:
	YYDEBUG(613, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '/')	goto yy614;
	if(yych <= '9')	goto yy615;
	goto yy614;
yy614:
	YYDEBUG(614, *YYCURSOR);

{
		DEBUG_OUTPUT("pgtextshort");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->m = timelib_get_month((char **) &ptr);
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		TIMELIB_PROCESS_YEAR(s->time->y);
		TIMELIB_DEINIT;
		return TIMELIB_PG_TEXT;
	}
yy615:
	YYDEBUG(615, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy614;
	if(yych >= ':')	goto yy614;
	goto yy616;
yy616:
	YYDEBUG(616, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy614;
	if(yych >= ':')	goto yy614;
	goto yy617;
yy617:
	YYDEBUG(617, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy614;
yy618:
	YYDEBUG(618, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '/'){
			if(yych <= ',')	goto yy466;
			if(yych <= '-')	goto yy612;
			if(yych <= '.')	goto yy548;
			goto yy466;
		} else {
			if(yych <= '0')	goto yy582;
			if(yych <= '1')	goto yy550;
			if(yych <= '2')	goto yy551;
			goto yy552;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy512;
			if(yych == 'n')	goto yy462;
			goto yy466;
		} else {
			if(yych <= 'r')	goto yy463;
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy619:
	YYDEBUG(619, *YYCURSOR);
	yyaccept = 7;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '/'){
			if(yych <= ',')	goto yy466;
			if(yych <= '-')	goto yy612;
			if(yych <= '.')	goto yy548;
			goto yy466;
		} else {
			if(yych <= '0')	goto yy582;
			if(yych <= '1')	goto yy550;
			if(yych <= '2')	goto yy551;
			goto yy552;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy512;
			if(yych == 'n')	goto yy462;
			goto yy466;
		} else {
			if(yych <= 'r')	goto yy463;
			if(yych <= 's')	goto yy461;
			if(yych <= 't')	goto yy464;
			goto yy466;
		}
	}
yy620:
	YYDEBUG(620, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'C'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'B')	goto yy138;
			goto yy443;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'c')	goto yy621;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy621:
	YYDEBUG(621, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'D'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'E')	goto yy452;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 'd'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'e')	goto yy622;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy622:
	YYDEBUG(622, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'M'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'L')	goto yy140;
			goto yy453;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'm')	goto yy623;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy623:
	YYDEBUG(623, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'B'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'A')	goto yy141;
			goto yy454;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'b')	goto yy624;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy624:
	YYDEBUG(624, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'D')	goto yy3;
			goto yy455;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy625;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy625:
	YYDEBUG(625, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy456;
	if(yych != 'r')	goto yy152;
	goto yy626;
yy626:
	YYDEBUG(626, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy446;
			goto yy444;
		} else {
			if(yych <= ' ')	goto yy446;
			if(yych <= ',')	goto yy444;
			goto yy446;
		}
	} else {
		if(yych <= '^'){
			if(yych <= '/')	goto yy144;
			if(yych <= '9')	goto yy446;
			goto yy444;
		} else {
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy444;
			if(yych <= 'z')	goto yy151;
			goto yy444;
		}
	}
yy627:
	YYDEBUG(627, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy138;
			goto yy628;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 't')	goto yy628;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy628:
	YYDEBUG(628, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych != 'O')	goto yy139;
				goto yy629;
			}
		} else {
			if(yych <= 'n'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'o')	goto yy629;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy629:
	YYDEBUG(629, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'B'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'A')	goto yy140;
			goto yy630;
		}
	} else {
		if(yych <= 'a'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'b')	goto yy630;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy630:
	YYDEBUG(630, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy141;
			goto yy631;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'e')	goto yy631;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy631:
	YYDEBUG(631, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'R')	goto yy456;
		if(yych == 'r')	goto yy456;
		goto yy3;
	}
yy632:
	YYDEBUG(632, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy138;
			goto yy628;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy633;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy633:
	YYDEBUG(633, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'N'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'O')	goto yy629;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 'n'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'o')	goto yy634;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy634:
	YYDEBUG(634, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'B'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'A')	goto yy140;
			goto yy630;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'b')	goto yy635;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy635:
	YYDEBUG(635, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy141;
			goto yy631;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy636;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy636:
	YYDEBUG(636, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'Q')	goto yy3;
			goto yy456;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy626;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy637:
	YYDEBUG(637, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'V'){
		if(yych <= 'B'){
			if(yych == ')')	goto yy136;
			if(yych <= '@')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'O'){
				if(yych <= 'C')	goto yy653;
				goto yy138;
			} else {
				if(yych <= 'P')	goto yy652;
				if(yych <= 'U')	goto yy138;
				goto yy654;
			}
		}
	} else {
		if(yych <= 'o'){
			if(yych <= '`'){
				if(yych <= 'Z')	goto yy138;
				goto yy3;
			} else {
				if(yych == 'c')	goto yy653;
				goto yy138;
			}
		} else {
			if(yych <= 'u'){
				if(yych <= 'p')	goto yy652;
				goto yy138;
			} else {
				if(yych <= 'v')	goto yy654;
				if(yych <= 'z')	goto yy138;
				goto yy3;
			}
		}
	}
yy638:
	YYDEBUG(638, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy138;
			goto yy647;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 't')	goto yy647;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy639:
	YYDEBUG(639, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'W')	goto yy138;
			goto yy645;
		}
	} else {
		if(yych <= 'w'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'x')	goto yy645;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy640:
	YYDEBUG(640, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy641;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'n')	goto yy641;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy641:
	YYDEBUG(641, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy417;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy417;
			if(yych <= 'C')	goto yy139;
			goto yy642;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy417;
			goto yy139;
		} else {
			if(yych <= 'd')	goto yy642;
			if(yych <= 'z')	goto yy139;
			goto yy417;
		}
	}
yy642:
	YYDEBUG(642, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy643;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy643;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy643:
	YYDEBUG(643, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'X')	goto yy141;
			goto yy644;
		}
	} else {
		if(yych <= 'x'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'y')	goto yy644;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy644:
	YYDEBUG(644, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == ')')	goto yy136;
	goto yy417;
yy645:
	YYDEBUG(645, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy646;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 't')	goto yy646;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy646:
	YYDEBUG(646, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'h')	goto yy388;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy647:
	YYDEBUG(647, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy417;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy417;
			if(yych <= 'T')	goto yy139;
			goto yy648;
		}
	} else {
		if(yych <= 't'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy417;
			goto yy139;
		} else {
			if(yych <= 'u')	goto yy648;
			if(yych <= 'z')	goto yy139;
			goto yy417;
		}
	}
yy648:
	YYDEBUG(648, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy140;
			goto yy649;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'r')	goto yy649;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy649:
	YYDEBUG(649, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy141;
			goto yy650;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'd')	goto yy650;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy650:
	YYDEBUG(650, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'A')	goto yy651;
		if(yych != 'a')	goto yy3;
		goto yy651;
	}
yy651:
	YYDEBUG(651, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy423;
	if(yych == 'y')	goto yy423;
	goto yy53;
yy652:
	YYDEBUG(652, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych == 'T')	goto yy661;
				goto yy139;
			}
		} else {
			if(yych <= 's'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 't')	goto yy661;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy653:
	YYDEBUG(653, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy139;
			goto yy658;
		}
	} else {
		if(yych <= 'n'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'o')	goto yy658;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy654:
	YYDEBUG(654, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy139;
			goto yy655;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'e')	goto yy655;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy655:
	YYDEBUG(655, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy140;
			goto yy656;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'n')	goto yy656;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy656:
	YYDEBUG(656, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy141;
			goto yy657;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 't')	goto yy657;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy657:
	YYDEBUG(657, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'G'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'H')	goto yy167;
		if(yych == 'h')	goto yy167;
		goto yy3;
	}
yy658:
	YYDEBUG(658, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy140;
			goto yy659;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'n')	goto yy659;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy659:
	YYDEBUG(659, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy141;
			goto yy660;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'd')	goto yy660;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy660:
	YYDEBUG(660, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy168;
				if(yych <= 0x1F)	goto yy3;
				goto yy168;
			} else {
				if(yych == ')')	goto yy136;
				if(yych <= 'C')	goto yy3;
				goto yy168;
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy168;
				if(yych <= 'G')	goto yy3;
				goto yy168;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy3;
					goto yy168;
				} else {
					if(yych <= 'R')	goto yy3;
					if(yych <= 'T')	goto yy168;
					goto yy3;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy3;
				if(yych <= 'Y')	goto yy168;
				goto yy3;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy168;
					goto yy3;
				} else {
					if(yych == 'g')	goto yy3;
					goto yy168;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy168;
				if(yych <= 'r')	goto yy3;
				goto yy168;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy3;
					goto yy168;
				} else {
					if(yych == 'y')	goto yy168;
					goto yy3;
				}
			}
		}
	}
yy661:
	YYDEBUG(661, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych != 'E')	goto yy140;
				goto yy662;
			}
		} else {
			if(yych <= 'd'){
				if(yych <= '`')	goto yy444;
				goto yy140;
			} else {
				if(yych <= 'e')	goto yy662;
				if(yych <= 'z')	goto yy140;
				goto yy444;
			}
		}
	}
yy662:
	YYDEBUG(662, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'L')	goto yy141;
			goto yy663;
		}
	} else {
		if(yych <= 'l'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'm')	goto yy663;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy663:
	YYDEBUG(663, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'B')	goto yy664;
		if(yych != 'b')	goto yy3;
		goto yy664;
	}
yy664:
	YYDEBUG(664, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy665;
	if(yych != 'e')	goto yy53;
	goto yy665;
yy665:
	YYDEBUG(665, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy456;
	if(yych == 'r')	goto yy456;
	goto yy53;
yy666:
	YYDEBUG(666, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= '@'){
			if(yych <= ')'){
				if(yych <= '(')	goto yy3;
				goto yy136;
			} else {
				if(yych == '/')	goto yy144;
				goto yy3;
			}
		} else {
			if(yych <= 'O'){
				if(yych == 'C')	goto yy653;
				goto yy138;
			} else {
				if(yych <= 'P')	goto yy652;
				if(yych <= 'U')	goto yy138;
				goto yy654;
			}
		}
	} else {
		if(yych <= 'c'){
			if(yych <= '_'){
				if(yych <= 'Z')	goto yy138;
				if(yych <= '^')	goto yy3;
				goto yy144;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'b')	goto yy143;
				goto yy682;
			}
		} else {
			if(yych <= 'u'){
				if(yych == 'p')	goto yy681;
				goto yy143;
			} else {
				if(yych <= 'v')	goto yy683;
				if(yych <= 'z')	goto yy143;
				goto yy3;
			}
		}
	}
yy667:
	YYDEBUG(667, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy138;
			goto yy647;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy676;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy668:
	YYDEBUG(668, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'X'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'W')	goto yy138;
			goto yy645;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'x')	goto yy674;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy669:
	YYDEBUG(669, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy641;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy670;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy670:
	YYDEBUG(670, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy417;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy417;
			if(yych <= 'C')	goto yy139;
			goto yy642;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy417;
		} else {
			if(yych == 'd')	goto yy671;
			if(yych <= 'z')	goto yy148;
			goto yy417;
		}
	}
yy671:
	YYDEBUG(671, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy643;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy672;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy672:
	YYDEBUG(672, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Y'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'X')	goto yy141;
			goto yy644;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'y')	goto yy673;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy673:
	YYDEBUG(673, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == ')')	goto yy136;
		if(yych <= '.')	goto yy417;
		goto yy144;
	} else {
		if(yych <= '_'){
			if(yych <= '^')	goto yy417;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy417;
			if(yych <= 'z')	goto yy151;
			goto yy417;
		}
	}
yy674:
	YYDEBUG(674, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy646;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy675;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy675:
	YYDEBUG(675, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy406;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy676:
	YYDEBUG(676, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy417;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy417;
			if(yych <= 'T')	goto yy139;
			goto yy648;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy417;
		} else {
			if(yych == 'u')	goto yy677;
			if(yych <= 'z')	goto yy148;
			goto yy417;
		}
	}
yy677:
	YYDEBUG(677, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy140;
			goto yy649;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy678;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy678:
	YYDEBUG(678, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy141;
			goto yy650;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'd')	goto yy679;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy679:
	YYDEBUG(679, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy651;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy680;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy680:
	YYDEBUG(680, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy423;
	if(yych == 'y')	goto yy436;
	goto yy152;
yy681:
	YYDEBUG(681, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'S'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'T')	goto yy661;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 's'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 't')	goto yy690;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy682:
	YYDEBUG(682, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'O'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy139;
			goto yy658;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'o')	goto yy687;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy683:
	YYDEBUG(683, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy139;
			goto yy655;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy684;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy684:
	YYDEBUG(684, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy140;
			goto yy656;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy685;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy685:
	YYDEBUG(685, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy141;
			goto yy657;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy686;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy686:
	YYDEBUG(686, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'G')	goto yy3;
			goto yy167;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy253;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy687:
	YYDEBUG(687, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy140;
			goto yy659;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy688;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy688:
	YYDEBUG(688, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy141;
			goto yy660;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'd')	goto yy689;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy689:
	YYDEBUG(689, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	case 'D':	case 'F':	case 'H':	case 'M':	case 'S':
	case 'T':	case 'W':	case 'Y':	goto yy168;
	case ')':	goto yy136;
	case '/':	case '_':	goto yy144;
	case 'a':
	case 'b':
	case 'c':	case 'e':	case 'g':	case 'i':
	case 'j':
	case 'k':
	case 'l':	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':	case 'u':
	case 'v':	case 'x':	case 'z':	goto yy151;
	case 'd':	goto yy257;
	case 'f':	goto yy259;
	case 'h':	goto yy256;
	case 'm':	goto yy255;
	case 's':	goto yy254;
	case 't':	goto yy261;
	case 'w':	goto yy258;
	case 'y':	goto yy260;
	default:	goto yy3;
	}
yy690:
	YYDEBUG(690, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'D'){
				if(yych <= '@')	goto yy444;
				goto yy140;
			} else {
				if(yych <= 'E')	goto yy662;
				if(yych <= 'Z')	goto yy140;
				goto yy444;
			}
		} else {
			if(yych <= 'd'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy149;
			} else {
				if(yych <= 'e')	goto yy691;
				if(yych <= 'z')	goto yy149;
				goto yy444;
			}
		}
	}
yy691:
	YYDEBUG(691, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'M'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'L')	goto yy141;
			goto yy663;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'm')	goto yy692;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy692:
	YYDEBUG(692, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'B'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'A')	goto yy3;
			goto yy664;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'b')	goto yy693;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy693:
	YYDEBUG(693, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy665;
	if(yych != 'e')	goto yy152;
	goto yy694;
yy694:
	YYDEBUG(694, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy456;
	if(yych == 'r')	goto yy626;
	goto yy152;
yy695:
	YYDEBUG(695, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'G'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'F')	goto yy138;
			goto yy703;
		}
	} else {
		if(yych <= 'f'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'g')	goto yy703;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy696:
	YYDEBUG(696, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy138;
			goto yy700;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'r')	goto yy700;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy697:
	YYDEBUG(697, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy138;
			goto yy698;
		}
	} else {
		if(yych <= 'n'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'o')	goto yy698;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy698:
	YYDEBUG(698, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '@'){
		if(yych == ')')	goto yy136;
		goto yy699;
	} else {
		if(yych <= 'Z')	goto yy139;
		if(yych <= '`')	goto yy699;
		if(yych <= 'z')	goto yy139;
		goto yy699;
	}
yy699:
	YYDEBUG(699, *YYCURSOR);

{
		DEBUG_OUTPUT("ago");
		TIMELIB_INIT;
		s->time->relative.y = 0 - s->time->relative.y;
		s->time->relative.m = 0 - s->time->relative.m;
		s->time->relative.d = 0 - s->time->relative.d;
		s->time->relative.h = 0 - s->time->relative.h;
		s->time->relative.i = 0 - s->time->relative.i;
		s->time->relative.s = 0 - s->time->relative.s;
		s->time->relative.weekday = 0 - s->time->relative.weekday;
		if (s->time->have_special_relative && s->time->special.type == TIMELIB_SPECIAL_WEEKDAY) {
			s->time->special.amount = 0 - s->time->special.amount;
		}
		TIMELIB_DEINIT;
		return TIMELIB_AGO;
	}
yy700:
	YYDEBUG(700, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych != 'I')	goto yy139;
				goto yy701;
			}
		} else {
			if(yych <= 'h'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'i')	goto yy701;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy701:
	YYDEBUG(701, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'K')	goto yy140;
			goto yy702;
		}
	} else {
		if(yych <= 'k'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'l')	goto yy702;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy702:
	YYDEBUG(702, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy446;
			goto yy444;
		} else {
			if(yych <= ' ')	goto yy446;
			if(yych == ')')	goto yy136;
			goto yy444;
		}
	} else {
		if(yych <= '@'){
			if(yych == '/')	goto yy444;
			if(yych <= '9')	goto yy446;
			goto yy444;
		} else {
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy444;
			if(yych <= 'z')	goto yy141;
			goto yy444;
		}
	}
yy703:
	YYDEBUG(703, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych != 'U')	goto yy139;
				goto yy704;
			}
		} else {
			if(yych <= 't'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'u')	goto yy704;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy704:
	YYDEBUG(704, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy140;
			goto yy705;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 's')	goto yy705;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy705:
	YYDEBUG(705, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy141;
			goto yy706;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 't')	goto yy706;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy706:
	YYDEBUG(706, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '('){
		if(yych <= 0x09){
			if(yych <= 0x08)	goto yy444;
			goto yy446;
		} else {
			if(yych == ' ')	goto yy446;
			goto yy444;
		}
	} else {
		if(yych <= '.'){
			if(yych <= ')')	goto yy136;
			if(yych <= ',')	goto yy444;
			goto yy446;
		} else {
			if(yych <= '/')	goto yy444;
			if(yych <= '9')	goto yy446;
			goto yy444;
		}
	}
yy707:
	YYDEBUG(707, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'G'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'F')	goto yy138;
			goto yy703;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'g')	goto yy714;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy708:
	YYDEBUG(708, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy138;
			goto yy700;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy711;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy709:
	YYDEBUG(709, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'O'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy138;
			goto yy698;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'o')	goto yy710;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy710:
	YYDEBUG(710, *YYCURSOR);
	yyaccept = 10;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy699;
			goto yy136;
		} else {
			if(yych == '/')	goto yy144;
			goto yy699;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '^')	goto yy699;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy699;
			if(yych <= 'z')	goto yy148;
			goto yy699;
		}
	}
yy711:
	YYDEBUG(711, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'H'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'I')	goto yy701;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 'h'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'i')	goto yy712;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy712:
	YYDEBUG(712, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'L'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'K')	goto yy140;
			goto yy702;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'l')	goto yy713;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy713:
	YYDEBUG(713, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy444;
			goto yy446;
		} else {
			if(yych == ')')	goto yy136;
			if(yych <= ',')	goto yy444;
			goto yy446;
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '/')	goto yy144;
			if(yych <= '9')	goto yy446;
			if(yych <= '@')	goto yy444;
			goto yy141;
		} else {
			if(yych <= '_'){
				if(yych <= '^')	goto yy444;
				goto yy144;
			} else {
				if(yych <= '`')	goto yy444;
				if(yych <= 'z')	goto yy150;
				goto yy444;
			}
		}
	}
yy714:
	YYDEBUG(714, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'T'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'U')	goto yy704;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 't'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'u')	goto yy715;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy715:
	YYDEBUG(715, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy140;
			goto yy705;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 's')	goto yy716;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy716:
	YYDEBUG(716, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy141;
			goto yy706;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy717;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy717:
	YYDEBUG(717, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy446;
			goto yy444;
		} else {
			if(yych <= ' ')	goto yy446;
			if(yych == ')')	goto yy136;
			goto yy444;
		}
	} else {
		if(yych <= '^'){
			if(yych == '/')	goto yy144;
			if(yych <= '9')	goto yy446;
			goto yy444;
		} else {
			if(yych <= '_')	goto yy144;
			if(yych <= '`')	goto yy444;
			if(yych <= 'z')	goto yy151;
			goto yy444;
		}
	}
yy718:
	YYDEBUG(718, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'B'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'A')	goto yy138;
			goto yy732;
		}
	} else {
		if(yych <= 'a'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'b')	goto yy732;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy719:
	YYDEBUG(719, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'F')	goto yy729;
			if(yych <= 'Q')	goto yy138;
			goto yy728;
		}
	} else {
		if(yych <= 'f'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			if(yych <= 'e')	goto yy138;
			goto yy729;
		} else {
			if(yych == 'r')	goto yy728;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy720:
	YYDEBUG(720, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'T')	goto yy138;
			goto yy725;
		}
	} else {
		if(yych <= 't'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'u')	goto yy725;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy721:
	YYDEBUG(721, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'I'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'H')	goto yy138;
			goto yy722;
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'i')	goto yy722;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy722:
	YYDEBUG(722, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy417;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy417;
			if(yych <= 'C')	goto yy139;
			goto yy723;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy417;
			goto yy139;
		} else {
			if(yych <= 'd')	goto yy723;
			if(yych <= 'z')	goto yy139;
			goto yy417;
		}
	}
yy723:
	YYDEBUG(723, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy724;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy724;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy724:
	YYDEBUG(724, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'X')	goto yy141;
			goto yy644;
		}
	} else {
		if(yych <= 'x'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'y')	goto yy644;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy725:
	YYDEBUG(725, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy139;
			goto yy726;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'r')	goto yy726;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy726:
	YYDEBUG(726, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy140;
			goto yy727;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 't')	goto yy727;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy727:
	YYDEBUG(727, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy141;
			goto yy660;
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'h')	goto yy660;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy728:
	YYDEBUG(728, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy139;
			goto yy731;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 's')	goto yy731;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy729:
	YYDEBUG(729, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy730;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 't')	goto yy730;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy730:
	YYDEBUG(730, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'h')	goto yy388;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy731:
	YYDEBUG(731, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 't')	goto yy388;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy732:
	YYDEBUG(732, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych != 'R')	goto yy139;
				goto yy733;
			}
		} else {
			if(yych <= 'q'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'r')	goto yy733;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy733:
	YYDEBUG(733, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'T')	goto yy140;
			goto yy734;
		}
	} else {
		if(yych <= 't'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'u')	goto yy734;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy734:
	YYDEBUG(734, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy735;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy735;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy735:
	YYDEBUG(735, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Q'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'R')	goto yy736;
		if(yych != 'r')	goto yy3;
		goto yy736;
	}
yy736:
	YYDEBUG(736, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy456;
	if(yych == 'y')	goto yy456;
	goto yy53;
yy737:
	YYDEBUG(737, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'B'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'A')	goto yy138;
			goto yy732;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'b')	goto yy751;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy738:
	YYDEBUG(738, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= 'E'){
				if(yych <= '@')	goto yy3;
				goto yy138;
			} else {
				if(yych <= 'F')	goto yy729;
				if(yych <= 'Q')	goto yy138;
				goto yy728;
			}
		}
	} else {
		if(yych <= 'e'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy138;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy143;
			}
		} else {
			if(yych <= 'q'){
				if(yych <= 'f')	goto yy748;
				goto yy143;
			} else {
				if(yych <= 'r')	goto yy747;
				if(yych <= 'z')	goto yy143;
				goto yy3;
			}
		}
	}
yy739:
	YYDEBUG(739, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'T')	goto yy138;
			goto yy725;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'u')	goto yy744;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy740:
	YYDEBUG(740, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'I'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'H')	goto yy138;
			goto yy722;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'i')	goto yy741;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy741:
	YYDEBUG(741, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy417;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy417;
			if(yych <= 'C')	goto yy139;
			goto yy723;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy417;
		} else {
			if(yych == 'd')	goto yy742;
			if(yych <= 'z')	goto yy148;
			goto yy417;
		}
	}
yy742:
	YYDEBUG(742, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy724;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy743;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy743:
	YYDEBUG(743, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Y'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'X')	goto yy141;
			goto yy644;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'y')	goto yy673;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy744:
	YYDEBUG(744, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy139;
			goto yy726;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy745;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy745:
	YYDEBUG(745, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy140;
			goto yy727;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy746;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy746:
	YYDEBUG(746, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy141;
			goto yy660;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy689;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy747:
	YYDEBUG(747, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy139;
			goto yy731;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 's')	goto yy750;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy748:
	YYDEBUG(748, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy730;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy749;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy749:
	YYDEBUG(749, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy406;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy750:
	YYDEBUG(750, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy406;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy751:
	YYDEBUG(751, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'Q'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'R')	goto yy733;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 'q'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'r')	goto yy752;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy752:
	YYDEBUG(752, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'T')	goto yy140;
			goto yy734;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'u')	goto yy753;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy753:
	YYDEBUG(753, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy735;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy754;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy754:
	YYDEBUG(754, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'Q')	goto yy3;
			goto yy736;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy755;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy755:
	YYDEBUG(755, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy456;
	if(yych == 'y')	goto yy626;
	goto yy152;
yy756:
	YYDEBUG(756, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'L')	goto yy763;
			if(yych <= 'M')	goto yy138;
			goto yy762;
		}
	} else {
		if(yych <= 'l'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			if(yych <= 'k')	goto yy138;
			goto yy763;
		} else {
			if(yych == 'n')	goto yy762;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy757:
	YYDEBUG(757, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy758;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'n')	goto yy758;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy758:
	YYDEBUG(758, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych != 'U')	goto yy139;
				goto yy759;
			}
		} else {
			if(yych <= 't'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'u')	goto yy759;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy759:
	YYDEBUG(759, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy760;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy760;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy760:
	YYDEBUG(760, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy141;
			goto yy761;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'r')	goto yy761;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy761:
	YYDEBUG(761, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Y')	goto yy456;
		if(yych == 'y')	goto yy456;
		goto yy3;
	}
yy762:
	YYDEBUG(762, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych == 'E')	goto yy764;
				goto yy139;
			}
		} else {
			if(yych <= 'd'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'e')	goto yy764;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy763:
	YYDEBUG(763, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych != 'Y')	goto yy139;
				goto yy764;
			}
		} else {
			if(yych <= 'x'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'y')	goto yy764;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy764:
	YYDEBUG(764, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy446;
			goto yy444;
		} else {
			if(yych <= ' ')	goto yy446;
			if(yych == ')')	goto yy136;
			goto yy444;
		}
	} else {
		if(yych <= '@'){
			if(yych == '/')	goto yy444;
			if(yych <= '9')	goto yy446;
			goto yy444;
		} else {
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy444;
			if(yych <= 'z')	goto yy140;
			goto yy444;
		}
	}
yy765:
	YYDEBUG(765, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= 'K'){
				if(yych <= '@')	goto yy3;
				goto yy138;
			} else {
				if(yych <= 'L')	goto yy763;
				if(yych <= 'M')	goto yy138;
				goto yy762;
			}
		}
	} else {
		if(yych <= 'k'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy138;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy143;
			}
		} else {
			if(yych <= 'm'){
				if(yych <= 'l')	goto yy772;
				goto yy143;
			} else {
				if(yych <= 'n')	goto yy771;
				if(yych <= 'z')	goto yy143;
				goto yy3;
			}
		}
	}
yy766:
	YYDEBUG(766, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy758;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy767;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy767:
	YYDEBUG(767, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'T'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'U')	goto yy759;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 't'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'u')	goto yy768;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy768:
	YYDEBUG(768, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy760;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy769;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy769:
	YYDEBUG(769, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy141;
			goto yy761;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy770;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy770:
	YYDEBUG(770, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Y'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'X')	goto yy3;
			goto yy456;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'y')	goto yy626;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy771:
	YYDEBUG(771, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'D'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'E')	goto yy764;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 'd'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'e')	goto yy773;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy772:
	YYDEBUG(772, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'X'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'Y')	goto yy764;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 'x'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'y')	goto yy773;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy773:
	YYDEBUG(773, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy444;
			goto yy446;
		} else {
			if(yych == ')')	goto yy136;
			if(yych <= ',')	goto yy444;
			goto yy446;
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '/')	goto yy144;
			if(yych <= '9')	goto yy446;
			if(yych <= '@')	goto yy444;
			goto yy140;
		} else {
			if(yych <= '_'){
				if(yych <= '^')	goto yy444;
				goto yy144;
			} else {
				if(yych <= '`')	goto yy444;
				if(yych <= 'z')	goto yy149;
				goto yy444;
			}
		}
	}
yy774:
	YYDEBUG(774, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy3;
			goto yy446;
		} else {
			if(yych == ')')	goto yy136;
			if(yych <= ',')	goto yy3;
			goto yy446;
		}
	} else {
		if(yych <= 'H'){
			if(yych <= '/')	goto yy3;
			if(yych <= '9')	goto yy446;
			if(yych <= '@')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'Z'){
				if(yych >= 'J')	goto yy138;
				goto yy775;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'z')	goto yy138;
				goto yy3;
			}
		}
	}
yy775:
	YYDEBUG(775, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy446;
			goto yy3;
		} else {
			if(yych <= ' ')	goto yy446;
			if(yych == ')')	goto yy136;
			goto yy3;
		}
	} else {
		if(yych <= '@'){
			if(yych == '/')	goto yy3;
			if(yych <= '9')	goto yy446;
			goto yy3;
		} else {
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy776:
	YYDEBUG(776, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy3;
			goto yy446;
		} else {
			if(yych == ')')	goto yy136;
			if(yych <= ',')	goto yy3;
			goto yy446;
		}
	} else {
		if(yych <= 'H'){
			if(yych <= '/')	goto yy3;
			if(yych <= '9')	goto yy446;
			if(yych <= '@')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'Z'){
				if(yych >= 'J')	goto yy138;
				goto yy777;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'z')	goto yy138;
				goto yy3;
			}
		}
	}
yy777:
	YYDEBUG(777, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy3;
			goto yy446;
		} else {
			if(yych == ')')	goto yy136;
			if(yych <= ',')	goto yy3;
			goto yy446;
		}
	} else {
		if(yych <= 'H'){
			if(yych <= '/')	goto yy3;
			if(yych <= '9')	goto yy446;
			if(yych <= '@')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'Z'){
				if(yych >= 'J')	goto yy139;
				goto yy778;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'z')	goto yy139;
				goto yy3;
			}
		}
	}
yy778:
	YYDEBUG(778, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy446;
			goto yy3;
		} else {
			if(yych <= ' ')	goto yy446;
			if(yych == ')')	goto yy136;
			goto yy3;
		}
	} else {
		if(yych <= '@'){
			if(yych == '/')	goto yy3;
			if(yych <= '9')	goto yy446;
			goto yy3;
		} else {
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy779:
	YYDEBUG(779, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy446;
			goto yy3;
		} else {
			if(yych <= ' ')	goto yy446;
			if(yych == ')')	goto yy136;
			goto yy3;
		}
	} else {
		if(yych <= '@'){
			if(yych == '/')	goto yy3;
			if(yych <= '9')	goto yy446;
			goto yy3;
		} else {
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy780:
	YYDEBUG(780, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy3;
			goto yy446;
		} else {
			if(yych == ')')	goto yy136;
			if(yych <= ',')	goto yy3;
			goto yy446;
		}
	} else {
		if(yych <= 'H'){
			if(yych <= '/')	goto yy3;
			if(yych <= '9')	goto yy446;
			if(yych <= '@')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'Z'){
				if(yych <= 'I')	goto yy775;
				goto yy138;
			} else {
				if(yych <= '`')	goto yy3;
				if(yych <= 'z')	goto yy138;
				goto yy3;
			}
		}
	}
yy781:
	YYDEBUG(781, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy783;
	if(yych <= '0')	goto yy1031;
	if(yych <= '1')	goto yy1032;
	if(yych <= '9')	goto yy1033;
	goto yy783;
yy782:
	YYDEBUG(782, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 13) YYFILL(13);
	yych = *YYCURSOR;
	goto yy783;
yy783:
	YYDEBUG(783, *YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	goto yy782;
	case '-':
	case '.':	goto yy882;
	case 'A':	case 'a':	goto yy801;
	case 'D':	case 'd':	goto yy787;
	case 'F':	case 'f':	goto yy788;
	case 'H':	case 'h':	goto yy60;
	case 'I':	goto yy796;
	case 'J':	case 'j':	goto yy800;
	case 'M':	case 'm':	goto yy786;
	case 'N':	case 'n':	goto yy803;
	case 'O':	case 'o':	goto yy802;
	case 'P':	case 'p':	goto yy805;
	case 'S':	case 's':	goto yy784;
	case 'T':	case 't':	goto yy65;
	case 'V':	goto yy798;
	case 'W':	case 'w':	goto yy62;
	case 'X':	goto yy799;
	case 'Y':	case 'y':	goto yy64;
	default:	goto yy53;
	}
yy784:
	YYDEBUG(784, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'D'){
			if(yych == 'A')	goto yy123;
			goto yy53;
		} else {
			if(yych <= 'E')	goto yy1327;
			if(yych <= 'T')	goto yy53;
			goto yy122;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'a')	goto yy123;
			goto yy53;
		} else {
			if(yych <= 'e')	goto yy1327;
			if(yych == 'u')	goto yy122;
			goto yy53;
		}
	}
yy785:
	YYDEBUG(785, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '`'){
		if(yych <= 'D'){
			if(yych == 'A')	goto yy123;
			goto yy53;
		} else {
			if(yych <= 'E')	goto yy1327;
			if(yych == 'U')	goto yy122;
			goto yy53;
		}
	} else {
		if(yych <= 'e'){
			if(yych <= 'a')	goto yy123;
			if(yych <= 'd')	goto yy53;
			goto yy1327;
		} else {
			if(yych <= 's')	goto yy53;
			if(yych <= 't')	goto yy1028;
			if(yych <= 'u')	goto yy122;
			goto yy53;
		}
	}
yy786:
	YYDEBUG(786, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'H'){
			if(yych == 'A')	goto yy897;
			goto yy53;
		} else {
			if(yych <= 'I')	goto yy114;
			if(yych <= 'N')	goto yy53;
			goto yy113;
		}
	} else {
		if(yych <= 'h'){
			if(yych == 'a')	goto yy897;
			goto yy53;
		} else {
			if(yych <= 'i')	goto yy114;
			if(yych == 'o')	goto yy113;
			goto yy53;
		}
	}
yy787:
	YYDEBUG(787, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych == 'A')	goto yy110;
		if(yych <= 'D')	goto yy53;
		goto yy884;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy53;
			goto yy110;
		} else {
			if(yych == 'e')	goto yy884;
			goto yy53;
		}
	}
yy788:
	YYDEBUG(788, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'N'){
			if(yych == 'E')	goto yy900;
			goto yy53;
		} else {
			if(yych <= 'O')	goto yy83;
			if(yych <= 'Q')	goto yy53;
			goto yy82;
		}
	} else {
		if(yych <= 'n'){
			if(yych == 'e')	goto yy900;
			goto yy53;
		} else {
			if(yych <= 'o')	goto yy83;
			if(yych == 'r')	goto yy82;
			goto yy53;
		}
	}
yy789:
	YYDEBUG(789, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'H')	goto yy66;
		if(yych <= 'T')	goto yy53;
		goto yy67;
	} else {
		if(yych <= 'h'){
			if(yych <= 'g')	goto yy53;
			goto yy1326;
		} else {
			if(yych == 'u')	goto yy67;
			goto yy53;
		}
	}
yy790:
	YYDEBUG(790, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '-')	goto yy1035;
	if(yych <= '/')	goto yy57;
	if(yych <= '9')	goto yy1034;
	goto yy57;
yy791:
	YYDEBUG(791, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'c'){
		if(yych == 'O')	goto yy835;
		goto yy53;
	} else {
		if(yych <= 'd')	goto yy1028;
		if(yych == 'o')	goto yy835;
		goto yy53;
	}
yy792:
	YYDEBUG(792, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'd')	goto yy1028;
	goto yy53;
yy793:
	YYDEBUG(793, *YYCURSOR);
	yych = *++YYCURSOR;
	YYDEBUG(-1, yych);
	switch(yych){
	case '0':
	case '1':
	case '2':	goto yy968;
	case '3':	goto yy970;
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy971;
	case 'A':	case 'a':	goto yy975;
	case 'D':	case 'd':	goto yy979;
	case 'F':	case 'f':	goto yy973;
	case 'J':	case 'j':	goto yy972;
	case 'M':	case 'm':	goto yy974;
	case 'N':	case 'n':	goto yy978;
	case 'O':	case 'o':	goto yy977;
	case 'S':	case 's':	goto yy976;
	default:	goto yy53;
	}
yy794:
	YYDEBUG(794, *YYCURSOR);
	yych = *++YYCURSOR;
	YYDEBUG(-1, yych);
	switch(yych){
	case '0':	goto yy918;
	case '1':	goto yy919;
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy920;
	case 'A':	case 'a':	goto yy924;
	case 'D':	case 'd':	goto yy928;
	case 'F':	case 'f':	goto yy922;
	case 'J':	case 'j':	goto yy921;
	case 'M':	case 'm':	goto yy923;
	case 'N':	case 'n':	goto yy927;
	case 'O':	case 'o':	goto yy926;
	case 'S':	case 's':	goto yy925;
	default:	goto yy883;
	}
yy795:
	YYDEBUG(795, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '1'){
		if(yych <= '/')	goto yy883;
		if(yych <= '0')	goto yy873;
		goto yy874;
	} else {
		if(yych <= '5')	goto yy875;
		if(yych <= '9')	goto yy876;
		goto yy883;
	}
yy796:
	YYDEBUG(796, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '.')	goto yy837;
			goto yy797;
		}
	} else {
		if(yych <= 'U'){
			if(yych <= '9')	goto yy839;
			if(yych == 'I')	goto yy872;
			goto yy797;
		} else {
			if(yych == 'W')	goto yy797;
			if(yych <= 'X')	goto yy845;
			goto yy797;
		}
	}
yy797:
	YYDEBUG(797, *YYCURSOR);

{
		DEBUG_OUTPUT("datenoyearrev");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		timelib_skip_day_suffix((char **) &ptr);
		s->time->m = timelib_get_month((char **) &ptr);
		TIMELIB_DEINIT;
		return TIMELIB_DATE_TEXT;
	}
yy798:
	YYDEBUG(798, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x09){
			if(yych <= 0x08)	goto yy797;
			goto yy837;
		} else {
			if(yych == ' ')	goto yy837;
			goto yy797;
		}
	} else {
		if(yych <= '9'){
			if(yych <= '.')	goto yy837;
			if(yych <= '/')	goto yy797;
			goto yy839;
		} else {
			if(yych == 'I')	goto yy870;
			goto yy797;
		}
	}
yy799:
	YYDEBUG(799, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x09){
			if(yych <= 0x08)	goto yy797;
			goto yy837;
		} else {
			if(yych == ' ')	goto yy837;
			goto yy797;
		}
	} else {
		if(yych <= '9'){
			if(yych <= '.')	goto yy837;
			if(yych <= '/')	goto yy797;
			goto yy839;
		} else {
			if(yych == 'I')	goto yy869;
			goto yy797;
		}
	}
yy800:
	YYDEBUG(800, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'A')	goto yy862;
		if(yych <= 'T')	goto yy53;
		goto yy861;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy53;
			goto yy862;
		} else {
			if(yych == 'u')	goto yy861;
			goto yy53;
		}
	}
yy801:
	YYDEBUG(801, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= 'L'){
			if(yych == '.')	goto yy806;
			goto yy53;
		} else {
			if(yych <= 'M')	goto yy807;
			if(yych == 'P')	goto yy855;
			goto yy53;
		}
	} else {
		if(yych <= 'o'){
			if(yych <= 'U')	goto yy854;
			if(yych == 'm')	goto yy807;
			goto yy53;
		} else {
			if(yych <= 'p')	goto yy855;
			if(yych == 'u')	goto yy854;
			goto yy53;
		}
	}
yy802:
	YYDEBUG(802, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy849;
	if(yych == 'c')	goto yy849;
	goto yy53;
yy803:
	YYDEBUG(803, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy835;
	if(yych == 'o')	goto yy835;
	goto yy53;
yy804:
	YYDEBUG(804, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy811;
	if(yych <= '9')	goto yy813;
	goto yy53;
yy805:
	YYDEBUG(805, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych != '.')	goto yy53;
		goto yy806;
	} else {
		if(yych <= 'M')	goto yy807;
		if(yych == 'm')	goto yy807;
		goto yy53;
	}
yy806:
	YYDEBUG(806, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy807;
	if(yych != 'm')	goto yy53;
	goto yy807;
yy807:
	YYDEBUG(807, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x1F){
		if(yych <= 0x00)	goto yy809;
		if(yych == 0x09)	goto yy809;
		goto yy53;
	} else {
		if(yych <= ' ')	goto yy809;
		if(yych != '.')	goto yy53;
		goto yy808;
	}
yy808:
	YYDEBUG(808, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x09){
		if(yych <= 0x00)	goto yy809;
		if(yych <= 0x08)	goto yy53;
		goto yy809;
	} else {
		if(yych != ' ')	goto yy53;
		goto yy809;
	}
yy809:
	YYDEBUG(809, *YYCURSOR);
	++YYCURSOR;
	goto yy810;
yy810:
	YYDEBUG(810, *YYCURSOR);

{
		DEBUG_OUTPUT("timetiny12 | timeshort12 | timelong12");
		TIMELIB_INIT;
		TIMELIB_HAVE_TIME();
		s->time->h = timelib_get_nr((char **) &ptr, 2);
		if (*ptr == ':' || *ptr == '.') {
			s->time->i = timelib_get_nr((char **) &ptr, 2);
			if (*ptr == ':' || *ptr == '.') {
				s->time->s = timelib_get_nr((char **) &ptr, 2);
			}
		}
		s->time->h += timelib_meridian((char **) &ptr, s->time->h);
		TIMELIB_DEINIT;
		return TIMELIB_TIME12;
	}
yy811:
	YYDEBUG(811, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy814;
		goto yy812;
	} else {
		if(yych <= '9')	goto yy828;
		if(yych <= ':')	goto yy814;
		goto yy812;
	}
yy812:
	YYDEBUG(812, *YYCURSOR);

{
		int tz_not_found;
		DEBUG_OUTPUT("timeshort24 | timelong24 | iso8601long");
		TIMELIB_INIT;
		TIMELIB_HAVE_TIME();
		s->time->h = timelib_get_nr((char **) &ptr, 2);
		s->time->i = timelib_get_nr((char **) &ptr, 2);
		if (*ptr == ':' || *ptr == '.') {
			s->time->s = timelib_get_nr((char **) &ptr, 2);

			if (*ptr == '.') {
				s->time->f = timelib_get_frac_nr((char **) &ptr, 8);
			}
		}

		if (*ptr != '\0') {
			s->time->z = timelib_get_zone((char **) &ptr, &s->time->dst, s->time, &tz_not_found, s->tzdb);
			if (tz_not_found) {
				add_error(s, "The timezone could not be found in the database");
			}
		}
		TIMELIB_DEINIT;
		return TIMELIB_TIME24_WITH_ZONE;
	}
yy813:
	YYDEBUG(813, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy814;
	if(yych != ':')	goto yy812;
	goto yy814;
yy814:
	YYDEBUG(814, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy815;
	if(yych <= '6')	goto yy816;
	if(yych <= '9')	goto yy817;
	goto yy53;
yy815:
	YYDEBUG(815, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy818;
	if(yych <= '/')	goto yy812;
	if(yych <= '9')	goto yy821;
	goto yy812;
yy816:
	YYDEBUG(816, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy818;
	if(yych == '0')	goto yy821;
	goto yy812;
yy817:
	YYDEBUG(817, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != '.')	goto yy812;
	goto yy818;
yy818:
	YYDEBUG(818, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy819;
yy819:
	YYDEBUG(819, *YYCURSOR);
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy820;
yy820:
	YYDEBUG(820, *YYCURSOR);
	if(yych <= '/')	goto yy812;
	if(yych <= '9')	goto yy819;
	goto yy812;
yy821:
	YYDEBUG(821, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= 0x1F){
			if(yych != 0x09)	goto yy812;
			goto yy822;
		} else {
			if(yych <= ' ')	goto yy822;
			if(yych == '.')	goto yy818;
			goto yy812;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'A')	goto yy824;
			if(yych == 'P')	goto yy824;
			goto yy812;
		} else {
			if(yych <= 'a')	goto yy824;
			if(yych == 'p')	goto yy824;
			goto yy812;
		}
	}
yy822:
	YYDEBUG(822, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	goto yy823;
yy823:
	YYDEBUG(823, *YYCURSOR);
	if(yych <= 'A'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy822;
			goto yy53;
		} else {
			if(yych <= ' ')	goto yy822;
			if(yych <= '@')	goto yy53;
			goto yy824;
		}
	} else {
		if(yych <= '`'){
			if(yych != 'P')	goto yy53;
			goto yy824;
		} else {
			if(yych <= 'a')	goto yy824;
			if(yych != 'p')	goto yy53;
			goto yy824;
		}
	}
yy824:
	YYDEBUG(824, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych != '.')	goto yy53;
		goto yy825;
	} else {
		if(yych <= 'M')	goto yy826;
		if(yych == 'm')	goto yy826;
		goto yy53;
	}
yy825:
	YYDEBUG(825, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy826;
	if(yych != 'm')	goto yy53;
	goto yy826;
yy826:
	YYDEBUG(826, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x1F){
		if(yych <= 0x00)	goto yy809;
		if(yych == 0x09)	goto yy809;
		goto yy53;
	} else {
		if(yych <= ' ')	goto yy809;
		if(yych != '.')	goto yy53;
		goto yy827;
	}
yy827:
	YYDEBUG(827, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x09){
		if(yych <= 0x00)	goto yy809;
		if(yych <= 0x08)	goto yy53;
		goto yy809;
	} else {
		if(yych == ' ')	goto yy809;
		goto yy53;
	}
yy828:
	YYDEBUG(828, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ':'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy829;
			if(yych <= 0x1F)	goto yy812;
			goto yy829;
		} else {
			if(yych == '.')	goto yy814;
			if(yych <= '9')	goto yy812;
			goto yy814;
		}
	} else {
		if(yych <= 'P'){
			if(yych == 'A')	goto yy831;
			if(yych <= 'O')	goto yy812;
			goto yy831;
		} else {
			if(yych <= 'a'){
				if(yych <= '`')	goto yy812;
				goto yy831;
			} else {
				if(yych == 'p')	goto yy831;
				goto yy812;
			}
		}
	}
yy829:
	YYDEBUG(829, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	goto yy830;
yy830:
	YYDEBUG(830, *YYCURSOR);
	if(yych <= 'A'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy829;
			goto yy53;
		} else {
			if(yych <= ' ')	goto yy829;
			if(yych <= '@')	goto yy53;
			goto yy831;
		}
	} else {
		if(yych <= '`'){
			if(yych != 'P')	goto yy53;
			goto yy831;
		} else {
			if(yych <= 'a')	goto yy831;
			if(yych != 'p')	goto yy53;
			goto yy831;
		}
	}
yy831:
	YYDEBUG(831, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych != '.')	goto yy53;
		goto yy832;
	} else {
		if(yych <= 'M')	goto yy833;
		if(yych == 'm')	goto yy833;
		goto yy53;
	}
yy832:
	YYDEBUG(832, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy833;
	if(yych != 'm')	goto yy53;
	goto yy833;
yy833:
	YYDEBUG(833, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x1F){
		if(yych <= 0x00)	goto yy809;
		if(yych == 0x09)	goto yy809;
		goto yy53;
	} else {
		if(yych <= ' ')	goto yy809;
		if(yych != '.')	goto yy53;
		goto yy834;
	}
yy834:
	YYDEBUG(834, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 0x09){
		if(yych <= 0x00)	goto yy809;
		if(yych <= 0x08)	goto yy53;
		goto yy809;
	} else {
		if(yych == ' ')	goto yy809;
		goto yy53;
	}
yy835:
	YYDEBUG(835, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy836;
	if(yych != 'v')	goto yy53;
	goto yy836;
yy836:
	YYDEBUG(836, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych != 0x09)	goto yy797;
			goto yy837;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'D'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'E')	goto yy841;
			if(yych == 'e')	goto yy841;
			goto yy797;
		}
	}
yy837:
	YYDEBUG(837, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	goto yy838;
yy838:
	YYDEBUG(838, *YYCURSOR);
	if(yych <= ' '){
		if(yych == 0x09)	goto yy837;
		if(yych <= 0x1F)	goto yy53;
		goto yy837;
	} else {
		if(yych <= '.'){
			if(yych <= ',')	goto yy53;
			goto yy837;
		} else {
			if(yych <= '/')	goto yy53;
			if(yych >= ':')	goto yy53;
			goto yy839;
		}
	}
yy839:
	YYDEBUG(839, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '/')	goto yy840;
	if(yych <= '9')	goto yy846;
	goto yy840;
yy840:
	YYDEBUG(840, *YYCURSOR);

{
		DEBUG_OUTPUT("datefull");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		timelib_skip_day_suffix((char **) &ptr);
		s->time->m = timelib_get_month((char **) &ptr);
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		TIMELIB_PROCESS_YEAR(s->time->y);
		TIMELIB_DEINIT;
		return TIMELIB_DATE_FULL;
	}
yy841:
	YYDEBUG(841, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy842;
	if(yych != 'm')	goto yy53;
	goto yy842;
yy842:
	YYDEBUG(842, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy843;
	if(yych != 'b')	goto yy53;
	goto yy843;
yy843:
	YYDEBUG(843, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy844;
	if(yych != 'e')	goto yy53;
	goto yy844;
yy844:
	YYDEBUG(844, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy845;
	if(yych != 'r')	goto yy53;
	goto yy845;
yy845:
	YYDEBUG(845, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ' '){
		if(yych == 0x09)	goto yy837;
		if(yych <= 0x1F)	goto yy797;
		goto yy837;
	} else {
		if(yych <= '.'){
			if(yych <= ',')	goto yy797;
			goto yy837;
		} else {
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		}
	}
yy846:
	YYDEBUG(846, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy840;
	if(yych >= ':')	goto yy840;
	goto yy847;
yy847:
	YYDEBUG(847, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy840;
	if(yych >= ':')	goto yy840;
	goto yy848;
yy848:
	YYDEBUG(848, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy840;
yy849:
	YYDEBUG(849, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy850;
	if(yych != 't')	goto yy53;
	goto yy850;
yy850:
	YYDEBUG(850, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'N'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'O')	goto yy851;
			if(yych != 'o')	goto yy797;
			goto yy851;
		}
	}
yy851:
	YYDEBUG(851, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy852;
	if(yych != 'b')	goto yy53;
	goto yy852;
yy852:
	YYDEBUG(852, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy853;
	if(yych != 'e')	goto yy53;
	goto yy853;
yy853:
	YYDEBUG(853, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy845;
	if(yych == 'r')	goto yy845;
	goto yy53;
yy854:
	YYDEBUG(854, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy858;
	if(yych == 'g')	goto yy858;
	goto yy53;
yy855:
	YYDEBUG(855, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy856;
	if(yych != 'r')	goto yy53;
	goto yy856;
yy856:
	YYDEBUG(856, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'H'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'I')	goto yy857;
			if(yych != 'i')	goto yy797;
			goto yy857;
		}
	}
yy857:
	YYDEBUG(857, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy845;
	if(yych == 'l')	goto yy845;
	goto yy53;
yy858:
	YYDEBUG(858, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'T'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'U')	goto yy859;
			if(yych != 'u')	goto yy797;
			goto yy859;
		}
	}
yy859:
	YYDEBUG(859, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy860;
	if(yych != 's')	goto yy53;
	goto yy860;
yy860:
	YYDEBUG(860, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy845;
	if(yych == 't')	goto yy845;
	goto yy53;
yy861:
	YYDEBUG(861, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'L')	goto yy868;
		if(yych <= 'M')	goto yy53;
		goto yy867;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy53;
			goto yy868;
		} else {
			if(yych == 'n')	goto yy867;
			goto yy53;
		}
	}
yy862:
	YYDEBUG(862, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy863;
	if(yych != 'n')	goto yy53;
	goto yy863;
yy863:
	YYDEBUG(863, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'T'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'U')	goto yy864;
			if(yych != 'u')	goto yy797;
			goto yy864;
		}
	}
yy864:
	YYDEBUG(864, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy865;
	if(yych != 'a')	goto yy53;
	goto yy865;
yy865:
	YYDEBUG(865, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy866;
	if(yych != 'r')	goto yy53;
	goto yy866;
yy866:
	YYDEBUG(866, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy845;
	if(yych == 'y')	goto yy845;
	goto yy53;
yy867:
	YYDEBUG(867, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'D'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'E')	goto yy845;
			if(yych == 'e')	goto yy845;
			goto yy797;
		}
	}
yy868:
	YYDEBUG(868, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'X'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'Y')	goto yy845;
			if(yych == 'y')	goto yy845;
			goto yy797;
		}
	}
yy869:
	YYDEBUG(869, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x09){
			if(yych <= 0x08)	goto yy797;
			goto yy837;
		} else {
			if(yych == ' ')	goto yy837;
			goto yy797;
		}
	} else {
		if(yych <= '9'){
			if(yych <= '.')	goto yy837;
			if(yych <= '/')	goto yy797;
			goto yy839;
		} else {
			if(yych == 'I')	goto yy845;
			goto yy797;
		}
	}
yy870:
	YYDEBUG(870, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x09){
			if(yych <= 0x08)	goto yy797;
			goto yy837;
		} else {
			if(yych == ' ')	goto yy837;
			goto yy797;
		}
	} else {
		if(yych <= '9'){
			if(yych <= '.')	goto yy837;
			if(yych <= '/')	goto yy797;
			goto yy839;
		} else {
			if(yych != 'I')	goto yy797;
			goto yy871;
		}
	}
yy871:
	YYDEBUG(871, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x09){
			if(yych <= 0x08)	goto yy797;
			goto yy837;
		} else {
			if(yych == ' ')	goto yy837;
			goto yy797;
		}
	} else {
		if(yych <= '9'){
			if(yych <= '.')	goto yy837;
			if(yych <= '/')	goto yy797;
			goto yy839;
		} else {
			if(yych == 'I')	goto yy845;
			goto yy797;
		}
	}
yy872:
	YYDEBUG(872, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x09){
			if(yych <= 0x08)	goto yy797;
			goto yy837;
		} else {
			if(yych == ' ')	goto yy837;
			goto yy797;
		}
	} else {
		if(yych <= '9'){
			if(yych <= '.')	goto yy837;
			if(yych <= '/')	goto yy797;
			goto yy839;
		} else {
			if(yych == 'I')	goto yy845;
			goto yy797;
		}
	}
yy873:
	YYDEBUG(873, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ',')	goto yy812;
		if(yych <= '-')	goto yy906;
		goto yy907;
	} else {
		if(yych <= '/')	goto yy812;
		if(yych <= '9')	goto yy917;
		if(yych <= ':')	goto yy814;
		goto yy812;
	}
yy874:
	YYDEBUG(874, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= ',')	goto yy812;
		if(yych <= '-')	goto yy906;
		if(yych <= '.')	goto yy907;
		goto yy812;
	} else {
		if(yych <= '2')	goto yy917;
		if(yych <= '9')	goto yy828;
		if(yych <= ':')	goto yy814;
		goto yy812;
	}
yy875:
	YYDEBUG(875, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ',')	goto yy812;
		if(yych <= '-')	goto yy906;
		goto yy907;
	} else {
		if(yych <= '/')	goto yy812;
		if(yych <= '9')	goto yy828;
		if(yych <= ':')	goto yy814;
		goto yy812;
	}
yy876:
	YYDEBUG(876, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ',')	goto yy812;
		if(yych <= '-')	goto yy906;
		goto yy907;
	} else {
		if(yych == ':')	goto yy814;
		goto yy812;
	}
yy877:
	YYDEBUG(877, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy900;
	if(yych == 'e')	goto yy900;
	goto yy53;
yy878:
	YYDEBUG(878, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy897;
	if(yych == 'a')	goto yy897;
	goto yy53;
yy879:
	YYDEBUG(879, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'P')	goto yy855;
		if(yych <= 'T')	goto yy53;
		goto yy854;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy53;
			goto yy855;
		} else {
			if(yych == 'u')	goto yy854;
			goto yy53;
		}
	}
yy880:
	YYDEBUG(880, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy890;
	if(yych == 'e')	goto yy890;
	goto yy53;
yy881:
	YYDEBUG(881, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy884;
	if(yych == 'e')	goto yy884;
	goto yy53;
yy882:
	YYDEBUG(882, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 13) YYFILL(13);
	yych = *YYCURSOR;
	goto yy883;
yy883:
	YYDEBUG(883, *YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	case '-':
	case '.':	goto yy882;
	case 'A':	case 'a':	goto yy879;
	case 'D':	case 'd':	goto yy881;
	case 'F':	case 'f':	goto yy877;
	case 'I':	goto yy796;
	case 'J':	case 'j':	goto yy800;
	case 'M':	case 'm':	goto yy878;
	case 'N':	case 'n':	goto yy803;
	case 'O':	case 'o':	goto yy802;
	case 'S':	case 's':	goto yy880;
	case 'V':	goto yy798;
	case 'X':	goto yy799;
	default:	goto yy53;
	}
yy884:
	YYDEBUG(884, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy885;
	if(yych != 'c')	goto yy53;
	goto yy885;
yy885:
	YYDEBUG(885, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'D'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'E')	goto yy886;
			if(yych != 'e')	goto yy797;
			goto yy886;
		}
	}
yy886:
	YYDEBUG(886, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy887;
	if(yych != 'm')	goto yy53;
	goto yy887;
yy887:
	YYDEBUG(887, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy888;
	if(yych != 'b')	goto yy53;
	goto yy888;
yy888:
	YYDEBUG(888, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy889;
	if(yych != 'e')	goto yy53;
	goto yy889;
yy889:
	YYDEBUG(889, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy845;
	if(yych == 'r')	goto yy845;
	goto yy53;
yy890:
	YYDEBUG(890, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy891;
	if(yych != 'p')	goto yy53;
	goto yy891;
yy891:
	YYDEBUG(891, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'S'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'T')	goto yy892;
			if(yych != 't')	goto yy797;
			goto yy892;
		}
	}
yy892:
	YYDEBUG(892, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'D'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'E')	goto yy893;
			if(yych != 'e')	goto yy797;
			goto yy893;
		}
	}
yy893:
	YYDEBUG(893, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy894;
	if(yych != 'm')	goto yy53;
	goto yy894;
yy894:
	YYDEBUG(894, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy895;
	if(yych != 'b')	goto yy53;
	goto yy895;
yy895:
	YYDEBUG(895, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy896;
	if(yych != 'e')	goto yy53;
	goto yy896;
yy896:
	YYDEBUG(896, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy845;
	if(yych == 'r')	goto yy845;
	goto yy53;
yy897:
	YYDEBUG(897, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych == 'R')	goto yy898;
		if(yych <= 'X')	goto yy53;
		goto yy845;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy53;
			goto yy898;
		} else {
			if(yych == 'y')	goto yy845;
			goto yy53;
		}
	}
yy898:
	YYDEBUG(898, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'B'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'C')	goto yy899;
			if(yych != 'c')	goto yy797;
			goto yy899;
		}
	}
yy899:
	YYDEBUG(899, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy845;
	if(yych == 'h')	goto yy845;
	goto yy53;
yy900:
	YYDEBUG(900, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy901;
	if(yych != 'b')	goto yy53;
	goto yy901;
yy901:
	YYDEBUG(901, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			goto yy837;
		}
	} else {
		if(yych <= 'Q'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'R')	goto yy902;
			if(yych != 'r')	goto yy797;
			goto yy902;
		}
	}
yy902:
	YYDEBUG(902, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy903;
	if(yych != 'u')	goto yy53;
	goto yy903;
yy903:
	YYDEBUG(903, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy904;
	if(yych != 'a')	goto yy53;
	goto yy904;
yy904:
	YYDEBUG(904, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy905;
	if(yych != 'r')	goto yy53;
	goto yy905;
yy905:
	YYDEBUG(905, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy845;
	if(yych == 'y')	goto yy845;
	goto yy53;
yy906:
	YYDEBUG(906, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy916;
	goto yy53;
yy907:
	YYDEBUG(907, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy908;
	if(yych <= '6')	goto yy909;
	if(yych <= '9')	goto yy910;
	goto yy53;
yy908:
	YYDEBUG(908, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy818;
	if(yych <= '/')	goto yy812;
	if(yych <= '9')	goto yy915;
	goto yy812;
yy909:
	YYDEBUG(909, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy818;
		goto yy812;
	} else {
		if(yych <= '0')	goto yy915;
		if(yych <= '9')	goto yy911;
		goto yy812;
	}
yy910:
	YYDEBUG(910, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy818;
	if(yych <= '/')	goto yy812;
	if(yych >= ':')	goto yy812;
	goto yy911;
yy911:
	YYDEBUG(911, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '/')	goto yy912;
	if(yych <= '9')	goto yy913;
	goto yy912;
yy912:
	YYDEBUG(912, *YYCURSOR);

{
		DEBUG_OUTPUT("pointed date");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		s->time->m = timelib_get_nr((char **) &ptr, 2);
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		TIMELIB_PROCESS_YEAR(s->time->y);
		TIMELIB_DEINIT;
		return TIMELIB_DATE_FULL_POINTED;
	}
yy913:
	YYDEBUG(913, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy912;
	if(yych >= ':')	goto yy912;
	goto yy914;
yy914:
	YYDEBUG(914, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy912;
yy915:
	YYDEBUG(915, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy822;
			if(yych <= 0x1F)	goto yy812;
			goto yy822;
		} else {
			if(yych == '.')	goto yy818;
			if(yych <= '/')	goto yy812;
			goto yy913;
		}
	} else {
		if(yych <= 'P'){
			if(yych == 'A')	goto yy824;
			if(yych <= 'O')	goto yy812;
			goto yy824;
		} else {
			if(yych <= 'a'){
				if(yych <= '`')	goto yy812;
				goto yy824;
			} else {
				if(yych == 'p')	goto yy824;
				goto yy812;
			}
		}
	}
yy916:
	YYDEBUG(916, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy912;
	if(yych <= '9')	goto yy911;
	goto yy912;
yy917:
	YYDEBUG(917, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ':'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy829;
			if(yych <= 0x1F)	goto yy812;
			goto yy829;
		} else {
			if(yych <= '-'){
				if(yych <= ',')	goto yy812;
				goto yy906;
			} else {
				if(yych <= '.')	goto yy907;
				if(yych <= '9')	goto yy812;
				goto yy814;
			}
		}
	} else {
		if(yych <= 'P'){
			if(yych == 'A')	goto yy831;
			if(yych <= 'O')	goto yy812;
			goto yy831;
		} else {
			if(yych <= 'a'){
				if(yych <= '`')	goto yy812;
				goto yy831;
			} else {
				if(yych == 'p')	goto yy831;
				goto yy812;
			}
		}
	}
yy918:
	YYDEBUG(918, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '.'){
		if(yych <= ',')	goto yy53;
		if(yych <= '-')	goto yy957;
		goto yy906;
	} else {
		if(yych <= '/')	goto yy53;
		if(yych <= '9')	goto yy920;
		goto yy53;
	}
yy919:
	YYDEBUG(919, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '.'){
		if(yych <= ',')	goto yy53;
		if(yych <= '-')	goto yy957;
		goto yy906;
	} else {
		if(yych <= '/')	goto yy53;
		if(yych >= '3')	goto yy53;
		goto yy920;
	}
yy920:
	YYDEBUG(920, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= ',')	goto yy53;
	if(yych <= '-')	goto yy957;
	if(yych <= '.')	goto yy906;
	goto yy53;
yy921:
	YYDEBUG(921, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'A')	goto yy953;
		if(yych <= 'T')	goto yy53;
		goto yy952;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy53;
			goto yy953;
		} else {
			if(yych == 'u')	goto yy952;
			goto yy53;
		}
	}
yy922:
	YYDEBUG(922, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy950;
	if(yych == 'e')	goto yy950;
	goto yy53;
yy923:
	YYDEBUG(923, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy947;
	if(yych == 'a')	goto yy947;
	goto yy53;
yy924:
	YYDEBUG(924, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'P')	goto yy944;
		if(yych <= 'T')	goto yy53;
		goto yy943;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy53;
			goto yy944;
		} else {
			if(yych == 'u')	goto yy943;
			goto yy53;
		}
	}
yy925:
	YYDEBUG(925, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy940;
	if(yych == 'e')	goto yy940;
	goto yy53;
yy926:
	YYDEBUG(926, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy938;
	if(yych == 'c')	goto yy938;
	goto yy53;
yy927:
	YYDEBUG(927, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy936;
	if(yych == 'o')	goto yy936;
	goto yy53;
yy928:
	YYDEBUG(928, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy929;
	if(yych != 'e')	goto yy53;
	goto yy929;
yy929:
	YYDEBUG(929, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy930;
	if(yych != 'c')	goto yy53;
	goto yy930;
yy930:
	YYDEBUG(930, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych >= '.')	goto yy837;
			goto yy931;
		}
	} else {
		if(yych <= 'D'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'E')	goto yy886;
			if(yych == 'e')	goto yy886;
			goto yy797;
		}
	}
yy931:
	YYDEBUG(931, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy838;
	if(yych <= '0')	goto yy932;
	if(yych <= '2')	goto yy933;
	if(yych <= '3')	goto yy934;
	goto yy838;
yy932:
	YYDEBUG(932, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy840;
	if(yych <= '0')	goto yy846;
	if(yych <= '9')	goto yy935;
	goto yy840;
yy933:
	YYDEBUG(933, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy840;
	if(yych <= '9')	goto yy935;
	goto yy840;
yy934:
	YYDEBUG(934, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy840;
	if(yych <= '1')	goto yy935;
	if(yych <= '9')	goto yy846;
	goto yy840;
yy935:
	YYDEBUG(935, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy840;
	if(yych <= '9')	goto yy847;
	goto yy840;
yy936:
	YYDEBUG(936, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy937;
	if(yych != 'v')	goto yy53;
	goto yy937;
yy937:
	YYDEBUG(937, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'D'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'E')	goto yy841;
			if(yych == 'e')	goto yy841;
			goto yy797;
		}
	}
yy938:
	YYDEBUG(938, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy939;
	if(yych != 't')	goto yy53;
	goto yy939;
yy939:
	YYDEBUG(939, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'N'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'O')	goto yy851;
			if(yych == 'o')	goto yy851;
			goto yy797;
		}
	}
yy940:
	YYDEBUG(940, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy941;
	if(yych != 'p')	goto yy53;
	goto yy941;
yy941:
	YYDEBUG(941, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'S'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'T')	goto yy942;
			if(yych != 't')	goto yy797;
			goto yy942;
		}
	}
yy942:
	YYDEBUG(942, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'D'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'E')	goto yy893;
			if(yych == 'e')	goto yy893;
			goto yy797;
		}
	}
yy943:
	YYDEBUG(943, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy946;
	if(yych == 'g')	goto yy946;
	goto yy53;
yy944:
	YYDEBUG(944, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy945;
	if(yych != 'r')	goto yy53;
	goto yy945;
yy945:
	YYDEBUG(945, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'H'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'I')	goto yy857;
			if(yych == 'i')	goto yy857;
			goto yy797;
		}
	}
yy946:
	YYDEBUG(946, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'T'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'U')	goto yy859;
			if(yych == 'u')	goto yy859;
			goto yy797;
		}
	}
yy947:
	YYDEBUG(947, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych == 'R')	goto yy948;
		if(yych <= 'X')	goto yy53;
		goto yy949;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy53;
			goto yy948;
		} else {
			if(yych == 'y')	goto yy949;
			goto yy53;
		}
	}
yy948:
	YYDEBUG(948, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'B'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'C')	goto yy899;
			if(yych == 'c')	goto yy899;
			goto yy797;
		}
	}
yy949:
	YYDEBUG(949, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ','){
		if(yych <= 0x09){
			if(yych <= 0x08)	goto yy797;
			goto yy837;
		} else {
			if(yych == ' ')	goto yy837;
			goto yy797;
		}
	} else {
		if(yych <= '.'){
			if(yych <= '-')	goto yy931;
			goto yy837;
		} else {
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		}
	}
yy950:
	YYDEBUG(950, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy951;
	if(yych != 'b')	goto yy53;
	goto yy951;
yy951:
	YYDEBUG(951, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'Q'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'R')	goto yy902;
			if(yych == 'r')	goto yy902;
			goto yy797;
		}
	}
yy952:
	YYDEBUG(952, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'L')	goto yy956;
		if(yych <= 'M')	goto yy53;
		goto yy955;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy53;
			goto yy956;
		} else {
			if(yych == 'n')	goto yy955;
			goto yy53;
		}
	}
yy953:
	YYDEBUG(953, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy954;
	if(yych != 'n')	goto yy53;
	goto yy954;
yy954:
	YYDEBUG(954, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'T'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'U')	goto yy864;
			if(yych == 'u')	goto yy864;
			goto yy797;
		}
	}
yy955:
	YYDEBUG(955, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'D'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'E')	goto yy845;
			if(yych == 'e')	goto yy845;
			goto yy797;
		}
	}
yy956:
	YYDEBUG(956, *YYCURSOR);
	yyaccept = 11;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= 0x1F){
			if(yych == 0x09)	goto yy837;
			goto yy797;
		} else {
			if(yych <= ' ')	goto yy837;
			if(yych <= ',')	goto yy797;
			if(yych <= '-')	goto yy931;
			goto yy837;
		}
	} else {
		if(yych <= 'X'){
			if(yych <= '/')	goto yy797;
			if(yych <= '9')	goto yy839;
			goto yy797;
		} else {
			if(yych <= 'Y')	goto yy845;
			if(yych == 'y')	goto yy845;
			goto yy797;
		}
	}
yy957:
	YYDEBUG(957, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '2')	goto yy958;
	if(yych <= '3')	goto yy960;
	if(yych <= '9')	goto yy961;
	goto yy53;
yy958:
	YYDEBUG(958, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/')	goto yy959;
		if(yych <= '9')	goto yy967;
		if(yych >= 'n')	goto yy963;
		goto yy959;
	} else {
		if(yych <= 'r'){
			if(yych >= 'r')	goto yy964;
			goto yy959;
		} else {
			if(yych <= 's')	goto yy962;
			if(yych <= 't')	goto yy965;
			goto yy959;
		}
	}
yy959:
	YYDEBUG(959, *YYCURSOR);

{
		DEBUG_OUTPUT("gnudateshort");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		s->time->m = timelib_get_nr((char **) &ptr, 2);
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		TIMELIB_PROCESS_YEAR(s->time->y);
		TIMELIB_DEINIT;
		return TIMELIB_ISO_DATE;
	}
yy960:
	YYDEBUG(960, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '1'){
			if(yych <= '/')	goto yy959;
			goto yy967;
		} else {
			if(yych <= '9')	goto yy911;
			if(yych <= 'm')	goto yy959;
			goto yy963;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy959;
			goto yy964;
		} else {
			if(yych <= 's')	goto yy962;
			if(yych <= 't')	goto yy965;
			goto yy959;
		}
	}
yy961:
	YYDEBUG(961, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/')	goto yy959;
		if(yych <= '9')	goto yy911;
		if(yych <= 'm')	goto yy959;
		goto yy963;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy959;
			goto yy964;
		} else {
			if(yych <= 's')	goto yy962;
			if(yych <= 't')	goto yy965;
			goto yy959;
		}
	}
yy962:
	YYDEBUG(962, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 't')	goto yy966;
	goto yy53;
yy963:
	YYDEBUG(963, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'd')	goto yy966;
	goto yy53;
yy964:
	YYDEBUG(964, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'd')	goto yy966;
	goto yy53;
yy965:
	YYDEBUG(965, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != 'h')	goto yy53;
	goto yy966;
yy966:
	YYDEBUG(966, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy959;
yy967:
	YYDEBUG(967, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/')	goto yy959;
		if(yych <= '9')	goto yy913;
		if(yych <= 'm')	goto yy959;
		goto yy963;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy959;
			goto yy964;
		} else {
			if(yych <= 's')	goto yy962;
			if(yych <= 't')	goto yy965;
			goto yy959;
		}
	}
yy968:
	YYDEBUG(968, *YYCURSOR);
	yyaccept = 14;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/'){
			if(yych >= '/')	goto yy1022;
			goto yy969;
		} else {
			if(yych <= '9')	goto yy971;
			if(yych >= 'n')	goto yy1019;
			goto yy969;
		}
	} else {
		if(yych <= 'r'){
			if(yych >= 'r')	goto yy1020;
			goto yy969;
		} else {
			if(yych <= 's')	goto yy1018;
			if(yych <= 't')	goto yy1021;
			goto yy969;
		}
	}
yy969:
	YYDEBUG(969, *YYCURSOR);

{
		DEBUG_OUTPUT("americanshort | american");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->m = timelib_get_nr((char **) &ptr, 2);
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		if (*ptr == '/') {
			s->time->y = timelib_get_nr((char **) &ptr, 4);
			TIMELIB_PROCESS_YEAR(s->time->y);
		}
		TIMELIB_DEINIT;
		return TIMELIB_AMERICAN;
	}
yy970:
	YYDEBUG(970, *YYCURSOR);
	yyaccept = 14;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/'){
			if(yych <= '.')	goto yy969;
			goto yy1022;
		} else {
			if(yych <= '1')	goto yy971;
			if(yych <= 'm')	goto yy969;
			goto yy1019;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy969;
			goto yy1020;
		} else {
			if(yych <= 's')	goto yy1018;
			if(yych <= 't')	goto yy1021;
			goto yy969;
		}
	}
yy971:
	YYDEBUG(971, *YYCURSOR);
	yyaccept = 14;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych == '/')	goto yy1022;
		if(yych <= 'm')	goto yy969;
		goto yy1019;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy969;
			goto yy1020;
		} else {
			if(yych <= 's')	goto yy1018;
			if(yych <= 't')	goto yy1021;
			goto yy969;
		}
	}
yy972:
	YYDEBUG(972, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'A')	goto yy1017;
		if(yych <= 'T')	goto yy53;
		goto yy1016;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy53;
			goto yy1017;
		} else {
			if(yych == 'u')	goto yy1016;
			goto yy53;
		}
	}
yy973:
	YYDEBUG(973, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1015;
	if(yych == 'e')	goto yy1015;
	goto yy53;
yy974:
	YYDEBUG(974, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1014;
	if(yych == 'a')	goto yy1014;
	goto yy53;
yy975:
	YYDEBUG(975, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'P')	goto yy1013;
		if(yych <= 'T')	goto yy53;
		goto yy1012;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy53;
			goto yy1013;
		} else {
			if(yych == 'u')	goto yy1012;
			goto yy53;
		}
	}
yy976:
	YYDEBUG(976, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1010;
	if(yych == 'e')	goto yy1010;
	goto yy53;
yy977:
	YYDEBUG(977, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1009;
	if(yych == 'c')	goto yy1009;
	goto yy53;
yy978:
	YYDEBUG(978, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1008;
	if(yych == 'o')	goto yy1008;
	goto yy53;
yy979:
	YYDEBUG(979, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy980;
	if(yych != 'e')	goto yy53;
	goto yy980;
yy980:
	YYDEBUG(980, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy981;
	if(yych != 'c')	goto yy53;
	goto yy981;
yy981:
	YYDEBUG(981, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '/')	goto yy53;
	goto yy982;
yy982:
	YYDEBUG(982, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy983;
yy983:
	YYDEBUG(983, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy984;
yy984:
	YYDEBUG(984, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy985;
yy985:
	YYDEBUG(985, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy986;
yy986:
	YYDEBUG(986, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy987;
yy987:
	YYDEBUG(987, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '1')	goto yy988;
	if(yych <= '2')	goto yy989;
	goto yy53;
yy988:
	YYDEBUG(988, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy990;
	goto yy53;
yy989:
	YYDEBUG(989, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '4')	goto yy53;
	goto yy990;
yy990:
	YYDEBUG(990, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy991;
yy991:
	YYDEBUG(991, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '6')	goto yy53;
	goto yy992;
yy992:
	YYDEBUG(992, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy993;
yy993:
	YYDEBUG(993, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy994;
yy994:
	YYDEBUG(994, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy995;
	if(yych <= '6')	goto yy996;
	goto yy53;
yy995:
	YYDEBUG(995, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy997;
	goto yy53;
yy996:
	YYDEBUG(996, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '0')	goto yy53;
	goto yy997;
yy997:
	YYDEBUG(997, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 0x09)	goto yy998;
	if(yych != ' ')	goto yy53;
	goto yy998;
yy998:
	YYDEBUG(998, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 6) YYFILL(6);
	yych = *YYCURSOR;
	goto yy999;
yy999:
	YYDEBUG(999, *YYCURSOR);
	if(yych <= ' '){
		if(yych == 0x09)	goto yy998;
		if(yych <= 0x1F)	goto yy53;
		goto yy998;
	} else {
		if(yych <= '+'){
			if(yych <= '*')	goto yy53;
			goto yy1000;
		} else {
			if(yych != '-')	goto yy53;
			goto yy1000;
		}
	}
yy1000:
	YYDEBUG(1000, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '1')	goto yy1001;
	if(yych <= '2')	goto yy1003;
	if(yych <= '9')	goto yy1004;
	goto yy53;
yy1001:
	YYDEBUG(1001, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '/')	goto yy1002;
	if(yych <= '9')	goto yy1004;
	if(yych <= ':')	goto yy1005;
	goto yy1002;
yy1002:
	YYDEBUG(1002, *YYCURSOR);

{
		int tz_not_found;
		DEBUG_OUTPUT("clf");
		TIMELIB_INIT;
		TIMELIB_HAVE_TIME();
		TIMELIB_HAVE_DATE();
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		s->time->m = timelib_get_month((char **) &ptr);
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		s->time->h = timelib_get_nr((char **) &ptr, 2);
		s->time->i = timelib_get_nr((char **) &ptr, 2);
		s->time->s = timelib_get_nr((char **) &ptr, 2);
		s->time->z = timelib_get_zone((char **) &ptr, &s->time->dst, s->time, &tz_not_found, s->tzdb);
		if (tz_not_found) {
			add_error(s, "The timezone could not be found in the database");
		}
		TIMELIB_DEINIT;
		return TIMELIB_CLF;
	}
yy1003:
	YYDEBUG(1003, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '5'){
		if(yych <= '/')	goto yy1002;
		if(yych >= '4')	goto yy1006;
		goto yy1004;
	} else {
		if(yych <= '9')	goto yy1007;
		if(yych <= ':')	goto yy1005;
		goto yy1002;
	}
yy1004:
	YYDEBUG(1004, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1002;
	if(yych <= '5')	goto yy1006;
	if(yych <= '9')	goto yy1007;
	if(yych >= ';')	goto yy1002;
	goto yy1005;
yy1005:
	YYDEBUG(1005, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1002;
	if(yych <= '5')	goto yy1006;
	if(yych <= '9')	goto yy1007;
	goto yy1002;
yy1006:
	YYDEBUG(1006, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1002;
	if(yych >= ':')	goto yy1002;
	goto yy1007;
yy1007:
	YYDEBUG(1007, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy1002;
yy1008:
	YYDEBUG(1008, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy981;
	if(yych == 'v')	goto yy981;
	goto yy53;
yy1009:
	YYDEBUG(1009, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy981;
	if(yych == 't')	goto yy981;
	goto yy53;
yy1010:
	YYDEBUG(1010, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1011;
	if(yych != 'p')	goto yy53;
	goto yy1011;
yy1011:
	YYDEBUG(1011, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == '/')	goto yy982;
		goto yy53;
	} else {
		if(yych <= 'T')	goto yy981;
		if(yych == 't')	goto yy981;
		goto yy53;
	}
yy1012:
	YYDEBUG(1012, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy981;
	if(yych == 'g')	goto yy981;
	goto yy53;
yy1013:
	YYDEBUG(1013, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy981;
	if(yych == 'r')	goto yy981;
	goto yy53;
yy1014:
	YYDEBUG(1014, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych == 'R')	goto yy981;
		if(yych <= 'X')	goto yy53;
		goto yy981;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy53;
			goto yy981;
		} else {
			if(yych == 'y')	goto yy981;
			goto yy53;
		}
	}
yy1015:
	YYDEBUG(1015, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy981;
	if(yych == 'b')	goto yy981;
	goto yy53;
yy1016:
	YYDEBUG(1016, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'L')	goto yy981;
		if(yych <= 'M')	goto yy53;
		goto yy981;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy53;
			goto yy981;
		} else {
			if(yych == 'n')	goto yy981;
			goto yy53;
		}
	}
yy1017:
	YYDEBUG(1017, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy981;
	if(yych == 'n')	goto yy981;
	goto yy53;
yy1018:
	YYDEBUG(1018, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 't')	goto yy1027;
	goto yy53;
yy1019:
	YYDEBUG(1019, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'd')	goto yy1027;
	goto yy53;
yy1020:
	YYDEBUG(1020, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'd')	goto yy1027;
	goto yy53;
yy1021:
	YYDEBUG(1021, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'h')	goto yy1027;
	goto yy53;
yy1022:
	YYDEBUG(1022, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy1023;
yy1023:
	YYDEBUG(1023, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy969;
	if(yych >= ':')	goto yy969;
	goto yy1024;
yy1024:
	YYDEBUG(1024, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy969;
	if(yych >= ':')	goto yy969;
	goto yy1025;
yy1025:
	YYDEBUG(1025, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy969;
	if(yych >= ':')	goto yy969;
	goto yy1026;
yy1026:
	YYDEBUG(1026, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy969;
yy1027:
	YYDEBUG(1027, *YYCURSOR);
	yyaccept = 14;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '/')	goto yy1022;
	goto yy969;
yy1028:
	YYDEBUG(1028, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= ','){
		if(yych == 0x09)	goto yy1030;
		goto yy883;
	} else {
		if(yych <= '.')	goto yy1030;
		if(yych >= '0')	goto yy883;
		goto yy1029;
	}
yy1029:
	YYDEBUG(1029, *YYCURSOR);
	yych = *++YYCURSOR;
	YYDEBUG(-1, yych);
	switch(yych){
	case 'A':	case 'a':	goto yy975;
	case 'D':	case 'd':	goto yy979;
	case 'F':	case 'f':	goto yy973;
	case 'J':	case 'j':	goto yy972;
	case 'M':	case 'm':	goto yy974;
	case 'N':	case 'n':	goto yy978;
	case 'O':	case 'o':	goto yy977;
	case 'S':	case 's':	goto yy976;
	default:	goto yy53;
	}
yy1030:
	YYDEBUG(1030, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy883;
	if(yych <= '0')	goto yy1031;
	if(yych <= '1')	goto yy1032;
	if(yych <= '9')	goto yy1033;
	goto yy883;
yy1031:
	YYDEBUG(1031, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= ',')	goto yy53;
	if(yych <= '.')	goto yy906;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1033;
	goto yy53;
yy1032:
	YYDEBUG(1032, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= ',')	goto yy53;
	if(yych <= '.')	goto yy906;
	if(yych <= '/')	goto yy53;
	if(yych >= '3')	goto yy53;
	goto yy1033;
yy1033:
	YYDEBUG(1033, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= ',')	goto yy53;
	if(yych <= '.')	goto yy906;
	goto yy53;
yy1034:
	YYDEBUG(1034, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '-')	goto yy1035;
	if(yych <= '/')	goto yy57;
	if(yych <= '9')	goto yy1069;
	goto yy57;
yy1035:
	YYDEBUG(1035, *YYCURSOR);
	yych = *++YYCURSOR;
	YYDEBUG(-1, yych);
	switch(yych){
	case '0':	goto yy1044;
	case '1':	goto yy1045;
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1046;
	case 'A':	case 'a':	goto yy1039;
	case 'D':	case 'd':	goto yy1043;
	case 'F':	case 'f':	goto yy1037;
	case 'J':	case 'j':	goto yy1036;
	case 'M':	case 'm':	goto yy1038;
	case 'N':	case 'n':	goto yy1042;
	case 'O':	case 'o':	goto yy1041;
	case 'S':	case 's':	goto yy1040;
	default:	goto yy53;
	}
yy1036:
	YYDEBUG(1036, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'A')	goto yy1068;
		if(yych <= 'T')	goto yy53;
		goto yy1067;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy53;
			goto yy1068;
		} else {
			if(yych == 'u')	goto yy1067;
			goto yy53;
		}
	}
yy1037:
	YYDEBUG(1037, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1066;
	if(yych == 'e')	goto yy1066;
	goto yy53;
yy1038:
	YYDEBUG(1038, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1065;
	if(yych == 'a')	goto yy1065;
	goto yy53;
yy1039:
	YYDEBUG(1039, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'P')	goto yy1064;
		if(yych <= 'T')	goto yy53;
		goto yy1063;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy53;
			goto yy1064;
		} else {
			if(yych == 'u')	goto yy1063;
			goto yy53;
		}
	}
yy1040:
	YYDEBUG(1040, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1061;
	if(yych == 'e')	goto yy1061;
	goto yy53;
yy1041:
	YYDEBUG(1041, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1060;
	if(yych == 'c')	goto yy1060;
	goto yy53;
yy1042:
	YYDEBUG(1042, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1059;
	if(yych == 'o')	goto yy1059;
	goto yy53;
yy1043:
	YYDEBUG(1043, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1051;
	if(yych == 'e')	goto yy1051;
	goto yy53;
yy1044:
	YYDEBUG(1044, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '-')	goto yy1047;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1046;
	goto yy53;
yy1045:
	YYDEBUG(1045, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '-')	goto yy1047;
	if(yych <= '/')	goto yy53;
	if(yych >= '3')	goto yy53;
	goto yy1046;
yy1046:
	YYDEBUG(1046, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '-')	goto yy53;
	goto yy1047;
yy1047:
	YYDEBUG(1047, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '2')	goto yy1048;
	if(yych <= '3')	goto yy1049;
	if(yych <= '9')	goto yy1050;
	goto yy53;
yy1048:
	YYDEBUG(1048, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/')	goto yy959;
		if(yych <= '9')	goto yy1050;
		if(yych <= 'm')	goto yy959;
		goto yy963;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy959;
			goto yy964;
		} else {
			if(yych <= 's')	goto yy962;
			if(yych <= 't')	goto yy965;
			goto yy959;
		}
	}
yy1049:
	YYDEBUG(1049, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/')	goto yy959;
		if(yych <= '1')	goto yy1050;
		if(yych <= 'm')	goto yy959;
		goto yy963;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy959;
			goto yy964;
		} else {
			if(yych <= 's')	goto yy962;
			if(yych <= 't')	goto yy965;
			goto yy959;
		}
	}
yy1050:
	YYDEBUG(1050, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'q'){
		if(yych == 'n')	goto yy963;
		goto yy959;
	} else {
		if(yych <= 'r')	goto yy964;
		if(yych <= 's')	goto yy962;
		if(yych <= 't')	goto yy965;
		goto yy959;
	}
yy1051:
	YYDEBUG(1051, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1052;
	if(yych != 'c')	goto yy53;
	goto yy1052;
yy1052:
	YYDEBUG(1052, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '-')	goto yy53;
	goto yy1053;
yy1053:
	YYDEBUG(1053, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '0')	goto yy1054;
	if(yych <= '2')	goto yy1055;
	if(yych <= '3')	goto yy1056;
	goto yy53;
yy1054:
	YYDEBUG(1054, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '0')	goto yy53;
	if(yych <= '9')	goto yy1057;
	goto yy53;
yy1055:
	YYDEBUG(1055, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1057;
	goto yy53;
yy1056:
	YYDEBUG(1056, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '2')	goto yy53;
	goto yy1057;
yy1057:
	YYDEBUG(1057, *YYCURSOR);
	++YYCURSOR;
	goto yy1058;
yy1058:
	YYDEBUG(1058, *YYCURSOR);

{
		DEBUG_OUTPUT("pgtextreverse");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		s->time->m = timelib_get_month((char **) &ptr);
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		TIMELIB_PROCESS_YEAR(s->time->y);
		TIMELIB_DEINIT;
		return TIMELIB_PG_TEXT;
	}
yy1059:
	YYDEBUG(1059, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1052;
	if(yych == 'v')	goto yy1052;
	goto yy53;
yy1060:
	YYDEBUG(1060, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1052;
	if(yych == 't')	goto yy1052;
	goto yy53;
yy1061:
	YYDEBUG(1061, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1062;
	if(yych != 'p')	goto yy53;
	goto yy1062;
yy1062:
	YYDEBUG(1062, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych == '-')	goto yy1053;
		goto yy53;
	} else {
		if(yych <= 'T')	goto yy1052;
		if(yych == 't')	goto yy1052;
		goto yy53;
	}
yy1063:
	YYDEBUG(1063, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy1052;
	if(yych == 'g')	goto yy1052;
	goto yy53;
yy1064:
	YYDEBUG(1064, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1052;
	if(yych == 'r')	goto yy1052;
	goto yy53;
yy1065:
	YYDEBUG(1065, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych == 'R')	goto yy1052;
		if(yych <= 'X')	goto yy53;
		goto yy1052;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy53;
			goto yy1052;
		} else {
			if(yych == 'y')	goto yy1052;
			goto yy53;
		}
	}
yy1066:
	YYDEBUG(1066, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy1052;
	if(yych == 'b')	goto yy1052;
	goto yy53;
yy1067:
	YYDEBUG(1067, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'L')	goto yy1052;
		if(yych <= 'M')	goto yy53;
		goto yy1052;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy53;
			goto yy1052;
		} else {
			if(yych == 'n')	goto yy1052;
			goto yy53;
		}
	}
yy1068:
	YYDEBUG(1068, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1052;
	if(yych == 'n')	goto yy1052;
	goto yy53;
yy1069:
	YYDEBUG(1069, *YYCURSOR);
	yyaccept = 15;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	case 'A':	case 'D':	case 'F':	case 'H':
	case 'I':
	case 'J':	case 'M':
	case 'N':
	case 'O':	case 'S':
	case 'T':	case 'V':	case 'X':
	case 'Y':	case 'a':	case 'd':	case 'f':	case 'h':	case 'j':	case 'm':
	case 'n':
	case 'o':	case 's':
	case 't':	case 'w':	case 'y':	goto yy1074;
	case '-':	goto yy1071;
	case '.':	goto yy1075;
	case '/':	goto yy1072;
	case '0':	goto yy1088;
	case '1':	goto yy1089;
	case '2':	goto yy1091;
	case '3':	goto yy1092;
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy51;
	case ':':	goto yy1090;
	case 'W':	goto yy1093;
	default:	goto yy1070;
	}
yy1070:
	YYDEBUG(1070, *YYCURSOR);

{
		DEBUG_OUTPUT("year4");
		TIMELIB_INIT;
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		TIMELIB_DEINIT;
		return TIMELIB_CLF;
	}
yy1071:
	YYDEBUG(1071, *YYCURSOR);
	yych = *++YYCURSOR;
	YYDEBUG(-1, yych);
	switch(yych){
	case '0':	goto yy1255;
	case '1':	goto yy1256;
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy1257;
	case 'A':	case 'a':	goto yy1250;
	case 'D':	case 'd':	goto yy1254;
	case 'F':	case 'f':	goto yy1248;
	case 'J':	case 'j':	goto yy1247;
	case 'M':	case 'm':	goto yy1249;
	case 'N':	case 'n':	goto yy1253;
	case 'O':	case 'o':	goto yy1252;
	case 'S':	case 's':	goto yy1251;
	default:	goto yy1220;
	}
yy1072:
	YYDEBUG(1072, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '0')	goto yy1228;
	if(yych <= '1')	goto yy1229;
	if(yych <= '9')	goto yy1230;
	goto yy53;
yy1073:
	YYDEBUG(1073, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 11) YYFILL(11);
	yych = *YYCURSOR;
	goto yy1074;
yy1074:
	YYDEBUG(1074, *YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	goto yy1073;
	case '-':
	case '.':	goto yy1219;
	case 'A':	case 'a':	goto yy1083;
	case 'D':	case 'd':	goto yy1087;
	case 'F':	case 'f':	goto yy1081;
	case 'H':	case 'h':	goto yy60;
	case 'I':	goto yy1076;
	case 'J':	case 'j':	goto yy1080;
	case 'M':	case 'm':	goto yy1082;
	case 'N':	case 'n':	goto yy1086;
	case 'O':	case 'o':	goto yy1085;
	case 'S':	case 's':	goto yy1084;
	case 'T':	case 't':	goto yy65;
	case 'V':	goto yy1078;
	case 'W':	case 'w':	goto yy62;
	case 'X':	goto yy1079;
	case 'Y':	case 'y':	goto yy64;
	default:	goto yy53;
	}
yy1075:
	YYDEBUG(1075, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1220;
	if(yych <= '0')	goto yy1212;
	if(yych <= '2')	goto yy1213;
	if(yych <= '3')	goto yy1214;
	goto yy1220;
yy1076:
	YYDEBUG(1076, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= 'U'){
		if(yych == 'I')	goto yy1211;
		goto yy1077;
	} else {
		if(yych == 'W')	goto yy1077;
		if(yych <= 'X')	goto yy1165;
		goto yy1077;
	}
yy1077:
	YYDEBUG(1077, *YYCURSOR);

{
		DEBUG_OUTPUT("datenodayrev");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		s->time->m = timelib_get_month((char **) &ptr);
		s->time->d = 1;
		TIMELIB_PROCESS_YEAR(s->time->y);
		TIMELIB_DEINIT;
		return TIMELIB_DATE_NO_DAY;
	}
yy1078:
	YYDEBUG(1078, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1209;
	goto yy1077;
yy1079:
	YYDEBUG(1079, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1208;
	goto yy1077;
yy1080:
	YYDEBUG(1080, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'A')	goto yy1201;
		if(yych <= 'T')	goto yy53;
		goto yy1200;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy53;
			goto yy1201;
		} else {
			if(yych == 'u')	goto yy1200;
			goto yy53;
		}
	}
yy1081:
	YYDEBUG(1081, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= 'N'){
			if(yych == 'E')	goto yy1194;
			goto yy53;
		} else {
			if(yych <= 'O')	goto yy83;
			if(yych <= 'Q')	goto yy53;
			goto yy82;
		}
	} else {
		if(yych <= 'n'){
			if(yych == 'e')	goto yy1194;
			goto yy53;
		} else {
			if(yych <= 'o')	goto yy83;
			if(yych == 'r')	goto yy82;
			goto yy53;
		}
	}
yy1082:
	YYDEBUG(1082, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= 'H'){
			if(yych == 'A')	goto yy1191;
			goto yy53;
		} else {
			if(yych <= 'I')	goto yy114;
			if(yych <= 'N')	goto yy53;
			goto yy113;
		}
	} else {
		if(yych <= 'h'){
			if(yych == 'a')	goto yy1191;
			goto yy53;
		} else {
			if(yych <= 'i')	goto yy114;
			if(yych == 'o')	goto yy113;
			goto yy53;
		}
	}
yy1083:
	YYDEBUG(1083, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'P')	goto yy1185;
		if(yych <= 'T')	goto yy53;
		goto yy1184;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy53;
			goto yy1185;
		} else {
			if(yych == 'u')	goto yy1184;
			goto yy53;
		}
	}
yy1084:
	YYDEBUG(1084, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= 'D'){
			if(yych == 'A')	goto yy123;
			goto yy53;
		} else {
			if(yych <= 'E')	goto yy1177;
			if(yych <= 'T')	goto yy53;
			goto yy122;
		}
	} else {
		if(yych <= 'd'){
			if(yych == 'a')	goto yy123;
			goto yy53;
		} else {
			if(yych <= 'e')	goto yy1177;
			if(yych == 'u')	goto yy122;
			goto yy53;
		}
	}
yy1085:
	YYDEBUG(1085, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1172;
	if(yych == 'c')	goto yy1172;
	goto yy53;
yy1086:
	YYDEBUG(1086, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1166;
	if(yych == 'o')	goto yy1166;
	goto yy53;
yy1087:
	YYDEBUG(1087, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych == 'A')	goto yy110;
		if(yych <= 'D')	goto yy53;
		goto yy1159;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy53;
			goto yy110;
		} else {
			if(yych == 'e')	goto yy1159;
			goto yy53;
		}
	}
yy1088:
	YYDEBUG(1088, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '0')	goto yy1157;
	if(yych <= '9')	goto yy1158;
	goto yy57;
yy1089:
	YYDEBUG(1089, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '2')	goto yy1126;
	if(yych <= '9')	goto yy1105;
	goto yy57;
yy1090:
	YYDEBUG(1090, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '0')	goto yy1106;
	if(yych <= '1')	goto yy1107;
	goto yy53;
yy1091:
	YYDEBUG(1091, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '9')	goto yy1105;
	goto yy57;
yy1092:
	YYDEBUG(1092, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '5')	goto yy1101;
	if(yych <= '6')	goto yy1102;
	if(yych <= '9')	goto yy51;
	goto yy57;
yy1093:
	YYDEBUG(1093, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '5'){
		if(yych <= '/')	goto yy53;
		if(yych <= '0')	goto yy1094;
		if(yych <= '4')	goto yy1095;
		goto yy1096;
	} else {
		if(yych <= 'E'){
			if(yych <= 'D')	goto yy53;
			goto yy98;
		} else {
			if(yych == 'e')	goto yy98;
			goto yy53;
		}
	}
yy1094:
	YYDEBUG(1094, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '0')	goto yy53;
	if(yych <= '9')	goto yy1097;
	goto yy53;
yy1095:
	YYDEBUG(1095, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1097;
	goto yy53;
yy1096:
	YYDEBUG(1096, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '4')	goto yy53;
	goto yy1097;
yy1097:
	YYDEBUG(1097, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '/')	goto yy1098;
	if(yych <= '7')	goto yy1099;
	goto yy1098;
yy1098:
	YYDEBUG(1098, *YYCURSOR);

{
		timelib_sll w, d;
		DEBUG_OUTPUT("isoweek");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		TIMELIB_HAVE_RELATIVE();
		
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		w = timelib_get_nr((char **) &ptr, 2);
		d = 1;
		s->time->m = 1;
		s->time->d = 1;
		s->time->relative.d = timelib_daynr_from_weeknr(s->time->y, w, d);

		TIMELIB_DEINIT;
		return TIMELIB_ISO_WEEK;
	}
yy1099:
	YYDEBUG(1099, *YYCURSOR);
	++YYCURSOR;
	goto yy1100;
yy1100:
	YYDEBUG(1100, *YYCURSOR);

{
		timelib_sll w, d;
		DEBUG_OUTPUT("isoweekday");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		TIMELIB_HAVE_RELATIVE();
		
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		w = timelib_get_nr((char **) &ptr, 2);
		d = timelib_get_nr((char **) &ptr, 1);
		s->time->m = 1;
		s->time->d = 1;
		s->time->relative.d = timelib_daynr_from_weeknr(s->time->y, w, d);

		TIMELIB_DEINIT;
		return TIMELIB_ISO_WEEK;
	}
yy1101:
	YYDEBUG(1101, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '9')	goto yy1103;
	goto yy57;
yy1102:
	YYDEBUG(1102, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '6')	goto yy1103;
	if(yych <= '9')	goto yy51;
	goto yy57;
yy1103:
	YYDEBUG(1103, *YYCURSOR);
	yyaccept = 16;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 8) {
		goto yy51;
	}
	if(yych <= 'W'){
		if(yych <= 'F'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych >= ' ')	goto yy57;
				goto yy1104;
			} else {
				if(yych == 'D')	goto yy57;
				if(yych >= 'F')	goto yy57;
				goto yy1104;
			}
		} else {
			if(yych <= 'M'){
				if(yych == 'H')	goto yy57;
				if(yych >= 'M')	goto yy57;
				goto yy1104;
			} else {
				if(yych <= 'R')	goto yy1104;
				if(yych <= 'T')	goto yy57;
				if(yych >= 'W')	goto yy57;
				goto yy1104;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'd'){
				if(yych == 'Y')	goto yy57;
				if(yych >= 'd')	goto yy57;
				goto yy1104;
			} else {
				if(yych == 'f')	goto yy57;
				if(yych >= 'h')	goto yy57;
				goto yy1104;
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych >= 's')	goto yy57;
				goto yy1104;
			} else {
				if(yych <= 'w'){
					if(yych >= 'w')	goto yy57;
					goto yy1104;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1104;
				}
			}
		}
	}
yy1104:
	YYDEBUG(1104, *YYCURSOR);

{
		DEBUG_OUTPUT("pgydotd");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		s->time->d = timelib_get_nr((char **) &ptr, 3);
		s->time->m = 1;
		TIMELIB_PROCESS_YEAR(s->time->y);
		TIMELIB_DEINIT;
		return TIMELIB_PG_YEARDAY;
	}
yy1105:
	YYDEBUG(1105, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '9')	goto yy1103;
	goto yy57;
yy1106:
	YYDEBUG(1106, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '0')	goto yy53;
	if(yych <= '9')	goto yy1108;
	goto yy53;
yy1107:
	YYDEBUG(1107, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '3')	goto yy53;
	goto yy1108;
yy1108:
	YYDEBUG(1108, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy1109;
yy1109:
	YYDEBUG(1109, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '0')	goto yy1110;
	if(yych <= '2')	goto yy1111;
	if(yych <= '3')	goto yy1112;
	goto yy53;
yy1110:
	YYDEBUG(1110, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '0')	goto yy53;
	if(yych <= '9')	goto yy1113;
	goto yy53;
yy1111:
	YYDEBUG(1111, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1113;
	goto yy53;
yy1112:
	YYDEBUG(1112, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '2')	goto yy53;
	goto yy1113;
yy1113:
	YYDEBUG(1113, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ' ')	goto yy53;
	goto yy1114;
yy1114:
	YYDEBUG(1114, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '1')	goto yy1115;
	if(yych <= '2')	goto yy1116;
	goto yy53;
yy1115:
	YYDEBUG(1115, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1117;
	goto yy53;
yy1116:
	YYDEBUG(1116, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '4')	goto yy53;
	goto yy1117;
yy1117:
	YYDEBUG(1117, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy1118;
yy1118:
	YYDEBUG(1118, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '6')	goto yy53;
	goto yy1119;
yy1119:
	YYDEBUG(1119, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy1120;
yy1120:
	YYDEBUG(1120, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy1121;
yy1121:
	YYDEBUG(1121, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1122;
	if(yych <= '6')	goto yy1123;
	goto yy53;
yy1122:
	YYDEBUG(1122, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1124;
	goto yy53;
yy1123:
	YYDEBUG(1123, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '0')	goto yy53;
	goto yy1124;
yy1124:
	YYDEBUG(1124, *YYCURSOR);
	++YYCURSOR;
	goto yy1125;
yy1125:
	YYDEBUG(1125, *YYCURSOR);

{
		int tz_not_found;
		DEBUG_OUTPUT("xmlrpc | xmlrpcnocolon | soap | wddx | exif");
		TIMELIB_INIT;
		TIMELIB_HAVE_TIME();
		TIMELIB_HAVE_DATE();
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		s->time->m = timelib_get_nr((char **) &ptr, 2);
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		s->time->h = timelib_get_nr((char **) &ptr, 2);
		s->time->i = timelib_get_nr((char **) &ptr, 2);
		s->time->s = timelib_get_nr((char **) &ptr, 2);
		if (*ptr == '.') {
			s->time->f = timelib_get_frac_nr((char **) &ptr, 9);
			if (*ptr) { /* timezone is optional */
				s->time->z = timelib_get_zone((char **) &ptr, &s->time->dst, s->time, &tz_not_found, s->tzdb);
				if (tz_not_found) {
					add_error(s, "The timezone could not be found in the database");
				}
			}
		}
		TIMELIB_DEINIT;
		return TIMELIB_XMLRPC_SOAP;
	}
yy1126:
	YYDEBUG(1126, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '2'){
		if(yych <= '/')	goto yy57;
		if(yych >= '1')	goto yy1128;
		goto yy1127;
	} else {
		if(yych <= '3')	goto yy1129;
		if(yych <= '9')	goto yy1103;
		goto yy57;
	}
yy1127:
	YYDEBUG(1127, *YYCURSOR);
	yyaccept = 16;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy1104;
				goto yy57;
			} else {
				if(yych <= '0'){
					if(yych <= '/')	goto yy1104;
					goto yy51;
				} else {
					if(yych <= '9')	goto yy1130;
					if(yych <= 'C')	goto yy1104;
					goto yy57;
				}
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy57;
				if(yych <= 'G')	goto yy1104;
				goto yy57;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy1104;
					goto yy57;
				} else {
					if(yych <= 'R')	goto yy1104;
					if(yych <= 'T')	goto yy57;
					goto yy1104;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy1104;
				if(yych <= 'Y')	goto yy57;
				goto yy1104;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy57;
					goto yy1104;
				} else {
					if(yych == 'g')	goto yy1104;
					goto yy57;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy1104;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy1104;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1104;
				}
			}
		}
	}
yy1128:
	YYDEBUG(1128, *YYCURSOR);
	yyaccept = 16;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy1104;
				goto yy57;
			} else {
				if(yych <= '/')	goto yy1104;
				if(yych <= '9')	goto yy1130;
				if(yych <= 'C')	goto yy1104;
				goto yy57;
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy57;
				if(yych <= 'G')	goto yy1104;
				goto yy57;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy1104;
					goto yy57;
				} else {
					if(yych <= 'R')	goto yy1104;
					if(yych <= 'T')	goto yy57;
					goto yy1104;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy1104;
				if(yych <= 'Y')	goto yy57;
				goto yy1104;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy57;
					goto yy1104;
				} else {
					if(yych == 'g')	goto yy1104;
					goto yy57;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy1104;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy1104;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1104;
				}
			}
		}
	}
yy1129:
	YYDEBUG(1129, *YYCURSOR);
	yyaccept = 16;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy1104;
				goto yy57;
			} else {
				if(yych <= '1'){
					if(yych <= '/')	goto yy1104;
					goto yy1130;
				} else {
					if(yych <= '9')	goto yy51;
					if(yych <= 'C')	goto yy1104;
					goto yy57;
				}
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy57;
				if(yych <= 'G')	goto yy1104;
				goto yy57;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy1104;
					goto yy57;
				} else {
					if(yych <= 'R')	goto yy1104;
					if(yych <= 'T')	goto yy57;
					goto yy1104;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy1104;
				if(yych <= 'Y')	goto yy57;
				goto yy1104;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy57;
					goto yy1104;
				} else {
					if(yych == 'g')	goto yy1104;
					goto yy57;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy1104;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy1104;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1104;
				}
			}
		}
	}
yy1130:
	YYDEBUG(1130, *YYCURSOR);
	yyaccept = 17;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 8) {
		goto yy51;
	}
	if(yych <= 'W'){
		if(yych <= 'F'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy56;
				if(yych >= ' ')	goto yy56;
				goto yy1131;
			} else {
				if(yych == 'D')	goto yy61;
				if(yych >= 'F')	goto yy63;
				goto yy1131;
			}
		} else {
			if(yych <= 'M'){
				if(yych == 'H')	goto yy60;
				if(yych >= 'M')	goto yy59;
				goto yy1131;
			} else {
				if(yych <= 'S'){
					if(yych >= 'S')	goto yy58;
					goto yy1131;
				} else {
					if(yych <= 'T')	goto yy1132;
					if(yych >= 'W')	goto yy62;
					goto yy1131;
				}
			}
		}
	} else {
		if(yych <= 'l'){
			if(yych <= 'd'){
				if(yych == 'Y')	goto yy64;
				if(yych >= 'd')	goto yy61;
				goto yy1131;
			} else {
				if(yych <= 'f'){
					if(yych >= 'f')	goto yy63;
					goto yy1131;
				} else {
					if(yych == 'h')	goto yy60;
					goto yy1131;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'm')	goto yy59;
				if(yych <= 'r')	goto yy1131;
				if(yych <= 's')	goto yy58;
				goto yy1133;
			} else {
				if(yych <= 'w'){
					if(yych >= 'w')	goto yy62;
					goto yy1131;
				} else {
					if(yych == 'y')	goto yy64;
					goto yy1131;
				}
			}
		}
	}
yy1131:
	YYDEBUG(1131, *YYCURSOR);

{
		DEBUG_OUTPUT("datenocolon");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		s->time->m = timelib_get_nr((char **) &ptr, 2);
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		TIMELIB_DEINIT;
		return TIMELIB_DATE_NOCOLON;
	}
yy1132:
	YYDEBUG(1132, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= '2'){
			if(yych <= '/')	goto yy53;
			if(yych <= '1')	goto yy1147;
			goto yy1148;
		} else {
			if(yych <= '9')	goto yy1149;
			if(yych <= 'G')	goto yy53;
			goto yy66;
		}
	} else {
		if(yych <= 'g'){
			if(yych == 'U')	goto yy67;
			goto yy53;
		} else {
			if(yych <= 'h')	goto yy66;
			if(yych == 'u')	goto yy67;
			goto yy53;
		}
	}
yy1133:
	YYDEBUG(1133, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= '2'){
			if(yych <= '/')	goto yy53;
			if(yych >= '2')	goto yy1135;
			goto yy1134;
		} else {
			if(yych <= '9')	goto yy1136;
			if(yych <= 'G')	goto yy53;
			goto yy66;
		}
	} else {
		if(yych <= 'g'){
			if(yych == 'U')	goto yy67;
			goto yy53;
		} else {
			if(yych <= 'h')	goto yy66;
			if(yych == 'u')	goto yy67;
			goto yy53;
		}
	}
yy1134:
	YYDEBUG(1134, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1141;
	if(yych <= '9')	goto yy1136;
	goto yy53;
yy1135:
	YYDEBUG(1135, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '3')	goto yy1141;
	if(yych <= '5')	goto yy1137;
	goto yy53;
yy1136:
	YYDEBUG(1136, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '6')	goto yy53;
	goto yy1137;
yy1137:
	YYDEBUG(1137, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy1138;
yy1138:
	YYDEBUG(1138, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1139;
	if(yych <= '6')	goto yy1140;
	goto yy53;
yy1139:
	YYDEBUG(1139, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1124;
	goto yy53;
yy1140:
	YYDEBUG(1140, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '0')	goto yy1124;
	goto yy53;
yy1141:
	YYDEBUG(1141, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1142;
	if(yych <= '9')	goto yy1138;
	goto yy53;
yy1142:
	YYDEBUG(1142, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1143;
	if(yych <= '6')	goto yy1144;
	if(yych <= '9')	goto yy1138;
	goto yy53;
yy1143:
	YYDEBUG(1143, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1145;
	if(yych <= '6')	goto yy1146;
	if(yych <= '9')	goto yy1124;
	goto yy53;
yy1144:
	YYDEBUG(1144, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '0')	goto yy1145;
	if(yych <= '5')	goto yy1139;
	if(yych <= '6')	goto yy1140;
	goto yy53;
yy1145:
	YYDEBUG(1145, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1125;
	if(yych <= '9')	goto yy1124;
	goto yy1125;
yy1146:
	YYDEBUG(1146, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '0')	goto yy1124;
	goto yy1125;
yy1147:
	YYDEBUG(1147, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1156;
	if(yych <= '9')	goto yy1149;
	if(yych <= ':')	goto yy1150;
	goto yy53;
yy1148:
	YYDEBUG(1148, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '5'){
		if(yych <= '/')	goto yy53;
		if(yych <= '3')	goto yy1156;
		goto yy1137;
	} else {
		if(yych == ':')	goto yy1150;
		goto yy53;
	}
yy1149:
	YYDEBUG(1149, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1137;
	if(yych != ':')	goto yy53;
	goto yy1150;
yy1150:
	YYDEBUG(1150, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= '6')	goto yy53;
	goto yy1151;
yy1151:
	YYDEBUG(1151, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy1152;
yy1152:
	YYDEBUG(1152, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy1153;
yy1153:
	YYDEBUG(1153, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1154;
	if(yych <= '6')	goto yy1155;
	goto yy53;
yy1154:
	YYDEBUG(1154, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1124;
	goto yy53;
yy1155:
	YYDEBUG(1155, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '0')	goto yy1124;
	goto yy53;
yy1156:
	YYDEBUG(1156, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1142;
	if(yych <= '9')	goto yy1138;
	if(yych <= ':')	goto yy1150;
	goto yy53;
yy1157:
	YYDEBUG(1157, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '0')	goto yy51;
	if(yych <= '9')	goto yy1103;
	goto yy57;
yy1158:
	YYDEBUG(1158, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '2'){
		if(yych <= '/')	goto yy57;
		if(yych <= '0')	goto yy1127;
		goto yy1128;
	} else {
		if(yych <= '3')	goto yy1129;
		if(yych <= '9')	goto yy1103;
		goto yy57;
	}
yy1159:
	YYDEBUG(1159, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1160;
	if(yych != 'c')	goto yy53;
	goto yy1160;
yy1160:
	YYDEBUG(1160, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'E')	goto yy1161;
	if(yych != 'e')	goto yy1077;
	goto yy1161;
yy1161:
	YYDEBUG(1161, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1162;
	if(yych != 'm')	goto yy53;
	goto yy1162;
yy1162:
	YYDEBUG(1162, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy1163;
	if(yych != 'b')	goto yy53;
	goto yy1163;
yy1163:
	YYDEBUG(1163, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1164;
	if(yych != 'e')	goto yy53;
	goto yy1164;
yy1164:
	YYDEBUG(1164, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1165;
	if(yych != 'r')	goto yy53;
	goto yy1165;
yy1165:
	YYDEBUG(1165, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy1077;
yy1166:
	YYDEBUG(1166, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1167;
	if(yych != 'v')	goto yy53;
	goto yy1167;
yy1167:
	YYDEBUG(1167, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'E')	goto yy1168;
	if(yych != 'e')	goto yy1077;
	goto yy1168;
yy1168:
	YYDEBUG(1168, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1169;
	if(yych != 'm')	goto yy53;
	goto yy1169;
yy1169:
	YYDEBUG(1169, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy1170;
	if(yych != 'b')	goto yy53;
	goto yy1170;
yy1170:
	YYDEBUG(1170, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1171;
	if(yych != 'e')	goto yy53;
	goto yy1171;
yy1171:
	YYDEBUG(1171, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1165;
	if(yych == 'r')	goto yy1165;
	goto yy53;
yy1172:
	YYDEBUG(1172, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1173;
	if(yych != 't')	goto yy53;
	goto yy1173;
yy1173:
	YYDEBUG(1173, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'O')	goto yy1174;
	if(yych != 'o')	goto yy1077;
	goto yy1174;
yy1174:
	YYDEBUG(1174, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy1175;
	if(yych != 'b')	goto yy53;
	goto yy1175;
yy1175:
	YYDEBUG(1175, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1176;
	if(yych != 'e')	goto yy53;
	goto yy1176;
yy1176:
	YYDEBUG(1176, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1165;
	if(yych == 'r')	goto yy1165;
	goto yy53;
yy1177:
	YYDEBUG(1177, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych == 'C')	goto yy125;
		if(yych <= 'O')	goto yy53;
		goto yy1178;
	} else {
		if(yych <= 'c'){
			if(yych <= 'b')	goto yy53;
			goto yy125;
		} else {
			if(yych != 'p')	goto yy53;
			goto yy1178;
		}
	}
yy1178:
	YYDEBUG(1178, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1179;
	if(yych != 't')	goto yy1077;
	goto yy1179;
yy1179:
	YYDEBUG(1179, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'E')	goto yy1180;
	if(yych != 'e')	goto yy1077;
	goto yy1180;
yy1180:
	YYDEBUG(1180, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy1181;
	if(yych != 'm')	goto yy53;
	goto yy1181;
yy1181:
	YYDEBUG(1181, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy1182;
	if(yych != 'b')	goto yy53;
	goto yy1182;
yy1182:
	YYDEBUG(1182, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1183;
	if(yych != 'e')	goto yy53;
	goto yy1183;
yy1183:
	YYDEBUG(1183, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1165;
	if(yych == 'r')	goto yy1165;
	goto yy53;
yy1184:
	YYDEBUG(1184, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy1188;
	if(yych == 'g')	goto yy1188;
	goto yy53;
yy1185:
	YYDEBUG(1185, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1186;
	if(yych != 'r')	goto yy53;
	goto yy1186;
yy1186:
	YYDEBUG(1186, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'I')	goto yy1187;
	if(yych != 'i')	goto yy1077;
	goto yy1187;
yy1187:
	YYDEBUG(1187, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy1165;
	if(yych == 'l')	goto yy1165;
	goto yy53;
yy1188:
	YYDEBUG(1188, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'U')	goto yy1189;
	if(yych != 'u')	goto yy1077;
	goto yy1189;
yy1189:
	YYDEBUG(1189, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'S')	goto yy1190;
	if(yych != 's')	goto yy53;
	goto yy1190;
yy1190:
	YYDEBUG(1190, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1165;
	if(yych == 't')	goto yy1165;
	goto yy53;
yy1191:
	YYDEBUG(1191, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych == 'R')	goto yy1192;
		if(yych <= 'X')	goto yy53;
		goto yy1165;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy53;
			goto yy1192;
		} else {
			if(yych == 'y')	goto yy1165;
			goto yy53;
		}
	}
yy1192:
	YYDEBUG(1192, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'C')	goto yy1193;
	if(yych != 'c')	goto yy1077;
	goto yy1193;
yy1193:
	YYDEBUG(1193, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'H')	goto yy1165;
	if(yych == 'h')	goto yy1165;
	goto yy53;
yy1194:
	YYDEBUG(1194, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy1195;
	if(yych != 'b')	goto yy53;
	goto yy1195;
yy1195:
	YYDEBUG(1195, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'R')	goto yy1196;
	if(yych != 'r')	goto yy1077;
	goto yy1196;
yy1196:
	YYDEBUG(1196, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'U')	goto yy1197;
	if(yych != 'u')	goto yy53;
	goto yy1197;
yy1197:
	YYDEBUG(1197, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1198;
	if(yych != 'a')	goto yy53;
	goto yy1198;
yy1198:
	YYDEBUG(1198, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1199;
	if(yych != 'r')	goto yy53;
	goto yy1199;
yy1199:
	YYDEBUG(1199, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy1165;
	if(yych == 'y')	goto yy1165;
	goto yy53;
yy1200:
	YYDEBUG(1200, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'L')	goto yy1207;
		if(yych <= 'M')	goto yy53;
		goto yy1206;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy53;
			goto yy1207;
		} else {
			if(yych == 'n')	goto yy1206;
			goto yy53;
		}
	}
yy1201:
	YYDEBUG(1201, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1202;
	if(yych != 'n')	goto yy53;
	goto yy1202;
yy1202:
	YYDEBUG(1202, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'U')	goto yy1203;
	if(yych != 'u')	goto yy1077;
	goto yy1203;
yy1203:
	YYDEBUG(1203, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1204;
	if(yych != 'a')	goto yy53;
	goto yy1204;
yy1204:
	YYDEBUG(1204, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1205;
	if(yych != 'r')	goto yy53;
	goto yy1205;
yy1205:
	YYDEBUG(1205, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy1165;
	if(yych == 'y')	goto yy1165;
	goto yy53;
yy1206:
	YYDEBUG(1206, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1165;
	if(yych == 'e')	goto yy1165;
	goto yy1077;
yy1207:
	YYDEBUG(1207, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy1165;
	if(yych == 'y')	goto yy1165;
	goto yy1077;
yy1208:
	YYDEBUG(1208, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1165;
	goto yy1077;
yy1209:
	YYDEBUG(1209, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != 'I')	goto yy1077;
	goto yy1210;
yy1210:
	YYDEBUG(1210, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1165;
	goto yy1077;
yy1211:
	YYDEBUG(1211, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy1165;
	goto yy1077;
yy1212:
	YYDEBUG(1212, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '0')	goto yy1227;
	if(yych <= '9')	goto yy1226;
	goto yy53;
yy1213:
	YYDEBUG(1213, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1225;
	goto yy53;
yy1214:
	YYDEBUG(1214, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1223;
	if(yych <= '6')	goto yy1222;
	goto yy53;
yy1215:
	YYDEBUG(1215, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1194;
	if(yych == 'e')	goto yy1194;
	goto yy53;
yy1216:
	YYDEBUG(1216, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1191;
	if(yych == 'a')	goto yy1191;
	goto yy53;
yy1217:
	YYDEBUG(1217, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1221;
	if(yych == 'e')	goto yy1221;
	goto yy53;
yy1218:
	YYDEBUG(1218, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1159;
	if(yych == 'e')	goto yy1159;
	goto yy53;
yy1219:
	YYDEBUG(1219, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	goto yy1220;
yy1220:
	YYDEBUG(1220, *YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	case '-':
	case '.':	goto yy1219;
	case 'A':	case 'a':	goto yy1083;
	case 'D':	case 'd':	goto yy1218;
	case 'F':	case 'f':	goto yy1215;
	case 'I':	goto yy1076;
	case 'J':	case 'j':	goto yy1080;
	case 'M':	case 'm':	goto yy1216;
	case 'N':	case 'n':	goto yy1086;
	case 'O':	case 'o':	goto yy1085;
	case 'S':	case 's':	goto yy1217;
	case 'V':	goto yy1078;
	case 'X':	goto yy1079;
	default:	goto yy53;
	}
yy1221:
	YYDEBUG(1221, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1178;
	if(yych == 'p')	goto yy1178;
	goto yy53;
yy1222:
	YYDEBUG(1222, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '6')	goto yy1224;
	goto yy53;
yy1223:
	YYDEBUG(1223, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy1224;
yy1224:
	YYDEBUG(1224, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy1104;
yy1225:
	YYDEBUG(1225, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1224;
	goto yy53;
yy1226:
	YYDEBUG(1226, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1224;
	goto yy53;
yy1227:
	YYDEBUG(1227, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '0')	goto yy53;
	if(yych <= '9')	goto yy1224;
	goto yy53;
yy1228:
	YYDEBUG(1228, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '.')	goto yy53;
	if(yych <= '/')	goto yy1231;
	if(yych <= '0')	goto yy1230;
	if(yych <= '9')	goto yy1241;
	goto yy53;
yy1229:
	YYDEBUG(1229, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '.')	goto yy53;
	if(yych <= '/')	goto yy1231;
	if(yych <= '2')	goto yy1241;
	goto yy53;
yy1230:
	YYDEBUG(1230, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '/')	goto yy53;
	goto yy1231;
yy1231:
	YYDEBUG(1231, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '2')	goto yy1232;
	if(yych <= '3')	goto yy1234;
	if(yych <= '9')	goto yy1235;
	goto yy53;
yy1232:
	YYDEBUG(1232, *YYCURSOR);
	yyaccept = 19;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/')	goto yy1233;
		if(yych <= '9')	goto yy1235;
		if(yych >= 'n')	goto yy1237;
		goto yy1233;
	} else {
		if(yych <= 'r'){
			if(yych >= 'r')	goto yy1238;
			goto yy1233;
		} else {
			if(yych <= 's')	goto yy1236;
			if(yych <= 't')	goto yy1239;
			goto yy1233;
		}
	}
yy1233:
	YYDEBUG(1233, *YYCURSOR);

{
		DEBUG_OUTPUT("iso8601date | iso8601dateslash | dateslash");
		TIMELIB_INIT;
		TIMELIB_HAVE_DATE();
		s->time->y = timelib_get_nr((char **) &ptr, 4);
		s->time->m = timelib_get_nr((char **) &ptr, 2);
		s->time->d = timelib_get_nr((char **) &ptr, 2);
		TIMELIB_DEINIT;
		return TIMELIB_ISO_DATE;
	}
yy1234:
	YYDEBUG(1234, *YYCURSOR);
	yyaccept = 19;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/')	goto yy1233;
		if(yych <= '1')	goto yy1235;
		if(yych <= 'm')	goto yy1233;
		goto yy1237;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy1233;
			goto yy1238;
		} else {
			if(yych <= 's')	goto yy1236;
			if(yych <= 't')	goto yy1239;
			goto yy1233;
		}
	}
yy1235:
	YYDEBUG(1235, *YYCURSOR);
	yyaccept = 19;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'q'){
		if(yych == 'n')	goto yy1237;
		goto yy1233;
	} else {
		if(yych <= 'r')	goto yy1238;
		if(yych <= 's')	goto yy1236;
		if(yych <= 't')	goto yy1239;
		goto yy1233;
	}
yy1236:
	YYDEBUG(1236, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 't')	goto yy1240;
	goto yy53;
yy1237:
	YYDEBUG(1237, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'd')	goto yy1240;
	goto yy53;
yy1238:
	YYDEBUG(1238, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'd')	goto yy1240;
	goto yy53;
yy1239:
	YYDEBUG(1239, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != 'h')	goto yy53;
	goto yy1240;
yy1240:
	YYDEBUG(1240, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy1233;
yy1241:
	YYDEBUG(1241, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '/')	goto yy53;
	goto yy1242;
yy1242:
	YYDEBUG(1242, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '2'){
		if(yych <= '/')	goto yy53;
		if(yych >= '1')	goto yy1244;
		goto yy1243;
	} else {
		if(yych <= '3')	goto yy1245;
		if(yych <= '9')	goto yy1235;
		goto yy53;
	}
yy1243:
	YYDEBUG(1243, *YYCURSOR);
	yyaccept = 19;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '0'){
			if(yych <= '/')	goto yy1233;
			goto yy1235;
		} else {
			if(yych <= '9')	goto yy1246;
			if(yych <= 'm')	goto yy1233;
			goto yy1237;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy1233;
			goto yy1238;
		} else {
			if(yych <= 's')	goto yy1236;
			if(yych <= 't')	goto yy1239;
			goto yy1233;
		}
	}
yy1244:
	YYDEBUG(1244, *YYCURSOR);
	yyaccept = 19;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/')	goto yy1233;
		if(yych <= '9')	goto yy1246;
		if(yych <= 'm')	goto yy1233;
		goto yy1237;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy1233;
			goto yy1238;
		} else {
			if(yych <= 's')	goto yy1236;
			if(yych <= 't')	goto yy1239;
			goto yy1233;
		}
	}
yy1245:
	YYDEBUG(1245, *YYCURSOR);
	yyaccept = 19;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych <= '/')	goto yy1233;
		if(yych <= '1')	goto yy1246;
		if(yych <= 'm')	goto yy1233;
		goto yy1237;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy1233;
			goto yy1238;
		} else {
			if(yych <= 's')	goto yy1236;
			if(yych <= 't')	goto yy1239;
			goto yy1233;
		}
	}
yy1246:
	YYDEBUG(1246, *YYCURSOR);
	yyaccept = 19;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych == '/')	goto yy1240;
		if(yych <= 'm')	goto yy1233;
		goto yy1237;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy1233;
			goto yy1238;
		} else {
			if(yych <= 's')	goto yy1236;
			if(yych <= 't')	goto yy1239;
			goto yy1233;
		}
	}
yy1247:
	YYDEBUG(1247, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'A')	goto yy1322;
		if(yych <= 'T')	goto yy53;
		goto yy1321;
	} else {
		if(yych <= 'a'){
			if(yych <= '`')	goto yy53;
			goto yy1322;
		} else {
			if(yych == 'u')	goto yy1321;
			goto yy53;
		}
	}
yy1248:
	YYDEBUG(1248, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1319;
	if(yych == 'e')	goto yy1319;
	goto yy53;
yy1249:
	YYDEBUG(1249, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1316;
	if(yych == 'a')	goto yy1316;
	goto yy53;
yy1250:
	YYDEBUG(1250, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych == 'P')	goto yy1313;
		if(yych <= 'T')	goto yy53;
		goto yy1312;
	} else {
		if(yych <= 'p'){
			if(yych <= 'o')	goto yy53;
			goto yy1313;
		} else {
			if(yych == 'u')	goto yy1312;
			goto yy53;
		}
	}
yy1251:
	YYDEBUG(1251, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1309;
	if(yych == 'e')	goto yy1309;
	goto yy53;
yy1252:
	YYDEBUG(1252, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1307;
	if(yych == 'c')	goto yy1307;
	goto yy53;
yy1253:
	YYDEBUG(1253, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy1305;
	if(yych == 'o')	goto yy1305;
	goto yy53;
yy1254:
	YYDEBUG(1254, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy1303;
	if(yych == 'e')	goto yy1303;
	goto yy53;
yy1255:
	YYDEBUG(1255, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/'){
		if(yych == '-')	goto yy1258;
		goto yy53;
	} else {
		if(yych <= '0')	goto yy1257;
		if(yych <= '9')	goto yy1277;
		goto yy53;
	}
yy1256:
	YYDEBUG(1256, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '-')	goto yy1258;
	if(yych <= '/')	goto yy53;
	if(yych <= '2')	goto yy1277;
	goto yy53;
yy1257:
	YYDEBUG(1257, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '-')	goto yy53;
	goto yy1258;
yy1258:
	YYDEBUG(1258, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '2')	goto yy1259;
	if(yych <= '3')	goto yy1260;
	if(yych <= '9')	goto yy1261;
	goto yy53;
yy1259:
	YYDEBUG(1259, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '9'){
			if(yych <= '/')	goto yy959;
			goto yy1261;
		} else {
			if(yych == 'T')	goto yy1266;
			goto yy959;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy1263;
			if(yych <= 'q')	goto yy959;
			goto yy1264;
		} else {
			if(yych <= 's')	goto yy1262;
			if(yych <= 't')	goto yy1265;
			goto yy959;
		}
	}
yy1260:
	YYDEBUG(1260, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '1'){
			if(yych <= '/')	goto yy959;
			goto yy1261;
		} else {
			if(yych == 'T')	goto yy1266;
			goto yy959;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy1263;
			if(yych <= 'q')	goto yy959;
			goto yy1264;
		} else {
			if(yych <= 's')	goto yy1262;
			if(yych <= 't')	goto yy1265;
			goto yy959;
		}
	}
yy1261:
	YYDEBUG(1261, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych == 'T')	goto yy1266;
		if(yych <= 'm')	goto yy959;
		goto yy1263;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy959;
			goto yy1264;
		} else {
			if(yych <= 's')	goto yy1262;
			if(yych <= 't')	goto yy1265;
			goto yy959;
		}
	}
yy1262:
	YYDEBUG(1262, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 't')	goto yy1276;
	goto yy53;
yy1263:
	YYDEBUG(1263, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'd')	goto yy1276;
	goto yy53;
yy1264:
	YYDEBUG(1264, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'd')	goto yy1276;
	goto yy53;
yy1265:
	YYDEBUG(1265, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'h')	goto yy1276;
	goto yy53;
yy1266:
	YYDEBUG(1266, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '1')	goto yy1267;
	if(yych <= '2')	goto yy1268;
	if(yych <= '9')	goto yy1269;
	goto yy53;
yy1267:
	YYDEBUG(1267, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1269;
	if(yych <= ':')	goto yy1270;
	goto yy53;
yy1268:
	YYDEBUG(1268, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '3')	goto yy1269;
	if(yych == ':')	goto yy1270;
	goto yy53;
yy1269:
	YYDEBUG(1269, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy1270;
yy1270:
	YYDEBUG(1270, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1271;
	if(yych <= '9')	goto yy1272;
	goto yy53;
yy1271:
	YYDEBUG(1271, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1272;
	if(yych <= ':')	goto yy1273;
	goto yy53;
yy1272:
	YYDEBUG(1272, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy1273;
yy1273:
	YYDEBUG(1273, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1274;
	if(yych <= '6')	goto yy1275;
	if(yych <= '9')	goto yy1124;
	goto yy53;
yy1274:
	YYDEBUG(1274, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1125;
	if(yych <= '9')	goto yy1124;
	goto yy1125;
yy1275:
	YYDEBUG(1275, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '0')	goto yy1124;
	goto yy1125;
yy1276:
	YYDEBUG(1276, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'T')	goto yy1266;
	goto yy959;
yy1277:
	YYDEBUG(1277, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '-')	goto yy53;
	goto yy1278;
yy1278:
	YYDEBUG(1278, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '2'){
		if(yych <= '/')	goto yy53;
		if(yych >= '1')	goto yy1280;
		goto yy1279;
	} else {
		if(yych <= '3')	goto yy1281;
		if(yych <= '9')	goto yy1261;
		goto yy53;
	}
yy1279:
	YYDEBUG(1279, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '9'){
			if(yych <= '/')	goto yy959;
			if(yych <= '0')	goto yy1261;
			goto yy1282;
		} else {
			if(yych == 'T')	goto yy1266;
			goto yy959;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy1263;
			if(yych <= 'q')	goto yy959;
			goto yy1264;
		} else {
			if(yych <= 's')	goto yy1262;
			if(yych <= 't')	goto yy1265;
			goto yy959;
		}
	}
yy1280:
	YYDEBUG(1280, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '9'){
			if(yych <= '/')	goto yy959;
			goto yy1282;
		} else {
			if(yych == 'T')	goto yy1266;
			goto yy959;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy1263;
			if(yych <= 'q')	goto yy959;
			goto yy1264;
		} else {
			if(yych <= 's')	goto yy1262;
			if(yych <= 't')	goto yy1265;
			goto yy959;
		}
	}
yy1281:
	YYDEBUG(1281, *YYCURSOR);
	yyaccept = 13;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'm'){
		if(yych <= '1'){
			if(yych <= '/')	goto yy959;
			goto yy1282;
		} else {
			if(yych == 'T')	goto yy1266;
			goto yy959;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'n')	goto yy1263;
			if(yych <= 'q')	goto yy959;
			goto yy1264;
		} else {
			if(yych <= 's')	goto yy1262;
			if(yych <= 't')	goto yy1265;
			goto yy959;
		}
	}
yy1282:
	YYDEBUG(1282, *YYCURSOR);
	yyaccept = 19;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'n'){
		if(yych == 'T')	goto yy1283;
		if(yych <= 'm')	goto yy1233;
		goto yy1263;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy1233;
			goto yy1264;
		} else {
			if(yych <= 's')	goto yy1262;
			if(yych <= 't')	goto yy1265;
			goto yy1233;
		}
	}
yy1283:
	YYDEBUG(1283, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '1')	goto yy1284;
	if(yych <= '2')	goto yy1285;
	if(yych <= '9')	goto yy1269;
	goto yy53;
yy1284:
	YYDEBUG(1284, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1286;
	if(yych <= ':')	goto yy1270;
	goto yy53;
yy1285:
	YYDEBUG(1285, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '3')	goto yy1286;
	if(yych == ':')	goto yy1270;
	goto yy53;
yy1286:
	YYDEBUG(1286, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy1287;
yy1287:
	YYDEBUG(1287, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1288;
	if(yych <= '9')	goto yy1272;
	goto yy53;
yy1288:
	YYDEBUG(1288, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1289;
	if(yych <= ':')	goto yy1273;
	goto yy53;
yy1289:
	YYDEBUG(1289, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != ':')	goto yy53;
	goto yy1290;
yy1290:
	YYDEBUG(1290, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1291;
	if(yych <= '6')	goto yy1292;
	if(yych <= '9')	goto yy1124;
	goto yy53;
yy1291:
	YYDEBUG(1291, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1125;
	if(yych <= '9')	goto yy1293;
	goto yy1125;
yy1292:
	YYDEBUG(1292, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '0')	goto yy1125;
	goto yy1293;
yy1293:
	YYDEBUG(1293, *YYCURSOR);
	yyaccept = 20;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != '.')	goto yy1125;
	goto yy1294;
yy1294:
	YYDEBUG(1294, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy1295;
yy1295:
	YYDEBUG(1295, *YYCURSOR);
	yyaccept = 20;
	YYMARKER = ++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 6) YYFILL(6);
	yych = *YYCURSOR;
	goto yy1296;
yy1296:
	YYDEBUG(1296, *YYCURSOR);
	if(yych <= ','){
		if(yych != '+')	goto yy1125;
		goto yy1297;
	} else {
		if(yych <= '-')	goto yy1297;
		if(yych <= '/')	goto yy1125;
		if(yych <= '9')	goto yy1295;
		goto yy1125;
	}
yy1297:
	YYDEBUG(1297, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '1')	goto yy1298;
	if(yych <= '2')	goto yy1299;
	if(yych <= '9')	goto yy1300;
	goto yy53;
yy1298:
	YYDEBUG(1298, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1125;
	if(yych <= '9')	goto yy1300;
	if(yych <= ':')	goto yy1301;
	goto yy1125;
yy1299:
	YYDEBUG(1299, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '5'){
		if(yych <= '/')	goto yy1125;
		if(yych >= '4')	goto yy1302;
		goto yy1300;
	} else {
		if(yych <= '9')	goto yy1124;
		if(yych <= ':')	goto yy1301;
		goto yy1125;
	}
yy1300:
	YYDEBUG(1300, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1125;
	if(yych <= '5')	goto yy1302;
	if(yych <= '9')	goto yy1124;
	if(yych >= ';')	goto yy1125;
	goto yy1301;
yy1301:
	YYDEBUG(1301, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1125;
	if(yych <= '5')	goto yy1302;
	if(yych <= '9')	goto yy1124;
	goto yy1125;
yy1302:
	YYDEBUG(1302, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1125;
	if(yych <= '9')	goto yy1124;
	goto yy1125;
yy1303:
	YYDEBUG(1303, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy1304;
	if(yych != 'c')	goto yy53;
	goto yy1304;
yy1304:
	YYDEBUG(1304, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'E')	goto yy1161;
		if(yych == 'e')	goto yy1161;
		goto yy1077;
	}
yy1305:
	YYDEBUG(1305, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'V')	goto yy1306;
	if(yych != 'v')	goto yy53;
	goto yy1306;
yy1306:
	YYDEBUG(1306, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'E')	goto yy1168;
		if(yych == 'e')	goto yy1168;
		goto yy1077;
	}
yy1307:
	YYDEBUG(1307, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1308;
	if(yych != 't')	goto yy53;
	goto yy1308;
yy1308:
	YYDEBUG(1308, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'O')	goto yy1174;
		if(yych == 'o')	goto yy1174;
		goto yy1077;
	}
yy1309:
	YYDEBUG(1309, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy1310;
	if(yych != 'p')	goto yy53;
	goto yy1310;
yy1310:
	YYDEBUG(1310, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'T')	goto yy1311;
		if(yych != 't')	goto yy1077;
		goto yy1311;
	}
yy1311:
	YYDEBUG(1311, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'E')	goto yy1180;
		if(yych == 'e')	goto yy1180;
		goto yy1077;
	}
yy1312:
	YYDEBUG(1312, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'G')	goto yy1315;
	if(yych == 'g')	goto yy1315;
	goto yy53;
yy1313:
	YYDEBUG(1313, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy1314;
	if(yych != 'r')	goto yy53;
	goto yy1314;
yy1314:
	YYDEBUG(1314, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'I')	goto yy1187;
		if(yych == 'i')	goto yy1187;
		goto yy1077;
	}
yy1315:
	YYDEBUG(1315, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'U')	goto yy1189;
		if(yych == 'u')	goto yy1189;
		goto yy1077;
	}
yy1316:
	YYDEBUG(1316, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych == 'R')	goto yy1317;
		if(yych <= 'X')	goto yy53;
		goto yy1318;
	} else {
		if(yych <= 'r'){
			if(yych <= 'q')	goto yy53;
			goto yy1317;
		} else {
			if(yych == 'y')	goto yy1318;
			goto yy53;
		}
	}
yy1317:
	YYDEBUG(1317, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'B'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'C')	goto yy1193;
		if(yych == 'c')	goto yy1193;
		goto yy1077;
	}
yy1318:
	YYDEBUG(1318, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '-')	goto yy1053;
	goto yy1077;
yy1319:
	YYDEBUG(1319, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy1320;
	if(yych != 'b')	goto yy53;
	goto yy1320;
yy1320:
	YYDEBUG(1320, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Q'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'R')	goto yy1196;
		if(yych == 'r')	goto yy1196;
		goto yy1077;
	}
yy1321:
	YYDEBUG(1321, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych == 'L')	goto yy1325;
		if(yych <= 'M')	goto yy53;
		goto yy1324;
	} else {
		if(yych <= 'l'){
			if(yych <= 'k')	goto yy53;
			goto yy1325;
		} else {
			if(yych == 'n')	goto yy1324;
			goto yy53;
		}
	}
yy1322:
	YYDEBUG(1322, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'N')	goto yy1323;
	if(yych != 'n')	goto yy53;
	goto yy1323;
yy1323:
	YYDEBUG(1323, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'U')	goto yy1203;
		if(yych == 'u')	goto yy1203;
		goto yy1077;
	}
yy1324:
	YYDEBUG(1324, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'E')	goto yy1165;
		if(yych == 'e')	goto yy1165;
		goto yy1077;
	}
yy1325:
	YYDEBUG(1325, *YYCURSOR);
	yyaccept = 18;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'X'){
		if(yych == '-')	goto yy1053;
		goto yy1077;
	} else {
		if(yych <= 'Y')	goto yy1165;
		if(yych == 'y')	goto yy1165;
		goto yy1077;
	}
yy1326:
	YYDEBUG(1326, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/'){
		if(yych <= 0x09){
			if(yych <= 0x08)	goto yy883;
			goto yy1030;
		} else {
			if(yych <= ',')	goto yy883;
			if(yych <= '.')	goto yy1030;
			goto yy1029;
		}
	} else {
		if(yych <= 'U'){
			if(yych <= 'T')	goto yy883;
			goto yy74;
		} else {
			if(yych == 'u')	goto yy74;
			goto yy883;
		}
	}
yy1327:
	YYDEBUG(1327, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'P'){
		if(yych == 'C')	goto yy125;
		if(yych <= 'O')	goto yy53;
		goto yy891;
	} else {
		if(yych <= 'c'){
			if(yych <= 'b')	goto yy53;
			goto yy125;
		} else {
			if(yych == 'p')	goto yy891;
			goto yy53;
		}
	}
yy1328:
	YYDEBUG(1328, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= ','){
			if(yych != 0x09)	goto yy1331;
			goto yy1329;
		} else {
			if(yych <= '-')	goto yy794;
			if(yych <= '.')	goto yy1030;
			if(yych <= '/')	goto yy1029;
			goto yy1034;
		}
	} else {
		if(yych <= 'q'){
			if(yych == 'n')	goto yy791;
			goto yy1331;
		} else {
			if(yych <= 'r')	goto yy792;
			if(yych <= 's')	goto yy785;
			if(yych <= 't')	goto yy789;
			goto yy1331;
		}
	}
yy1329:
	YYDEBUG(1329, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy1331;
	if(yych <= '0')	goto yy1031;
	if(yych <= '1')	goto yy1032;
	if(yych <= '9')	goto yy1033;
	goto yy1331;
yy1330:
	YYDEBUG(1330, *YYCURSOR);
	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 13) YYFILL(13);
	yych = *YYCURSOR;
	goto yy1331;
yy1331:
	YYDEBUG(1331, *YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	goto yy1330;
	case '-':
	case '.':	goto yy882;
	case 'A':	case 'a':	goto yy879;
	case 'D':	case 'd':	goto yy787;
	case 'F':	case 'f':	goto yy788;
	case 'H':	case 'h':	goto yy60;
	case 'I':	goto yy796;
	case 'J':	case 'j':	goto yy800;
	case 'M':	case 'm':	goto yy786;
	case 'N':	case 'n':	goto yy803;
	case 'O':	case 'o':	goto yy802;
	case 'S':	case 's':	goto yy784;
	case 'T':	case 't':	goto yy65;
	case 'V':	goto yy798;
	case 'W':	case 'w':	goto yy62;
	case 'X':	goto yy799;
	case 'Y':	case 'y':	goto yy64;
	default:	goto yy53;
	}
yy1332:
	YYDEBUG(1332, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == 0x09)	goto yy1329;
			if(yych <= ',')	goto yy1331;
			goto yy794;
		} else {
			if(yych <= '.')	goto yy1333;
			if(yych <= '/')	goto yy1029;
			if(yych <= '5')	goto yy1335;
			goto yy1034;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy1334;
			if(yych == 'n')	goto yy791;
			goto yy1331;
		} else {
			if(yych <= 'r')	goto yy792;
			if(yych <= 's')	goto yy785;
			if(yych <= 't')	goto yy789;
			goto yy1331;
		}
	}
yy1333:
	YYDEBUG(1333, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '1'){
		if(yych <= '/')	goto yy883;
		if(yych <= '0')	goto yy1357;
		goto yy1358;
	} else {
		if(yych <= '5')	goto yy1359;
		if(yych <= '9')	goto yy1360;
		goto yy883;
	}
yy1334:
	YYDEBUG(1334, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1352;
	if(yych <= '9')	goto yy1353;
	goto yy53;
yy1335:
	YYDEBUG(1335, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '-')	goto yy1035;
	if(yych <= '/')	goto yy57;
	if(yych >= ':')	goto yy57;
	goto yy1336;
yy1336:
	YYDEBUG(1336, *YYCURSOR);
	yyaccept = 21;
	yych = *(YYMARKER = ++YYCURSOR);
	YYDEBUG(-1, yych);
	switch(yych){
	case 0x09:	case ' ':	case 'A':	case 'D':	case 'F':	case 'H':
	case 'I':
	case 'J':	case 'M':
	case 'N':
	case 'O':	case 'S':
	case 'T':	case 'V':	case 'X':
	case 'Y':	case 'a':	case 'd':	case 'f':	case 'h':	case 'j':	case 'm':
	case 'n':
	case 'o':	case 's':
	case 't':	case 'w':	case 'y':	goto yy1074;
	case '-':	goto yy1071;
	case '.':	goto yy1075;
	case '/':	goto yy1072;
	case '0':	goto yy1338;
	case '1':	goto yy1339;
	case '2':	goto yy1340;
	case '3':	goto yy1341;
	case '4':
	case '5':	goto yy1342;
	case '6':	goto yy1343;
	case '7':
	case '8':
	case '9':	goto yy51;
	case ':':	goto yy1090;
	case 'W':	goto yy1093;
	default:	goto yy1337;
	}
yy1337:
	YYDEBUG(1337, *YYCURSOR);

{
		DEBUG_OUTPUT("gnunocolon");
		TIMELIB_INIT;
		switch (s->time->have_time) {
			case 0:
				s->time->h = timelib_get_nr((char **) &ptr, 2);
				s->time->i = timelib_get_nr((char **) &ptr, 2);
				s->time->s = 0;
				break;
			case 1:
				s->time->y = timelib_get_nr((char **) &ptr, 4);
				break;
			default:
				TIMELIB_DEINIT;
				add_error(s, "Double time specification");
				return TIMELIB_ERROR;
		}
		s->time->have_time++;
		TIMELIB_DEINIT;
		return TIMELIB_GNU_NOCOLON;
	}
yy1338:
	YYDEBUG(1338, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '0')	goto yy1350;
	if(yych <= '9')	goto yy1351;
	goto yy57;
yy1339:
	YYDEBUG(1339, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '2')	goto yy1349;
	if(yych <= '9')	goto yy1348;
	goto yy57;
yy1340:
	YYDEBUG(1340, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '9')	goto yy1348;
	goto yy57;
yy1341:
	YYDEBUG(1341, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '5')	goto yy1346;
	if(yych <= '6')	goto yy1347;
	if(yych <= '9')	goto yy1344;
	goto yy57;
yy1342:
	YYDEBUG(1342, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '9')	goto yy1344;
	goto yy57;
yy1343:
	YYDEBUG(1343, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy57;
	if(yych <= '0')	goto yy1344;
	if(yych <= '9')	goto yy51;
	goto yy57;
yy1344:
	YYDEBUG(1344, *YYCURSOR);
	yyaccept = 22;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 8) {
		goto yy51;
	}
	if(yych <= 'W'){
		if(yych <= 'F'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych >= ' ')	goto yy57;
				goto yy1345;
			} else {
				if(yych == 'D')	goto yy57;
				if(yych >= 'F')	goto yy57;
				goto yy1345;
			}
		} else {
			if(yych <= 'M'){
				if(yych == 'H')	goto yy57;
				if(yych >= 'M')	goto yy57;
				goto yy1345;
			} else {
				if(yych <= 'R')	goto yy1345;
				if(yych <= 'T')	goto yy57;
				if(yych >= 'W')	goto yy57;
				goto yy1345;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'd'){
				if(yych == 'Y')	goto yy57;
				if(yych >= 'd')	goto yy57;
				goto yy1345;
			} else {
				if(yych == 'f')	goto yy57;
				if(yych >= 'h')	goto yy57;
				goto yy1345;
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych >= 's')	goto yy57;
				goto yy1345;
			} else {
				if(yych <= 'w'){
					if(yych >= 'w')	goto yy57;
					goto yy1345;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1345;
				}
			}
		}
	}
yy1345:
	YYDEBUG(1345, *YYCURSOR);

{
		int tz_not_found;
		DEBUG_OUTPUT("iso8601nocolon");
		TIMELIB_INIT;
		TIMELIB_HAVE_TIME();
		s->time->h = timelib_get_nr((char **) &ptr, 2);
		s->time->i = timelib_get_nr((char **) &ptr, 2);
		s->time->s = timelib_get_nr((char **) &ptr, 2);

		if (*ptr != '\0') {
			s->time->z = timelib_get_zone((char **) &ptr, &s->time->dst, s->time, &tz_not_found, s->tzdb);
			if (tz_not_found) {
				add_error(s, "The timezone could not be found in the database");
			}
		}
		TIMELIB_DEINIT;
		return TIMELIB_ISO_NOCOLON;
	}
yy1346:
	YYDEBUG(1346, *YYCURSOR);
	yyaccept = 22;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy1345;
				goto yy57;
			} else {
				if(yych <= '/')	goto yy1345;
				if(yych <= '9')	goto yy1103;
				if(yych <= 'C')	goto yy1345;
				goto yy57;
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy57;
				if(yych <= 'G')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy1345;
					goto yy57;
				} else {
					if(yych <= 'R')	goto yy1345;
					if(yych <= 'T')	goto yy57;
					goto yy1345;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy1345;
				if(yych <= 'Y')	goto yy57;
				goto yy1345;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy57;
					goto yy1345;
				} else {
					if(yych == 'g')	goto yy1345;
					goto yy57;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1345;
				}
			}
		}
	}
yy1347:
	YYDEBUG(1347, *YYCURSOR);
	yyaccept = 22;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy1345;
				goto yy57;
			} else {
				if(yych <= '6'){
					if(yych <= '/')	goto yy1345;
					goto yy1103;
				} else {
					if(yych <= '9')	goto yy51;
					if(yych <= 'C')	goto yy1345;
					goto yy57;
				}
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy57;
				if(yych <= 'G')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy1345;
					goto yy57;
				} else {
					if(yych <= 'R')	goto yy1345;
					if(yych <= 'T')	goto yy57;
					goto yy1345;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy1345;
				if(yych <= 'Y')	goto yy57;
				goto yy1345;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy57;
					goto yy1345;
				} else {
					if(yych == 'g')	goto yy1345;
					goto yy57;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1345;
				}
			}
		}
	}
yy1348:
	YYDEBUG(1348, *YYCURSOR);
	yyaccept = 22;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy1345;
				goto yy57;
			} else {
				if(yych <= '/')	goto yy1345;
				if(yych <= '9')	goto yy1103;
				if(yych <= 'C')	goto yy1345;
				goto yy57;
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy57;
				if(yych <= 'G')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy1345;
					goto yy57;
				} else {
					if(yych <= 'R')	goto yy1345;
					if(yych <= 'T')	goto yy57;
					goto yy1345;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy1345;
				if(yych <= 'Y')	goto yy57;
				goto yy1345;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy57;
					goto yy1345;
				} else {
					if(yych == 'g')	goto yy1345;
					goto yy57;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1345;
				}
			}
		}
	}
yy1349:
	YYDEBUG(1349, *YYCURSOR);
	yyaccept = 22;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '9'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy1345;
				goto yy57;
			} else {
				if(yych <= '0'){
					if(yych <= '/')	goto yy1345;
					goto yy1127;
				} else {
					if(yych <= '2')	goto yy1128;
					if(yych <= '3')	goto yy1129;
					goto yy1103;
				}
			}
		} else {
			if(yych <= 'G'){
				if(yych <= 'D'){
					if(yych <= 'C')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'F')	goto yy57;
					goto yy1345;
				}
			} else {
				if(yych <= 'L'){
					if(yych <= 'H')	goto yy57;
					goto yy1345;
				} else {
					if(yych <= 'M')	goto yy57;
					if(yych <= 'R')	goto yy1345;
					goto yy57;
				}
			}
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Y'){
				if(yych == 'W')	goto yy57;
				if(yych <= 'X')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'd'){
					if(yych <= 'c')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'f')	goto yy57;
					goto yy1345;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'l'){
					if(yych <= 'h')	goto yy57;
					goto yy1345;
				} else {
					if(yych <= 'm')	goto yy57;
					if(yych <= 'r')	goto yy1345;
					goto yy57;
				}
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1345;
				}
			}
		}
	}
yy1350:
	YYDEBUG(1350, *YYCURSOR);
	yyaccept = 22;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'V'){
		if(yych <= 'D'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy1345;
				goto yy57;
			} else {
				if(yych <= '0'){
					if(yych <= '/')	goto yy1345;
					goto yy51;
				} else {
					if(yych <= '9')	goto yy1103;
					if(yych <= 'C')	goto yy1345;
					goto yy57;
				}
			}
		} else {
			if(yych <= 'H'){
				if(yych == 'F')	goto yy57;
				if(yych <= 'G')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'M'){
					if(yych <= 'L')	goto yy1345;
					goto yy57;
				} else {
					if(yych <= 'R')	goto yy1345;
					if(yych <= 'T')	goto yy57;
					goto yy1345;
				}
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'c'){
				if(yych == 'X')	goto yy1345;
				if(yych <= 'Y')	goto yy57;
				goto yy1345;
			} else {
				if(yych <= 'e'){
					if(yych <= 'd')	goto yy57;
					goto yy1345;
				} else {
					if(yych == 'g')	goto yy1345;
					goto yy57;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych == 'm')	goto yy57;
				if(yych <= 'r')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1345;
				}
			}
		}
	}
yy1351:
	YYDEBUG(1351, *YYCURSOR);
	yyaccept = 22;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '9'){
			if(yych <= ' '){
				if(yych == 0x09)	goto yy57;
				if(yych <= 0x1F)	goto yy1345;
				goto yy57;
			} else {
				if(yych <= '0'){
					if(yych <= '/')	goto yy1345;
					goto yy1127;
				} else {
					if(yych <= '2')	goto yy1128;
					if(yych <= '3')	goto yy1129;
					goto yy1103;
				}
			}
		} else {
			if(yych <= 'G'){
				if(yych <= 'D'){
					if(yych <= 'C')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'F')	goto yy57;
					goto yy1345;
				}
			} else {
				if(yych <= 'L'){
					if(yych <= 'H')	goto yy57;
					goto yy1345;
				} else {
					if(yych <= 'M')	goto yy57;
					if(yych <= 'R')	goto yy1345;
					goto yy57;
				}
			}
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Y'){
				if(yych == 'W')	goto yy57;
				if(yych <= 'X')	goto yy1345;
				goto yy57;
			} else {
				if(yych <= 'd'){
					if(yych <= 'c')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'f')	goto yy57;
					goto yy1345;
				}
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'l'){
					if(yych <= 'h')	goto yy57;
					goto yy1345;
				} else {
					if(yych <= 'm')	goto yy57;
					if(yych <= 'r')	goto yy1345;
					goto yy57;
				}
			} else {
				if(yych <= 'w'){
					if(yych <= 'v')	goto yy1345;
					goto yy57;
				} else {
					if(yych == 'y')	goto yy57;
					goto yy1345;
				}
			}
		}
	}
yy1352:
	YYDEBUG(1352, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy1354;
		goto yy812;
	} else {
		if(yych <= '9')	goto yy1353;
		if(yych <= ':')	goto yy1354;
		goto yy812;
	}
yy1353:
	YYDEBUG(1353, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy1354;
	if(yych != ':')	goto yy812;
	goto yy1354;
yy1354:
	YYDEBUG(1354, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1355;
	if(yych <= '6')	goto yy1356;
	if(yych <= '9')	goto yy817;
	goto yy53;
yy1355:
	YYDEBUG(1355, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy818;
	if(yych <= '/')	goto yy812;
	if(yych <= '9')	goto yy817;
	goto yy812;
yy1356:
	YYDEBUG(1356, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy818;
	if(yych == '0')	goto yy817;
	goto yy812;
yy1357:
	YYDEBUG(1357, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ',')	goto yy812;
		if(yych <= '-')	goto yy906;
		goto yy1361;
	} else {
		if(yych <= '/')	goto yy812;
		if(yych <= '9')	goto yy1360;
		if(yych <= ':')	goto yy1354;
		goto yy812;
	}
yy1358:
	YYDEBUG(1358, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= ',')	goto yy812;
		if(yych <= '-')	goto yy906;
		if(yych <= '.')	goto yy1361;
		goto yy812;
	} else {
		if(yych <= '2')	goto yy1360;
		if(yych <= '9')	goto yy1353;
		if(yych <= ':')	goto yy1354;
		goto yy812;
	}
yy1359:
	YYDEBUG(1359, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ',')	goto yy812;
		if(yych <= '-')	goto yy906;
		goto yy1361;
	} else {
		if(yych <= '/')	goto yy812;
		if(yych <= '9')	goto yy1353;
		if(yych <= ':')	goto yy1354;
		goto yy812;
	}
yy1360:
	YYDEBUG(1360, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ',')	goto yy812;
		if(yych <= '-')	goto yy906;
		goto yy1361;
	} else {
		if(yych == ':')	goto yy1354;
		goto yy812;
	}
yy1361:
	YYDEBUG(1361, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '5')	goto yy1362;
	if(yych <= '6')	goto yy1363;
	if(yych <= '9')	goto yy910;
	goto yy53;
yy1362:
	YYDEBUG(1362, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy818;
	if(yych <= '/')	goto yy812;
	if(yych <= '9')	goto yy1364;
	goto yy812;
yy1363:
	YYDEBUG(1363, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych == '.')	goto yy818;
		goto yy812;
	} else {
		if(yych <= '0')	goto yy1364;
		if(yych <= '9')	goto yy911;
		goto yy812;
	}
yy1364:
	YYDEBUG(1364, *YYCURSOR);
	yyaccept = 12;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '.')	goto yy818;
	if(yych <= '/')	goto yy812;
	if(yych <= '9')	goto yy913;
	goto yy812;
yy1365:
	YYDEBUG(1365, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == 0x09)	goto yy781;
			if(yych <= ',')	goto yy783;
			goto yy794;
		} else {
			if(yych <= '.')	goto yy795;
			if(yych <= '/')	goto yy793;
			if(yych <= '5')	goto yy1335;
			goto yy1034;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy804;
			if(yych == 'n')	goto yy791;
			goto yy783;
		} else {
			if(yych <= 'r')	goto yy792;
			if(yych <= 's')	goto yy785;
			if(yych <= 't')	goto yy789;
			goto yy783;
		}
	}
yy1366:
	YYDEBUG(1366, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '9'){
		if(yych <= '-'){
			if(yych == 0x09)	goto yy1329;
			if(yych <= ',')	goto yy1331;
			goto yy794;
		} else {
			if(yych <= '.')	goto yy1333;
			if(yych <= '/')	goto yy793;
			if(yych <= '5')	goto yy1335;
			goto yy1034;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= ':')	goto yy1334;
			if(yych == 'n')	goto yy791;
			goto yy1331;
		} else {
			if(yych <= 'r')	goto yy792;
			if(yych <= 's')	goto yy785;
			if(yych <= 't')	goto yy789;
			goto yy1331;
		}
	}
yy1367:
	YYDEBUG(1367, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy1368;
yy1368:
	YYDEBUG(1368, *YYCURSOR);
	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy1369;
yy1369:
	YYDEBUG(1369, *YYCURSOR);
	if(yych <= '/')	goto yy1370;
	if(yych <= '9')	goto yy1368;
	goto yy1370;
yy1370:
	YYDEBUG(1370, *YYCURSOR);

{
		timelib_ull i;

		TIMELIB_INIT;
		TIMELIB_HAVE_RELATIVE();
		TIMELIB_UNHAVE_DATE();
		TIMELIB_UNHAVE_TIME();

		i = timelib_get_unsigned_nr((char **) &ptr, 24);
		s->time->y = 1970;
		s->time->m = 1;
		s->time->d = 1;
		s->time->h = s->time->i = s->time->s = 0;
		s->time->f = 0.0;
		s->time->relative.s += i;
		s->time->is_localtime = 1;
		s->time->zone_type = TIMELIB_ZONETYPE_OFFSET;
		s->time->z = 0;

		TIMELIB_DEINIT;
		return TIMELIB_RELATIVE;
	}
yy1371:
	YYDEBUG(1371, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy1411;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'n')	goto yy1411;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1372:
	YYDEBUG(1372, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'U'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'I')	goto yy1405;
			if(yych <= 'T')	goto yy138;
			goto yy1404;
		}
	} else {
		if(yych <= 'i'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			if(yych <= 'h')	goto yy138;
			goto yy1405;
		} else {
			if(yych == 'u')	goto yy1404;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1373:
	YYDEBUG(1373, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'D')	goto yy1393;
			if(yych <= 'L')	goto yy138;
			goto yy1394;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			if(yych <= 'c')	goto yy138;
			goto yy1393;
		} else {
			if(yych == 'm')	goto yy1394;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1374:
	YYDEBUG(1374, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy138;
			goto yy1389;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'e')	goto yy1389;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1375:
	YYDEBUG(1375, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy138;
			goto yy1385;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'e')	goto yy1385;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1376:
	YYDEBUG(1376, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/'){
		if(yych == '.')	goto yy1334;
		goto yy53;
	} else {
		if(yych <= '9')	goto yy1379;
		if(yych <= ':')	goto yy1334;
		goto yy53;
	}
yy1377:
	YYDEBUG(1377, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/'){
		if(yych == '.')	goto yy1334;
		goto yy53;
	} else {
		if(yych <= '3')	goto yy1379;
		if(yych == ':')	goto yy1334;
		goto yy53;
	}
yy1378:
	YYDEBUG(1378, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == '.')	goto yy1334;
	if(yych == ':')	goto yy1334;
	goto yy53;
yy1379:
	YYDEBUG(1379, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/'){
		if(yych == '.')	goto yy1334;
		goto yy53;
	} else {
		if(yych <= '5')	goto yy1380;
		if(yych == ':')	goto yy1334;
		goto yy53;
	}
yy1380:
	YYDEBUG(1380, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych >= ':')	goto yy53;
	goto yy1381;
yy1381:
	YYDEBUG(1381, *YYCURSOR);
	yyaccept = 21;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/')	goto yy1337;
	if(yych <= '5')	goto yy1382;
	if(yych <= '6')	goto yy1383;
	goto yy1337;
yy1382:
	YYDEBUG(1382, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= '/')	goto yy53;
	if(yych <= '9')	goto yy1384;
	goto yy53;
yy1383:
	YYDEBUG(1383, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych != '0')	goto yy53;
	goto yy1384;
yy1384:
	YYDEBUG(1384, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy1345;
yy1385:
	YYDEBUG(1385, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'L'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'K')	goto yy139;
			goto yy1386;
		}
	} else {
		if(yych <= 'k'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'l')	goto yy1386;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1386:
	YYDEBUG(1386, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'F'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'E')	goto yy140;
			goto yy1387;
		}
	} else {
		if(yych <= 'e'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'f')	goto yy1387;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1387:
	YYDEBUG(1387, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy141;
			goto yy1388;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 't')	goto yy1388;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy1388:
	YYDEBUG(1388, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'G'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'H')	goto yy167;
		if(yych == 'h')	goto yy167;
		goto yy3;
	}
yy1389:
	YYDEBUG(1389, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy417;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy417;
			if(yych <= 'R')	goto yy139;
			goto yy1390;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy417;
			goto yy139;
		} else {
			if(yych <= 's')	goto yy1390;
			if(yych <= 'z')	goto yy139;
			goto yy417;
		}
	}
yy1390:
	YYDEBUG(1390, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy140;
			goto yy1391;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'd')	goto yy1391;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1391:
	YYDEBUG(1391, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy1392;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy1392;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy1392:
	YYDEBUG(1392, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'Y')	goto yy423;
		if(yych == 'y')	goto yy423;
		goto yy3;
	}
yy1393:
	YYDEBUG(1393, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy1401;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy1401;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1394:
	YYDEBUG(1394, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'O'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy139;
			goto yy1395;
		}
	} else {
		if(yych <= 'n'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'o')	goto yy1395;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1395:
	YYDEBUG(1395, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy140;
			goto yy1396;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'r')	goto yy1396;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1396:
	YYDEBUG(1396, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy141;
			goto yy1397;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'r')	goto yy1397;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy1397:
	YYDEBUG(1397, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'O')	goto yy1398;
		if(yych != 'o')	goto yy3;
		goto yy1398;
	}
yy1398:
	YYDEBUG(1398, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy1399;
	if(yych != 'w')	goto yy53;
	goto yy1399;
yy1399:
	YYDEBUG(1399, *YYCURSOR);
	++YYCURSOR;
	goto yy1400;
yy1400:
	YYDEBUG(1400, *YYCURSOR);

{
		DEBUG_OUTPUT("tomorrow");
		TIMELIB_INIT;
		TIMELIB_HAVE_RELATIVE();
		TIMELIB_UNHAVE_TIME();

		s->time->relative.d = 1;
		TIMELIB_DEINIT;
		return TIMELIB_RELATIVE;
	}
yy1401:
	YYDEBUG(1401, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'X')	goto yy140;
			goto yy1402;
		}
	} else {
		if(yych <= 'x'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'y')	goto yy1402;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1402:
	YYDEBUG(1402, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '@'){
		if(yych == ')')	goto yy136;
		goto yy1403;
	} else {
		if(yych <= 'Z')	goto yy141;
		if(yych <= '`')	goto yy1403;
		if(yych <= 'z')	goto yy141;
		goto yy1403;
	}
yy1403:
	YYDEBUG(1403, *YYCURSOR);

{
		DEBUG_OUTPUT("midnight | today");
		TIMELIB_INIT;
		TIMELIB_UNHAVE_TIME();

		TIMELIB_DEINIT;
		return TIMELIB_RELATIVE;
	}
yy1404:
	YYDEBUG(1404, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy417;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy417;
			if(yych <= 'Q')	goto yy139;
			goto yy1407;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy417;
			goto yy139;
		} else {
			if(yych <= 'r')	goto yy1407;
			if(yych <= 'z')	goto yy139;
			goto yy417;
		}
	}
yy1405:
	YYDEBUG(1405, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= 'Q')	goto yy139;
			if(yych >= 'S')	goto yy333;
			goto yy1406;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'r')	goto yy1406;
			if(yych <= 's')	goto yy333;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1406:
	YYDEBUG(1406, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'd')	goto yy388;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1407:
	YYDEBUG(1407, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy140;
			goto yy1408;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 's')	goto yy1408;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1408:
	YYDEBUG(1408, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy141;
			goto yy1409;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'd')	goto yy1409;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy1409:
	YYDEBUG(1409, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'A')	goto yy1410;
		if(yych != 'a')	goto yy3;
		goto yy1410;
	}
yy1410:
	YYDEBUG(1410, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy423;
	if(yych == 'y')	goto yy423;
	goto yy53;
yy1411:
	YYDEBUG(1411, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy1412;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 't')	goto yy1412;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1412:
	YYDEBUG(1412, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'h')	goto yy388;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1413:
	YYDEBUG(1413, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy1411;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy1442;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy1414:
	YYDEBUG(1414, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'U'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= 'H'){
				if(yych <= '@')	goto yy3;
				goto yy138;
			} else {
				if(yych <= 'I')	goto yy1405;
				if(yych <= 'T')	goto yy138;
				goto yy1404;
			}
		}
	} else {
		if(yych <= 'h'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy138;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy143;
			}
		} else {
			if(yych <= 't'){
				if(yych <= 'i')	goto yy1436;
				goto yy143;
			} else {
				if(yych <= 'u')	goto yy1435;
				if(yych <= 'z')	goto yy143;
				goto yy3;
			}
		}
	}
yy1415:
	YYDEBUG(1415, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'M'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= 'C'){
				if(yych <= '@')	goto yy3;
				goto yy138;
			} else {
				if(yych <= 'D')	goto yy1393;
				if(yych <= 'L')	goto yy138;
				goto yy1394;
			}
		}
	} else {
		if(yych <= 'c'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy138;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy143;
			}
		} else {
			if(yych <= 'l'){
				if(yych <= 'd')	goto yy1426;
				goto yy143;
			} else {
				if(yych <= 'm')	goto yy1427;
				if(yych <= 'z')	goto yy143;
				goto yy3;
			}
		}
	}
yy1416:
	YYDEBUG(1416, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy138;
			goto yy1389;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy1422;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy1417:
	YYDEBUG(1417, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy138;
			goto yy1385;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy1418;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy1418:
	YYDEBUG(1418, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'L'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'K')	goto yy139;
			goto yy1386;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'l')	goto yy1419;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy1419:
	YYDEBUG(1419, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'F'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'E')	goto yy140;
			goto yy1387;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'f')	goto yy1420;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1420:
	YYDEBUG(1420, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy141;
			goto yy1388;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy1421;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy1421:
	YYDEBUG(1421, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'G')	goto yy3;
			goto yy167;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy253;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy1422:
	YYDEBUG(1422, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy417;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy417;
			if(yych <= 'R')	goto yy139;
			goto yy1390;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy417;
		} else {
			if(yych == 's')	goto yy1423;
			if(yych <= 'z')	goto yy148;
			goto yy417;
		}
	}
yy1423:
	YYDEBUG(1423, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy140;
			goto yy1391;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'd')	goto yy1424;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1424:
	YYDEBUG(1424, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy1392;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy1425;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy1425:
	YYDEBUG(1425, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Y'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'X')	goto yy3;
			goto yy423;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'y')	goto yy436;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy1426:
	YYDEBUG(1426, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy1401;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy1433;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy1427:
	YYDEBUG(1427, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'O'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'N')	goto yy139;
			goto yy1395;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'o')	goto yy1428;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy1428:
	YYDEBUG(1428, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy140;
			goto yy1396;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy1429;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1429:
	YYDEBUG(1429, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy141;
			goto yy1397;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy1430;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy1430:
	YYDEBUG(1430, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'O'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'N')	goto yy3;
			goto yy1398;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'o')	goto yy1431;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy1431:
	YYDEBUG(1431, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'W')	goto yy1399;
	if(yych != 'w')	goto yy152;
	goto yy1432;
yy1432:
	YYDEBUG(1432, *YYCURSOR);
	yyaccept = 23;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych == '/')	goto yy144;
		goto yy1400;
	} else {
		if(yych <= '_')	goto yy144;
		if(yych <= '`')	goto yy1400;
		if(yych <= 'z')	goto yy151;
		goto yy1400;
	}
yy1433:
	YYDEBUG(1433, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Y'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'X')	goto yy140;
			goto yy1402;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'y')	goto yy1434;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1434:
	YYDEBUG(1434, *YYCURSOR);
	yyaccept = 24;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy1403;
			goto yy136;
		} else {
			if(yych == '/')	goto yy144;
			goto yy1403;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '^')	goto yy1403;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy1403;
			if(yych <= 'z')	goto yy150;
			goto yy1403;
		}
	}
yy1435:
	YYDEBUG(1435, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy417;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy417;
			if(yych <= 'Q')	goto yy139;
			goto yy1407;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy417;
		} else {
			if(yych == 'r')	goto yy1438;
			if(yych <= 'z')	goto yy148;
			goto yy417;
		}
	}
yy1436:
	YYDEBUG(1436, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy139;
			if(yych <= 'R')	goto yy1406;
			goto yy333;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych <= 'r'){
				if(yych <= 'q')	goto yy148;
				goto yy1437;
			} else {
				if(yych <= 's')	goto yy357;
				if(yych <= 'z')	goto yy148;
				goto yy3;
			}
		}
	}
yy1437:
	YYDEBUG(1437, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'd')	goto yy406;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1438:
	YYDEBUG(1438, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy140;
			goto yy1408;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 's')	goto yy1439;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1439:
	YYDEBUG(1439, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy141;
			goto yy1409;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'd')	goto yy1440;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy1440:
	YYDEBUG(1440, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy1410;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy1441;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy1441:
	YYDEBUG(1441, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy423;
	if(yych == 'y')	goto yy436;
	goto yy152;
yy1442:
	YYDEBUG(1442, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy1412;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy1443;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy1443:
	YYDEBUG(1443, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy406;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1444:
	YYDEBUG(1444, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych <= '@'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych == 'R')	goto yy1456;
			if(yych <= 'X')	goto yy138;
			goto yy1457;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			if(yych <= 'q')	goto yy138;
			goto yy1456;
		} else {
			if(yych == 'y')	goto yy1457;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1445:
	YYDEBUG(1445, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy138;
			goto yy1450;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'd')	goto yy1450;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1446:
	YYDEBUG(1446, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy1447;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'n')	goto yy1447;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1447:
	YYDEBUG(1447, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'D'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy417;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy417;
			if(yych <= 'C')	goto yy139;
			goto yy1448;
		}
	} else {
		if(yych <= 'c'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy417;
			goto yy139;
		} else {
			if(yych <= 'd')	goto yy1448;
			if(yych <= 'z')	goto yy139;
			goto yy417;
		}
	}
yy1448:
	YYDEBUG(1448, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'A'){
		if(yych == ')')	goto yy136;
		if(yych <= '@')	goto yy3;
		goto yy1449;
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			goto yy3;
		} else {
			if(yych <= 'a')	goto yy1449;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1449:
	YYDEBUG(1449, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'Y'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'X')	goto yy141;
			goto yy644;
		}
	} else {
		if(yych <= 'x'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'y')	goto yy644;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy1450:
	YYDEBUG(1450, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy139;
			goto yy1451;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'n')	goto yy1451;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1451:
	YYDEBUG(1451, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'I'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'H')	goto yy140;
			goto yy1452;
		}
	} else {
		if(yych <= 'h'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'i')	goto yy1452;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1452:
	YYDEBUG(1452, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'G'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'F')	goto yy141;
			goto yy1453;
		}
	} else {
		if(yych <= 'f'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'g')	goto yy1453;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy1453:
	YYDEBUG(1453, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'G'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'H')	goto yy1454;
		if(yych != 'h')	goto yy3;
		goto yy1454;
	}
yy1454:
	YYDEBUG(1454, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1455;
	if(yych != 't')	goto yy53;
	goto yy1455;
yy1455:
	YYDEBUG(1455, *YYCURSOR);
	yych = *++YYCURSOR;
	goto yy1403;
yy1456:
	YYDEBUG(1456, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych == 'C')	goto yy1458;
				goto yy139;
			}
		} else {
			if(yych <= 'b'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'c')	goto yy1458;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy1457:
	YYDEBUG(1457, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '-'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy444;
			goto yy446;
		} else {
			if(yych == ')')	goto yy136;
			if(yych <= ',')	goto yy444;
			goto yy447;
		}
	} else {
		if(yych <= '@'){
			if(yych == '/')	goto yy444;
			if(yych <= '9')	goto yy446;
			goto yy444;
		} else {
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy444;
			if(yych <= 'z')	goto yy139;
			goto yy444;
		}
	}
yy1458:
	YYDEBUG(1458, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy702;
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'h')	goto yy702;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1459:
	YYDEBUG(1459, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Y'){
		if(yych <= '/'){
			if(yych == ')')	goto yy136;
			if(yych <= '.')	goto yy3;
			goto yy144;
		} else {
			if(yych <= 'Q'){
				if(yych <= '@')	goto yy3;
				goto yy138;
			} else {
				if(yych <= 'R')	goto yy1456;
				if(yych <= 'X')	goto yy138;
				goto yy1457;
			}
		}
	} else {
		if(yych <= 'q'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy138;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy143;
			}
		} else {
			if(yych <= 'x'){
				if(yych <= 'r')	goto yy1471;
				goto yy143;
			} else {
				if(yych <= 'y')	goto yy1472;
				if(yych <= 'z')	goto yy143;
				goto yy3;
			}
		}
	}
yy1460:
	YYDEBUG(1460, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'C')	goto yy138;
			goto yy1450;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'd')	goto yy1465;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy1461:
	YYDEBUG(1461, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy1447;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy1462;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy1462:
	YYDEBUG(1462, *YYCURSOR);
	yyaccept = 5;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy417;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy417;
			if(yych <= 'C')	goto yy139;
			goto yy1448;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy417;
		} else {
			if(yych == 'd')	goto yy1463;
			if(yych <= 'z')	goto yy148;
			goto yy417;
		}
	}
yy1463:
	YYDEBUG(1463, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'A'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			goto yy1449;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '^')	goto yy3;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy3;
			if(yych <= 'a')	goto yy1464;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1464:
	YYDEBUG(1464, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'Y'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'X')	goto yy141;
			goto yy644;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'y')	goto yy673;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy1465:
	YYDEBUG(1465, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy139;
			goto yy1451;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy1466;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy1466:
	YYDEBUG(1466, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'I'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'H')	goto yy140;
			goto yy1452;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'i')	goto yy1467;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1467:
	YYDEBUG(1467, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'G'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'F')	goto yy141;
			goto yy1453;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'g')	goto yy1468;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy1468:
	YYDEBUG(1468, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'G')	goto yy3;
			goto yy1454;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy1469;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy1469:
	YYDEBUG(1469, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'T')	goto yy1455;
	if(yych != 't')	goto yy152;
	goto yy1470;
yy1470:
	YYDEBUG(1470, *YYCURSOR);
	yyaccept = 24;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych == '/')	goto yy144;
		goto yy1403;
	} else {
		if(yych <= '_')	goto yy144;
		if(yych <= '`')	goto yy1403;
		if(yych <= 'z')	goto yy151;
		goto yy1403;
	}
yy1471:
	YYDEBUG(1471, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'B'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'C')	goto yy1458;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 'b'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'c')	goto yy1473;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy1472:
	YYDEBUG(1472, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '.'){
		if(yych <= ' '){
			if(yych == 0x09)	goto yy446;
			if(yych <= 0x1F)	goto yy444;
			goto yy446;
		} else {
			if(yych <= ')'){
				if(yych <= '(')	goto yy444;
				goto yy136;
			} else {
				if(yych <= ',')	goto yy444;
				if(yych <= '-')	goto yy447;
				goto yy446;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '/')	goto yy144;
			if(yych <= '9')	goto yy446;
			if(yych <= '@')	goto yy444;
			goto yy139;
		} else {
			if(yych <= '_'){
				if(yych <= '^')	goto yy444;
				goto yy144;
			} else {
				if(yych <= '`')	goto yy444;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy1473:
	YYDEBUG(1473, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy702;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy713;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1474:
	YYDEBUG(1474, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'W'){
		if(yych <= 'N'){
			if(yych == ')')	goto yy136;
			if(yych <= '@')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'O')	goto yy1482;
			if(yych <= 'U')	goto yy138;
			if(yych <= 'V')	goto yy1483;
			goto yy1480;
		}
	} else {
		if(yych <= 'o'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			if(yych <= 'n')	goto yy138;
			goto yy1482;
		} else {
			if(yych <= 'v'){
				if(yych <= 'u')	goto yy138;
				goto yy1483;
			} else {
				if(yych <= 'w')	goto yy1480;
				if(yych <= 'z')	goto yy138;
				goto yy3;
			}
		}
	}
yy1475:
	YYDEBUG(1475, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'X'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'W')	goto yy138;
			goto yy1479;
		}
	} else {
		if(yych <= 'w'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'x')	goto yy1479;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1476:
	YYDEBUG(1476, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy1477;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 'n')	goto yy1477;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1477:
	YYDEBUG(1477, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy1478;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 't')	goto yy1478;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1478:
	YYDEBUG(1478, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'H'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= 'g'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'h')	goto yy388;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1479:
	YYDEBUG(1479, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy333;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 't')	goto yy333;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1480:
	YYDEBUG(1480, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '@'){
		if(yych == ')')	goto yy136;
		goto yy1481;
	} else {
		if(yych <= 'Z')	goto yy139;
		if(yych <= '`')	goto yy1481;
		if(yych <= 'z')	goto yy139;
		goto yy1481;
	}
yy1481:
	YYDEBUG(1481, *YYCURSOR);

{
		DEBUG_OUTPUT("now");
		TIMELIB_INIT;

		TIMELIB_DEINIT;
		return TIMELIB_RELATIVE;
	}
yy1482:
	YYDEBUG(1482, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'N'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy139;
			goto yy1488;
		}
	} else {
		if(yych <= 'm'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 'n')	goto yy1488;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1483:
	YYDEBUG(1483, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '/'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= ','){
				if(yych <= ')')	goto yy136;
				goto yy444;
			} else {
				if(yych <= '-')	goto yy447;
				if(yych <= '.')	goto yy446;
				goto yy444;
			}
		}
	} else {
		if(yych <= 'Z'){
			if(yych <= '@'){
				if(yych <= '9')	goto yy446;
				goto yy444;
			} else {
				if(yych != 'E')	goto yy139;
				goto yy1484;
			}
		} else {
			if(yych <= 'd'){
				if(yych <= '`')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'e')	goto yy1484;
				if(yych <= 'z')	goto yy139;
				goto yy444;
			}
		}
	}
yy1484:
	YYDEBUG(1484, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'M'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'L')	goto yy140;
			goto yy1485;
		}
	} else {
		if(yych <= 'l'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'm')	goto yy1485;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1485:
	YYDEBUG(1485, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'B'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'A')	goto yy141;
			goto yy1486;
		}
	} else {
		if(yych <= 'a'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'b')	goto yy1486;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy1486:
	YYDEBUG(1486, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'E')	goto yy1487;
		if(yych != 'e')	goto yy3;
		goto yy1487;
	}
yy1487:
	YYDEBUG(1487, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy456;
	if(yych == 'r')	goto yy456;
	goto yy53;
yy1488:
	YYDEBUG(1488, *YYCURSOR);
	++YYCURSOR;
	if((yych = *YYCURSOR) <= '@'){
		if(yych == ')')	goto yy136;
		goto yy1489;
	} else {
		if(yych <= 'Z')	goto yy140;
		if(yych <= '`')	goto yy1489;
		if(yych <= 'z')	goto yy140;
		goto yy1489;
	}
yy1489:
	YYDEBUG(1489, *YYCURSOR);

{
		DEBUG_OUTPUT("noon");
		TIMELIB_INIT;
		TIMELIB_UNHAVE_TIME();
		TIMELIB_HAVE_TIME();
		s->time->h = 12;

		TIMELIB_DEINIT;
		return TIMELIB_RELATIVE;
	}
yy1490:
	YYDEBUG(1490, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'W'){
		if(yych <= '@'){
			if(yych <= ')'){
				if(yych <= '(')	goto yy3;
				goto yy136;
			} else {
				if(yych == '/')	goto yy144;
				goto yy3;
			}
		} else {
			if(yych <= 'O'){
				if(yych <= 'N')	goto yy138;
				goto yy1482;
			} else {
				if(yych <= 'U')	goto yy138;
				if(yych <= 'V')	goto yy1483;
				goto yy1480;
			}
		}
	} else {
		if(yych <= 'n'){
			if(yych <= '^'){
				if(yych <= 'Z')	goto yy138;
				goto yy3;
			} else {
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy3;
				goto yy143;
			}
		} else {
			if(yych <= 'v'){
				if(yych <= 'o')	goto yy1497;
				if(yych <= 'u')	goto yy143;
				goto yy1498;
			} else {
				if(yych <= 'w')	goto yy1496;
				if(yych <= 'z')	goto yy143;
				goto yy3;
			}
		}
	}
yy1491:
	YYDEBUG(1491, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'X'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'W')	goto yy138;
			goto yy1479;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'x')	goto yy1495;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy1492:
	YYDEBUG(1492, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy138;
			goto yy1477;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy1493;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy1493:
	YYDEBUG(1493, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy1478;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy1494;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy1494:
	YYDEBUG(1494, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'H'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'G')	goto yy140;
			goto yy388;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'h')	goto yy406;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1495:
	YYDEBUG(1495, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy333;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy357;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy1496:
	YYDEBUG(1496, *YYCURSOR);
	yyaccept = 25;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy1481;
			goto yy136;
		} else {
			if(yych == '/')	goto yy144;
			goto yy1481;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '^')	goto yy1481;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy1481;
			if(yych <= 'z')	goto yy148;
			goto yy1481;
		}
	}
yy1497:
	YYDEBUG(1497, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'N'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'M')	goto yy139;
			goto yy1488;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'n')	goto yy1503;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy1498:
	YYDEBUG(1498, *YYCURSOR);
	yyaccept = 6;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '9'){
		if(yych <= '('){
			if(yych <= 0x09){
				if(yych <= 0x08)	goto yy444;
				goto yy446;
			} else {
				if(yych == ' ')	goto yy446;
				goto yy444;
			}
		} else {
			if(yych <= '-'){
				if(yych <= ')')	goto yy136;
				if(yych <= ',')	goto yy444;
				goto yy447;
			} else {
				if(yych == '/')	goto yy144;
				goto yy446;
			}
		}
	} else {
		if(yych <= '^'){
			if(yych <= 'D'){
				if(yych <= '@')	goto yy444;
				goto yy139;
			} else {
				if(yych <= 'E')	goto yy1484;
				if(yych <= 'Z')	goto yy139;
				goto yy444;
			}
		} else {
			if(yych <= 'd'){
				if(yych <= '_')	goto yy144;
				if(yych <= '`')	goto yy444;
				goto yy148;
			} else {
				if(yych <= 'e')	goto yy1499;
				if(yych <= 'z')	goto yy148;
				goto yy444;
			}
		}
	}
yy1499:
	YYDEBUG(1499, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'M'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'L')	goto yy140;
			goto yy1485;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'm')	goto yy1500;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1500:
	YYDEBUG(1500, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'B'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'A')	goto yy141;
			goto yy1486;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'b')	goto yy1501;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy1501:
	YYDEBUG(1501, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'D')	goto yy3;
			goto yy1487;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy1502;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy1502:
	YYDEBUG(1502, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy456;
	if(yych == 'r')	goto yy626;
	goto yy152;
yy1503:
	YYDEBUG(1503, *YYCURSOR);
	yyaccept = 26;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '@'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy1489;
			goto yy136;
		} else {
			if(yych == '/')	goto yy144;
			goto yy1489;
		}
	} else {
		if(yych <= '_'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '^')	goto yy1489;
			goto yy144;
		} else {
			if(yych <= '`')	goto yy1489;
			if(yych <= 'z')	goto yy149;
			goto yy1489;
		}
	}
yy1504:
	YYDEBUG(1504, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'S'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy138;
			goto yy1505;
		}
	} else {
		if(yych <= 'r'){
			if(yych <= 'Z')	goto yy138;
			if(yych <= '`')	goto yy3;
			goto yy138;
		} else {
			if(yych <= 's')	goto yy1505;
			if(yych <= 'z')	goto yy138;
			goto yy3;
		}
	}
yy1505:
	YYDEBUG(1505, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'T'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy1506;
		}
	} else {
		if(yych <= 's'){
			if(yych <= 'Z')	goto yy139;
			if(yych <= '`')	goto yy3;
			goto yy139;
		} else {
			if(yych <= 't')	goto yy1506;
			if(yych <= 'z')	goto yy139;
			goto yy3;
		}
	}
yy1506:
	YYDEBUG(1506, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'E'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy140;
			goto yy1507;
		}
	} else {
		if(yych <= 'd'){
			if(yych <= 'Z')	goto yy140;
			if(yych <= '`')	goto yy3;
			goto yy140;
		} else {
			if(yych <= 'e')	goto yy1507;
			if(yych <= 'z')	goto yy140;
			goto yy3;
		}
	}
yy1507:
	YYDEBUG(1507, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych <= 'R'){
		if(yych <= ')'){
			if(yych <= '(')	goto yy3;
			goto yy136;
		} else {
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy141;
			goto yy1508;
		}
	} else {
		if(yych <= 'q'){
			if(yych <= 'Z')	goto yy141;
			if(yych <= '`')	goto yy3;
			goto yy141;
		} else {
			if(yych <= 'r')	goto yy1508;
			if(yych <= 'z')	goto yy141;
			goto yy3;
		}
	}
yy1508:
	YYDEBUG(1508, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'C'){
		if(yych == ')')	goto yy136;
		goto yy3;
	} else {
		if(yych <= 'D')	goto yy1509;
		if(yych != 'd')	goto yy3;
		goto yy1509;
	}
yy1509:
	YYDEBUG(1509, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1510;
	if(yych != 'a')	goto yy53;
	goto yy1510;
yy1510:
	YYDEBUG(1510, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy1511;
	if(yych != 'y')	goto yy53;
	goto yy1511;
yy1511:
	YYDEBUG(1511, *YYCURSOR);
	++YYCURSOR;
	goto yy1512;
yy1512:
	YYDEBUG(1512, *YYCURSOR);

{
		DEBUG_OUTPUT("yesterday");
		TIMELIB_INIT;
		TIMELIB_HAVE_RELATIVE();
		TIMELIB_UNHAVE_TIME();

		s->time->relative.d = -1;
		TIMELIB_DEINIT;
		return TIMELIB_RELATIVE;
	}
yy1513:
	YYDEBUG(1513, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'S'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'R')	goto yy138;
			goto yy1505;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy138;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 's')	goto yy1514;
			if(yych <= 'z')	goto yy143;
			goto yy3;
		}
	}
yy1514:
	YYDEBUG(1514, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'T'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'S')	goto yy139;
			goto yy1506;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy139;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 't')	goto yy1515;
			if(yych <= 'z')	goto yy148;
			goto yy3;
		}
	}
yy1515:
	YYDEBUG(1515, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'E'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'D')	goto yy140;
			goto yy1507;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy140;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'e')	goto yy1516;
			if(yych <= 'z')	goto yy149;
			goto yy3;
		}
	}
yy1516:
	YYDEBUG(1516, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'R'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= '@')	goto yy3;
			if(yych <= 'Q')	goto yy141;
			goto yy1508;
		}
	} else {
		if(yych <= '`'){
			if(yych <= 'Z')	goto yy141;
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'r')	goto yy1517;
			if(yych <= 'z')	goto yy150;
			goto yy3;
		}
	}
yy1517:
	YYDEBUG(1517, *YYCURSOR);
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= 'D'){
		if(yych <= '.'){
			if(yych == ')')	goto yy136;
			goto yy3;
		} else {
			if(yych <= '/')	goto yy144;
			if(yych <= 'C')	goto yy3;
			goto yy1509;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy144;
			goto yy3;
		} else {
			if(yych == 'd')	goto yy1518;
			if(yych <= 'z')	goto yy151;
			goto yy3;
		}
	}
yy1518:
	YYDEBUG(1518, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy1510;
	if(yych != 'a')	goto yy152;
	goto yy1519;
yy1519:
	YYDEBUG(1519, *YYCURSOR);
	yych = *++YYCURSOR;
	if(yych == 'Y')	goto yy1511;
	if(yych != 'y')	goto yy152;
	goto yy1520;
yy1520:
	YYDEBUG(1520, *YYCURSOR);
	yyaccept = 27;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= '^'){
		if(yych == '/')	goto yy144;
		goto yy1512;
	} else {
		if(yych <= '_')	goto yy144;
		if(yych <= '`')	goto yy1512;
		if(yych <= 'z')	goto yy151;
		goto yy1512;
	}
}
}

}

#define YYMAXFILL 29


timelib_time* timelib_strtotime(char *s, int len, struct timelib_error_container **errors, timelib_tzdb *tzdb)
{
	Scanner in;
	int t;
	char *e = s + len - 1;

	memset(&in, 0, sizeof(in));
	in.errors = malloc(sizeof(struct timelib_error_container));
	in.errors->warning_count = 0;
	in.errors->warning_messages = NULL;
	in.errors->error_count = 0;
	in.errors->error_messages = NULL;

	while (isspace(*s) && s < e) {
		s++;
	}
	while (isspace(*e) && e > s) {
		e--;
	}
	if (e - s < 1) {
		in.time = timelib_time_ctor();
		add_error(&in, "Empty string");
		if (errors) {
			*errors = in.errors;
		} else {
			timelib_error_container_dtor(in.errors);
		}
		in.time->y = in.time->d = in.time->m = in.time->h = in.time->i = in.time->s = in.time->f = in.time->z = in.time->dst = -1;
		in.time->is_localtime = in.time->zone_type = 0;
		return in.time;
	}
	e++;

	in.str = malloc((e - s) + YYMAXFILL);
	memset(in.str, 0, (e - s) + YYMAXFILL);
	memcpy(in.str, s, (e - s));
	in.lim = in.str + (e - s) + YYMAXFILL;
	in.cur = in.str;
	in.time = timelib_time_ctor();
	in.time->y = -1;
	in.time->d = -1;
	in.time->m = -1;
	in.time->h = -1;
	in.time->i = -1;
	in.time->s = -1;
	in.time->f = -1;
	in.time->z = -1;
	in.time->dst = -1;
	in.tzdb = tzdb;
	in.time->is_localtime = 0;
	in.time->zone_type = 0;

	do {
		t = scan(&in);
#ifdef DEBUG_PARSER
		printf("%d\n", t);
#endif
	} while(t != EOI);

	free(in.str);
	if (errors) {
		*errors = in.errors;
	} else {
		timelib_error_container_dtor(in.errors);
	}
	return in.time;
}

void timelib_fill_holes(timelib_time *parsed, timelib_time *now, int options)
{
	if (!(options && TIMELIB_OVERRIDE_TIME) && parsed->have_date && !parsed->have_time) {
		parsed->h = 0;
		parsed->i = 0;
		parsed->s = 0;
		parsed->f = 0;
	}
	if (parsed->y == -1) parsed->y = now->y != -1 ? now->y : 0;
	if (parsed->d == -1) parsed->d = now->d != -1 ? now->d : 0;
	if (parsed->m == -1) parsed->m = now->m != -1 ? now->m : 0;
	if (parsed->h == -1) parsed->h = now->h != -1 ? now->h : 0;
	if (parsed->i == -1) parsed->i = now->i != -1 ? now->i : 0;
	if (parsed->s == -1) parsed->s = now->s != -1 ? now->s : 0;
	if (parsed->f == -1) parsed->f = now->f != -1 ? now->f : 0;
	if (parsed->z == -1) parsed->z = now->z != -1 ? now->z : 0;
	if (parsed->dst == -1) parsed->dst = now->dst != -1 ? now->dst : 0;

	if (!parsed->tz_abbr) {
		parsed->tz_abbr = now->tz_abbr ? strdup(now->tz_abbr) : NULL;
	}
	if (!parsed->tz_info) {
		parsed->tz_info = now->tz_info ? timelib_tzinfo_clone(now->tz_info) : NULL;
	}
	if (parsed->zone_type == 0 && now->zone_type != 0) {
		parsed->zone_type = now->zone_type;
/*		parsed->tz_abbr = now->tz_abbr ? strdup(now->tz_abbr) : NULL;
		parsed->tz_info = now->tz_info ? timelib_tzinfo_clone(now->tz_info) : NULL;
*/		parsed->is_localtime = 1;
	}
/*	timelib_dump_date(parsed, 2);
	timelib_dump_date(now, 2);
*/
}

char *timelib_timezone_id_from_abbr(const char *abbr, long gmtoffset, int isdst)
{
	timelib_tz_lookup_table *tp;

	tp = zone_search(abbr, gmtoffset, isdst);
	if (tp) {
		return (tp->full_tz_name);
	} else {
		return NULL;
	}
}

timelib_tz_lookup_table *timelib_timezone_abbreviations_list(void)
{
	return timelib_timezone_lookup;
}

#ifdef DEBUG_PARSER_STUB
int main(void)
{
	timelib_time time = timelib_strtotime("May 12");

	printf ("%04d-%02d-%02d %02d:%02d:%02d.%-5d %+04d %1d",
		time.y, time.m, time.d, time.h, time.i, time.s, time.f, time.z, time.dst);
	if (time.have_relative) {
		printf ("%3dY %3dM %3dD / %3dH %3dM %3dS", 
			time.relative.y, time.relative.m, time.relative.d, time.relative.h, time.relative.i, time.relative.s);
	}
	if (time.have_weekday_relative) {
		printf (" / %d", time.relative.weekday);
	}
	if (time.have_weeknr_day) {
		printf(" / %dW%d", time.relative.weeknr_day.weeknr, time.relative.weeknr_day.dayofweek);
	}
	return 0;				
}
#endif

/*
 * vim: syntax=c
 */
